// This code conforms with the UFC specification version 2017.1.0
// and was automatically generated by FFC version 2017.1.0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
// 
// This code was generated with the following parameters:
// 
//   add_tabulate_tensor_timing:     False
//   convert_exceptions_to_warnings: False
//   cpp_optimize:                   True
//   cpp_optimize_flags:             '-O2'
//   epsilon:                        1e-14
//   error_control:                  False
//   form_postfix:                   True
//   format:                         'dolfin'
//   generate_dummy_tabulate_tensor: False
//   max_signature_length:           0
//   optimize:                       True
//   precision:                      None
//   quadrature_degree:              None
//   quadrature_rule:                None
//   representation:                 'auto'
//   split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    *values = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        *values += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values = 0.0;
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
      values[r] = dof_values;
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 3; r++)
    {
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[2];
    for (unsigned int r = 0; r < 2; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 3; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < num_derivatives; s++)
      {
        values[r*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 3; r++)
      {
        values[1] += coefficients0[r]*basisvalues[r];
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[2][1];
    for (unsigned int row = 0; row < 2; row++)
    {
      for (unsigned int col = 0; col < 1; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[2][2];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, -0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910317, 0.2886751345948129, -0.1666666666666667};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[3] = {0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[1] *= std::sqrt(3.0);
      
      // Table(s) of coefficients
      static const double coefficients0[3] = \
      {0.4714045207910316, 0.0, 0.3333333333333333};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[3][3] = \
      {{0.0, 0.0, 0.0},
      {4.89897948556635, 0.0, 0.0},
      {0.0, 0.0, 0.0}};
      
      static const double dmats1[3][3] = \
      {{0.0, 0.0, 0.0},
      {2.449489742783182, 0.0, 0.0},
      {4.242640687119285, 0.0, 0.0}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[2];
      for (unsigned int r = 0; r < 2; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[3][3] = \
      {{1.0, 0.0, 0.0},
      {0.0, 1.0, 0.0},
      {0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 3; t++)
        {
          for (unsigned int u = 0; u < 3; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 3; t++)
          {
            for (unsigned int u = 0; u < 3; u++)
            {
              for (unsigned int tu = 0; tu < 3; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 3; s++)
        {
          for (unsigned int t = 0; t < 3; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[num_derivatives + r] += transform[r][s]*derivatives[s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 6; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[4];
    for (unsigned int r = 0; r < 4; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 6; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 1:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 2:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[0];
        break;
      }
    case 3:
      {
        y[0] = coordinate_dofs[0];
      y[1] = coordinate_dofs[1];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 4:
      {
        y[0] = coordinate_dofs[2];
      y[1] = coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    case 5:
      {
        y[0] = coordinate_dofs[4];
      y[1] = coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return vals[1];
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[3] = coordinate_dofs[3];
    dof_coordinates[4] = coordinate_dofs[4];
    dof_coordinates[5] = coordinate_dofs[5];
    dof_coordinates[6] = coordinate_dofs[0];
    dof_coordinates[7] = coordinate_dofs[1];
    dof_coordinates[8] = coordinate_dofs[2];
    dof_coordinates[9] = coordinate_dofs[3];
    dof_coordinates[10] = coordinate_dofs[4];
    dof_coordinates[11] = coordinate_dofs[5];
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_0();
        break;
      }
    case 1:
      {
        return new forms_finite_element_0();
        break;
      }
    }
    
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return 2;
        break;
      }
    }
    
    return 0;
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  static void _evaluate_basis(std::size_t i,
                              double * values,
                              const double * x,
                              const double * coordinate_dofs,
                              int cell_orientation)
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Reset values
    values[0] = 0.0;
    values[1] = 0.0;
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.1695331725611232, 0.08417937871268441, -0.1166423687039607, 0.0, -0.1468200342221037, 0.07290148043997567, -0.1010152544552209};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.321678327423669, -0.134687005940295, 0.0972019739199675, 0.2605797108646138, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.07824607964359527, -0.1683587574253685, 0.349927106111882, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.165186168136479, 0.235702260395516, -0.2721655269759085, -0.1202675588605914, 0.1468200342221037, -0.224536559755125, 0.1767766952966371};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.2138443426239284, 0.06013377943029567, 0.03952847075210468, 0.1122682798775625, -0.1388959748759292};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268399, 0.1166423687039606, 0.0, 0.1468200342221035, 0.07290148043997532, 0.1010152544552209};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.01694077317947335, -0.02478650334959185, 0.03788072042070801};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.0782460796435952, -0.1683587574253685, -0.3499271061118823, 0.0, -0.06776309271789388, -0.1458029608799508, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.2434322477800737, -0.4040610178208844, -0.6220926330877909, 0.1202675588605912, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.1641497884897344};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.311046316543896, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.1695331725611226, 0.08417937871268413, 0.1166423687039613, 0.1603567451474546, 0.06776309271789377, 0.03207665139358953, -0.0757614408414161};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719485, 0.0, 0.1807015805810507, 0.0, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.3207134902949093, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.1458029608799512, -0.2020305089104418};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.2130032168075648, -0.2188663846529795, 0.194403947839935, 0.160356745147455, -0.1581138830084195, 0.1778796122735408, -0.1262690680690266};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.649572197684647, 0.0, -0.3194382824999709, -0.4123930494211602, 0.5714285714285701};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.1597191412499854, -0.4536323543632767, 0.3571428571428567};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {-1.198216475447763e-15, 3.999999999999998, 0.0, -0.6776309271789404, 1.807956714911395, -1.228617901860574e-15, 0.0, -0.586845597326966, -1.262690680690262, -1.443289932012704e-15};
      
      static const double coefficients1[10] = \
      {0.0, -1.453698272868564e-15, 0.0, 1.054092553389457, 1.166423687039608, -0.3367175148507357, 1.041547612244118, 0.6846531968814582, -0.5808377131175202, 0.2187044413199252};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {1.206661475141169e-15, 0.0, 4, 0.1304101327393259, -0.8417937871268411, 0.9331389496316876, 0.0, 0.112938487863157, -0.7290148043997552, -2.02030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.347760353971534, 0.336717514850738, 1.360827634879544, -0.2004459314343182, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0};
      
      static const double coefficients1[10] = \
      {4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.4123930494211613, -0.1428571428571428};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.355261854357878, -1.714774156003074e-15, -1.082901129878522e-15, 0.0, 1.17369119465393, 0.0, 0.0};
      
      static const double coefficients1[10] = \
      {0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, -1.787822277374285e-15, -2.083095224488239, 0.5868455973269636, -0.101015254455223, 1.693090112553364e-15};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 1.742312891184206e-15, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.45802960879951, 0.0};
      
      static const double coefficients1[10] = \
      {2.29065365473691e-15, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.788516320127402, 0.0, -1.129384878631566, 0.7290148043997554, -0.2525381361380525};
      
      // Compute value(s)
      for (unsigned int r = 0; r < 10; r++)
      {
        values[0] += coefficients0[r]*basisvalues[r];
        values[1] += coefficients1[r]*basisvalues[r];
      } // end loop over 'r'
      
      // Using covariant Piola transform to map values back to the physical element
      const double tmp_ref0 = values[0];
      const double tmp_ref1 = values[1];
      values[0] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
      values[1] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
        break;
      }
    }
    
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation) const final override
  {
    _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_all(double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation)
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {0.0, 0.0};
    
    // Loop dofs and call evaluate_basis
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2; s++)
      {
        values[r*2 + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation) const final override
  {
    _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives(std::size_t i,
                                          std::size_t n,
                                          double * values,
                                          const double * x,
                                          const double * coordinate_dofs,
                                          int cell_orientation)
  {
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Reset values. Assuming that values is always an array.
    for (unsigned int r = 0; r < 2*num_derivatives; r++)
    {
      values[r] = 0.0;
    } // end loop over 'r'
    
    // Call evaluate_basis if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
    return ;
    }
    
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    
    // Get coordinates and map to the reference (FIAT) element
    double X = (J[1]*(C1 - 2.0*x[1]) + J[3]*(2.0*x[0] - C0)) / detJ;
    double Y = (J[0]*(2.0*x[1] - C1) + J[2]*(C0 - 2.0*x[0])) / detJ;
    
    // Declare two dimensional array that holds combinations of derivatives and initialise
    unsigned int combinations[8][3];
    for (unsigned int row = 0; row < 8; row++)
    {
      for (unsigned int col = 0; col < 3; col++)
        combinations[row][col] = 0;
    }
    
    // Generate combinations of derivatives
    for (unsigned int row = 1; row < num_derivatives; row++)
    {
      for (unsigned int num = 0; num < row; num++)
      {
        for (unsigned int col = n-1; col+1 > 0; col--)
        {
          if (combinations[row][col] + 1 > 1)
            combinations[row][col] = 0;
          else
          {
            combinations[row][col] += 1;
            break;
          }
        }
      }
    }
    
    // Compute inverse of Jacobian
    const double Jinv[2][2] = {{K[0], K[1]}, {K[2], K[3]}};
    
    // Declare transformation matrix
    // Declare pointer to two dimensional array and initialise
    double transform[8][8];
    for (unsigned int j = 0; j < num_derivatives; j++)
    {
      for (unsigned int k = 0; k < num_derivatives; k++)
        transform[j][k] = 1;
    }
    
    // Construct transformation matrix
    for (unsigned int row = 0; row < num_derivatives; row++)
    {
      for (unsigned int col = 0; col < num_derivatives; col++)
      {
        for (unsigned int k = 0; k < n; k++)
          transform[row][col] *= Jinv[combinations[col][k]][combinations[row][k]];
      }
    }
    switch (i)
    {
    case 0:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.1695331725611232, 0.08417937871268441, -0.1166423687039607, 0.0, -0.1468200342221037, 0.07290148043997567, -0.1010152544552209};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.321678327423669, -0.134687005940295, 0.0972019739199675, 0.2605797108646138, -0.1298792610426301, 0.0976879837895675, -0.06313453403451336};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 1:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.07824607964359527, -0.1683587574253685, 0.349927106111882, 0.0, 0.06776309271789396, -0.1458029608799511, 0.3030457633656629};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.165186168136479, 0.235702260395516, -0.2721655269759085, -0.1202675588605914, 0.1468200342221037, -0.224536559755125, 0.1767766952966371};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 2:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.03912303982179773, -0.08417937871268394, -0.3499271061118824, 0.0, -0.03388154635894701, -0.07290148043997546, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.06085806194501873, 0.0, 0.2138443426239284, 0.06013377943029567, 0.03952847075210468, 0.1122682798775625, -0.1388959748759292};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 3:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.169533172561123, 0.08417937871268399, 0.1166423687039606, 0.0, 0.1468200342221035, 0.07290148043997532, 0.1010152544552209};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.4912114999847917, 0.2188663846529791, 0.2138443426239279, -0.2605797108646135, 0.01694077317947335, -0.02478650334959185, 0.03788072042070801};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 4:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.0782460796435952, -0.1683587574253685, -0.3499271061118823, 0.0, -0.06776309271789388, -0.1458029608799508, -0.303045763365663};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.2434322477800737, -0.4040610178208844, -0.6220926330877909, 0.1202675588605912, 0.0790569415042094, 0.07873359887517382, -0.1262690680690266};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 5:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.03912303982179742, -0.08417937871268397, 0.3499271061118822, 0.0, 0.03388154635894683, -0.07290148043997549, 0.3030457633656628};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.09998110176681553, -0.08417937871268397, 0.5637714487358108, -0.0601337794302957, 0.07341001711105188, -0.185169760317538, 0.1641497884897344};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 6:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686871, 0.3030457633656633, 0.311046316543896, 0.0, -0.09035079029052537, -0.1458029608799509, -0.202030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.1695331725611226, 0.08417937871268413, 0.1166423687039613, 0.1603567451474546, 0.06776309271789377, 0.03207665139358953, -0.0757614408414161};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 7:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719485, 0.0, 0.1807015805810507, 0.0, 0.1010152544552208};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.3825363893686872, 0.06734350297014793, -0.07776157913597449, -0.3207134902949093, 0.09035079029052553, -0.06415330278717903, 0.05050762722761083};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 8:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.3825363893686873, -0.3030457633656635, 0.3110463165438966, 0.0, -0.09035079029052526, 0.1458029608799512, -0.2020305089104418};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.2130032168075648, -0.2188663846529795, 0.194403947839935, 0.160356745147455, -0.1581138830084195, 0.1778796122735408, -0.1262690680690266};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 9:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {3.999999999999999, 0.0, 0.0, -0.3688555567816608, -0.4761904761904753, -1.649572197684647, 0.0, -0.3194382824999709, -0.4123930494211602, 0.5714285714285701};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, 0.6147592613027624, 0.476190476190476, -0.5498573992282138, 0.5669467095138394, 0.1597191412499854, -0.4536323543632767, 0.3571428571428567};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 10:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {-1.198216475447763e-15, 3.999999999999998, 0.0, -0.6776309271789404, 1.807956714911395, -1.228617901860574e-15, 0.0, -0.586845597326966, -1.262690680690262, -1.443289932012704e-15};
      
      static const double coefficients1[10] = \
      {0.0, -1.453698272868564e-15, 0.0, 1.054092553389457, 1.166423687039608, -0.3367175148507357, 1.041547612244118, 0.6846531968814582, -0.5808377131175202, 0.2187044413199252};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 11:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {1.206661475141169e-15, 0.0, 4, 0.1304101327393259, -0.8417937871268411, 0.9331389496316876, 0.0, 0.112938487863157, -0.7290148043997552, -2.02030508910442};
      
      static const double coefficients1[10] = \
      {0.0, 0.0, 0.0, -0.347760353971534, 0.336717514850738, 1.360827634879544, -0.2004459314343182, 0.6211616832473614, 0.5977921396077999, -0.8838834764831855};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 12:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 0.0, 0.9523809523809517, 0.0, 0.0, 0.0, 0.8247860988423221, 0.0};
      
      static const double coefficients1[10] = \
      {4.000000000000001, 0.0, 0.0, -1.598374079387188, 0.4761904761904756, -0.5498573992282171, 0.0, -0.6388765649999406, 0.4123930494211613, -0.1428571428571428};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 13:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 0.0, 0.0, 1.355261854357878, -1.714774156003074e-15, -1.082901129878522e-15, 0.0, 1.17369119465393, 0.0, 0.0};
      
      static const double coefficients1[10] = \
      {0.0, 3.999999999999997, 0.0, 0.6776309271789397, -0.5248906591678214, -1.787822277374285e-15, -2.083095224488239, 0.5868455973269636, -0.101015254455223, 1.693090112553364e-15};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    case 14:
      {
        
      // Array of basisvalues
      double basisvalues[10] = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
      
      // Declare helper variables
      double tmp0 = (1.0 + Y + 2.0*X)/2.0;
      double tmp1 = (1.0 - Y)/2.0;
      double tmp2 = tmp1*tmp1;
      
      // Compute basisvalues
      basisvalues[0] = 1.0;
      basisvalues[1] = tmp0;
      basisvalues[3] = basisvalues[1]*1.5*tmp0 - basisvalues[0]*0.5*tmp2;
      basisvalues[6] = basisvalues[3]*1.666666666666667*tmp0 - basisvalues[1]*0.6666666666666666*tmp2;
      basisvalues[2] = basisvalues[0]*(0.5 + 1.5*Y);
      basisvalues[4] = basisvalues[1]*(1.5 + 2.5*Y);
      basisvalues[7] = basisvalues[3]*(2.5 + 3.5*Y);
      basisvalues[5] = basisvalues[2]*(0.1111111111111111 + Y*1.666666666666667) - basisvalues[0]*0.5555555555555556;
      basisvalues[9] = basisvalues[5]*(0.05 + Y*1.75) - basisvalues[2]*0.7;
      basisvalues[8] = basisvalues[4]*(0.54 + Y*2.1) - basisvalues[1]*0.5600000000000001;
      basisvalues[0] *= std::sqrt(0.5);
      basisvalues[2] *= std::sqrt(1.0);
      basisvalues[5] *= std::sqrt(1.5);
      basisvalues[9] *= std::sqrt(2.0);
      basisvalues[1] *= std::sqrt(3.0);
      basisvalues[4] *= std::sqrt(4.5);
      basisvalues[8] *= std::sqrt(6.0);
      basisvalues[3] *= std::sqrt(7.5);
      basisvalues[7] *= std::sqrt(10.0);
      basisvalues[6] *= std::sqrt(14.0);
      
      // Table(s) of coefficients
      static const double coefficients0[10] = \
      {0.0, 1.742312891184206e-15, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.45802960879951, 0.0};
      
      static const double coefficients1[10] = \
      {2.29065365473691e-15, 0.0, 3.999999999999999, 0.8259308406823943, 0.8417937871268409, -1.788516320127402, 0.0, -1.129384878631566, 0.7290148043997554, -0.2525381361380525};
      
      // Tables of derivatives of the polynomial base (transpose).
      static const double dmats0[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.89897948556635, 2.753172783350728e-15, 0.0, 0.0, -1.110223024625157e-15, 0.0, 0.0, 0.0, 0.0, 2.220446049250313e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.04962861157947e-15, 9.486832980505149, -1.569115208136889e-15, 0.0, -1.110223024625157e-15, 3.250888398770507e-15, -1.051012949804829e-15, 0.0, -1.77635683940025e-15, 0.0},
      {3.999999999999994, 0.0, 7.071067811865469, 0.0, 0.0, 1.77635683940025e-15, 0.0, 2.0710725351256e-15, 0.0, 3.552713678800501e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {5.291502622129189, -4.61061686781004e-14, -2.993325909419156, 13.66260102127946, 6.716849298982197e-15, 0.6110100926607791, 1.264792451016662e-15, 1.092663855699144e-15, 1.675447497537781e-15, 5.773159728050814e-15},
      {5.329070518200751e-15, 4.381780460041337, 7.993605777301127e-15, 0.0, 12.52198067399883, 7.993605777301127e-15, 0.0, 0.0, 5.329070518200751e-15, 5.329070518200751e-15},
      {3.464101615137755, -1.705912536821895e-15, 7.838367176906181, 0.0, 1.27675647831893e-15, 8.400000000000009, 0.0, 0.0, 0.0, 5.329070518200751e-15},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}};
      
      static const double dmats1[10][10] = \
      {{0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {2.449489742783182, 1.376586391675364e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {4.242640687119286, 2.74129760682974e-15, 0.0, 0.0, 0.0, 0.0, 0.0, 1.110426471346974e-15, 0.0, 1.332267629550188e-15},
      {2.581988897471623, 4.743416490252576, -0.9128709291752806, 0.0, -1.887379141862766e-15, 1.443289932012704e-15, 0.0, 0.0, 0.0, 1.221245327087672e-15},
      {1.999999999999916, 6.12372435695794, 3.535533905932735, -1.556152502729364e-15, 0.0, 2.664535259100376e-15, 0.0, 1.57122995957928e-15, -1.368919091296009e-15, 2.664535259100376e-15},
      {-2.309401076758493, -3.829666370077199e-15, 8.164965809277271, -1.028877616283535e-15, 2.109423746787797e-15, 2.664535259100376e-15, -1.314047835843942e-15, 1.979118206281541e-15, 0.0, 2.664535259100376e-15},
      {2.645751311064573, 5.184592558726255, -1.496662954709565, 6.831300510639725, -1.058300524425832, 0.3055050463303882, 0.0, 0.0, 0.0, 2.997602166487923e-15},
      {2.236067977499824, 2.190890230020676, 2.529822128134686, 8.082903768654772, 6.260990336999409, -1.80739222823012, 2.045646071896159e-15, -1.368746386073583e-15, 6.849482400163546e-15, 1.998401444325282e-15},
      {1.732050807568877, -5.091168824543145, 3.919183588453093, 0.0, 9.699484522385696, 4.200000000000006, 0.0, 0.0, 3.885780586188048e-15, 4.440892098500626e-15},
      {5.000000000000025, 1.836667035643843e-15, -2.828427124746229, 1.003903975583009e-15, -1.332267629550188e-15, 12.12435565298216, 0.0, -2.061282886822577e-15, 0.0, 2.664535259100376e-15}};
      
      // Compute reference derivatives.
      // Declare array of derivatives on FIAT element.
      double derivatives[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives[r] = 0.0;
      } // end loop over 'r'
      
      // Declare array of reference derivatives on physical element.
      double derivatives_p[16];
      for (unsigned int r = 0; r < 16; r++)
      {
        derivatives_p[r] = 0.0;
      } // end loop over 'r'
      
      // Declare derivative matrix (of polynomial basis).
      double dmats[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Declare (auxiliary) derivative matrix (of polynomial basis).
      double dmats_old[10][10] = \
      {{1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0},
      {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0}};
      
      // Loop possible derivatives.
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        // Resetting dmats values to compute next derivative.
        for (unsigned int t = 0; t < 10; t++)
        {
          for (unsigned int u = 0; u < 10; u++)
          {
            dmats[t][u] = 0.0;
            if (t == u)
            {
            dmats[t][u] = 1.0;
            }
            
          } // end loop over 'u'
        } // end loop over 't'
        
        // Looping derivative order to generate dmats.
        for (unsigned int s = 0; s < n; s++)
        {
          // Updating dmats_old with new values and resetting dmats.
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              dmats_old[t][u] = dmats[t][u];
              dmats[t][u] = 0.0;
            } // end loop over 'u'
          } // end loop over 't'
          
          // Update dmats using an inner product.
          if (combinations[r][s] == 0)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats0[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
          if (combinations[r][s] == 1)
          {
          for (unsigned int t = 0; t < 10; t++)
          {
            for (unsigned int u = 0; u < 10; u++)
            {
              for (unsigned int tu = 0; tu < 10; tu++)
              {
                dmats[t][u] += dmats1[t][tu]*dmats_old[tu][u];
              } // end loop over 'tu'
            } // end loop over 'u'
          } // end loop over 't'
          }
          
        } // end loop over 's'
        for (unsigned int s = 0; s < 10; s++)
        {
          for (unsigned int t = 0; t < 10; t++)
          {
            derivatives[r] += coefficients0[s]*dmats[s][t]*basisvalues[t];
            derivatives[num_derivatives + r] += coefficients1[s]*dmats[s][t]*basisvalues[t];
          } // end loop over 't'
        } // end loop over 's'
        
        // Using covariant Piola transform to map values back to the physical element
        const double tmp_ref0 = derivatives[r];
        const double tmp_ref1 = derivatives[num_derivatives + r];
        derivatives_p[r] = (K[0]*tmp_ref0 + K[2]*tmp_ref1);
        derivatives_p[num_derivatives + r] = (K[1]*tmp_ref0 + K[3]*tmp_ref1);
      } // end loop over 'r'
      
      // Transform derivatives back to physical element
      for (unsigned int r = 0; r < num_derivatives; r++)
      {
        for (unsigned int s = 0; s < num_derivatives; s++)
        {
          values[r] += transform[r][s]*derivatives_p[s];
          values[num_derivatives + r] += transform[r][s]*derivatives_p[num_derivatives + s];
        } // end loop over 's'
      } // end loop over 'r'
        break;
      }
    }
    
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation) const final override
  {
    _evaluate_basis_derivatives(i, n, values, x, coordinate_dofs, cell_orientation);
  }

  static void _evaluate_basis_derivatives_all(std::size_t n,
                                              double * values,
                                              const double * x,
                                              const double * coordinate_dofs,
                                              int cell_orientation)
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
      _evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
      return ;
    }
    
    // Compute number of derivatives.
    unsigned int num_derivatives = 1;
    for (unsigned int r = 0; r < n; r++)
    {
      num_derivatives *= 2;
    } // end loop over 'r'
    
    // Set values equal to zero.
    for (unsigned int r = 0; r < 15; r++)
    {
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = 0.0;
      } // end loop over 's'
    } // end loop over 'r'
    
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
    {
      return ;
    }
    
    // Helper variable to hold values of a single dof.
    double dof_values[16];
    for (unsigned int r = 0; r < 16; r++)
    {
      dof_values[r] = 0.0;
    } // end loop over 'r'
    
    // Loop dofs and call evaluate_basis_derivatives.
    for (unsigned int r = 0; r < 15; r++)
    {
      _evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
      for (unsigned int s = 0; s < 2*num_derivatives; s++)
      {
        values[r*2*num_derivatives + s] = dof_values[s];
      } // end loop over 's'
    } // end loop over 'r'
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation) const final override
  {
    _evaluate_basis_derivatives_all(n, values, x, coordinate_dofs, cell_orientation);
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
      {
        y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 1:
      {
        y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 2:
      {
        y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 3:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 4:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 5:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
      f.evaluate(vals, y, c);
      return (J[1]*vals[0] + J[3]*vals[1]);
        break;
      }
    case 6:
      {
        y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
      y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 7:
      {
        y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
      y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 8:
      {
        y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
      y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
      f.evaluate(vals, y, c);
      return (J[0]*vals[0] + J[2]*vals[1]);
        break;
      }
    case 9:
      {
        result = 0.0;
      double X_9[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_9[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_9[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
      double copy_9[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_9[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_9[D_9[r][s]]*W_9[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 10:
      {
        result = 0.0;
      double X_10[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_10[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_10[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
      double copy_10[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_10[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_10[D_10[r][s]]*W_10[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 11:
      {
        result = 0.0;
      double X_11[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_11[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
      double W_11[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
      double copy_11[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_11[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_11[D_11[r][s]]*W_11[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 12:
      {
        result = 0.0;
      double X_12[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_12[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_12[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
      double copy_12[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_12[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_12[D_12[r][s]]*W_12[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 13:
      {
        result = 0.0;
      double X_13[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_13[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_13[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
      double copy_13[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_13[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_13[D_13[r][s]]*W_13[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    case 14:
      {
        result = 0.0;
      double X_14[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
      int D_14[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
      double W_14[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
      double copy_14[2];
      // Loop over points
      for (unsigned int r = 0; r < 36; r++)
      {
        // Evaluate basis functions for affine mapping
        const double w0 = 1.0 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        
        // Compute affine mapping y = F(X)
        y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
        y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = J[0]*vals[0] + J[2]*vals[1];
        copy_14[1] = J[1]*vals[0] + J[3]*vals[1];
        // Loop over directions
        for (unsigned int s = 0; s < 1; s++)
        {
          result += copy_14[D_14[r][s]]*W_14[r][s];
        } // end loop over 's'
      } // end loop over 'r'
      return result;
        break;
      }
    }
    
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    
    // Declare variable for physical coordinates
    double y[2];
    
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75*coordinate_dofs[2] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[3] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.5*coordinate_dofs[2] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[3] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.25*coordinate_dofs[2] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[3] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = (-1.0)*(J[0]*vals[0] + J[2]*vals[1]) + (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[4];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[4];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[4];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = (J[1]*vals[0] + J[3]*vals[1]);
    y[0] = 0.75*coordinate_dofs[0] + 0.25*coordinate_dofs[2];
    y[1] = 0.75*coordinate_dofs[1] + 0.25*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = (J[0]*vals[0] + J[2]*vals[1]);
    y[0] = 0.5*coordinate_dofs[0] + 0.5*coordinate_dofs[2];
    y[1] = 0.5*coordinate_dofs[1] + 0.5*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = (J[0]*vals[0] + J[2]*vals[1]);
    y[0] = 0.25*coordinate_dofs[0] + 0.75*coordinate_dofs[2];
    y[1] = 0.25*coordinate_dofs[1] + 0.75*coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = (J[0]*vals[0] + J[2]*vals[1]);
    result = 0.0;
    double X_9[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_9[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_9[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
    double copy_9[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_9[r][0] - X_9[r][1];
      const double w1 = X_9[r][0];
      const double w2 = X_9[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_9[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_9[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_9[D_9[r][s]]*W_9[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[9] = result;
    result = 0.0;
    double X_10[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_10[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_10[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
    double copy_10[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_10[r][0] - X_10[r][1];
      const double w1 = X_10[r][0];
      const double w2 = X_10[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_10[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_10[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_10[D_10[r][s]]*W_10[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[10] = result;
    result = 0.0;
    double X_11[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_11[36][1] = {{0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}, {0}};
    double W_11[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
    double copy_11[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_11[r][0] - X_11[r][1];
      const double w1 = X_11[r][0];
      const double w2 = X_11[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_11[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_11[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_11[D_11[r][s]]*W_11[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[11] = result;
    result = 0.0;
    double X_12[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_12[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_12[36][1] = {{0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.0119624829871}, {0.0224231420448}, {0.023291672331}, {0.0163217665744}, {0.00727161547759}, {0.00144559962225}, {0.00922307258049}, {0.0172882391377}, {0.0179578758575}, {0.0125840795694}, {0.0056064144375}, {0.00111455709092}, {0.00438000703533}, {0.00821012828325}, {0.00852813657368}, {0.00597613827346}, {0.00266246789938}, {0.000529299521057}};
    double copy_12[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_12[r][0] - X_12[r][1];
      const double w1 = X_12[r][0];
      const double w2 = X_12[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_12[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_12[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_12[D_12[r][s]]*W_12[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[12] = result;
    result = 0.0;
    double X_13[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_13[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_13[36][1] = {{-0.00971097319453}, {-0.0159756941744}, {-0.0129148084988}, {-0.00602410954055}, {-0.00140335236045}, {-8.83197279225e-05}, {-0.014499997977}, {-0.0238542037517}, {-0.0192838239128}, {-0.0089949353583}, {-0.00209542400951}, {-0.000131875132445}, {-0.00678703358623}, {-0.0111654692844}, {-0.00902620543637}, {-0.00421027151037}, {-0.000980807938907}, {-6.17269708946e-05}, {0.00678703358623}, {0.0111654692844}, {0.00902620543637}, {0.00421027151037}, {0.000980807938907}, {6.17269708946e-05}, {0.014499997977}, {0.0238542037517}, {0.0192838239128}, {0.0089949353583}, {0.00209542400951}, {0.000131875132445}, {0.00971097319453}, {0.0159756941744}, {0.0129148084988}, {0.00602410954055}, {0.00140335236045}, {8.83197279225e-05}};
    double copy_13[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_13[r][0] - X_13[r][1];
      const double w1 = X_13[r][0];
      const double w2 = X_13[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_13[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_13[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_13[D_13[r][s]]*W_13[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[13] = result;
    result = 0.0;
    double X_14[36][2] = {{0.0327753666145, 0.0293164271598}, {0.0287653330126, 0.148078599668}, {0.022386872978, 0.336984690281}, {0.0149015633667, 0.558671518772}, {0.00779187470129, 0.76923386203}, {0.00246669715267, 0.92694567132}, {0.164429241595, 0.0293164271598}, {0.14431148695, 0.148078599668}, {0.112311681781, 0.336984690281}, {0.0747589734626, 0.558671518772}, {0.0390907007328, 0.76923386203}, {0.0123750604174, 0.92694567132}, {0.369529924372, 0.0293164271598}, {0.324318304589, 0.148078599668}, {0.252403568077, 0.336984690281}, {0.168009519121, 0.558671518772}, {0.087850454976, 0.76923386203}, {0.0278110821154, 0.92694567132}, {0.601153648468, 0.0293164271598}, {0.527603095743, 0.148078599668}, {0.410611741642, 0.336984690281}, {0.273318962107, 0.558671518772}, {0.142915682994, 0.76923386203}, {0.0452432465649, 0.92694567132}, {0.806254331245, 0.0293164271598}, {0.707609913381, 0.148078599668}, {0.550703627938, 0.336984690281}, {0.366569507766, 0.558671518772}, {0.191675437237, 0.76923386203}, {0.0606792682628, 0.92694567132}, {0.937908206226, 0.0293164271598}, {0.823156067319, 0.148078599668}, {0.640628436741, 0.336984690281}, {0.426426917862, 0.558671518772}, {0.222974263269, 0.76923386203}, {0.0705876315276, 0.92694567132}};
    int D_14[36][1] = {{1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}, {1}};
    double W_14[36][1] = {{-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.015429623211}, {-0.0176239005959}, {0.0003608205091}, {0.0156040814239}, {0.0134479025608}, {0.00364071931307}, {-0.0118962371707}, {-0.0135880247038}, {0.000278192558146}, {0.0120307444265}, {0.010368330848}, {0.00280699404177}, {-0.0056494841656}, {-0.00645290853773}, {0.000132112736967}, {0.00571336122195}, {0.00492388644484}, {0.00133303229957}};
    double copy_14[2];
    // Loop over points
    for (unsigned int r = 0; r < 36; r++)
    {
      // Evaluate basis functions for affine mapping
      const double w0 = 1.0 - X_14[r][0] - X_14[r][1];
      const double w1 = X_14[r][0];
      const double w2 = X_14[r][1];
      
      // Compute affine mapping y = F(X)
      y[0] = w0*coordinate_dofs[0] + w1*coordinate_dofs[2] + w2*coordinate_dofs[4];
      y[1] = w0*coordinate_dofs[1] + w1*coordinate_dofs[3] + w2*coordinate_dofs[5];
      // Evaluate function at physical point
      f.evaluate(vals, y, c);
      // Map function to reference element
      copy_14[0] = J[0]*vals[0] + J[2]*vals[1];
      copy_14[1] = J[1]*vals[0] + J[3]*vals[1];
      // Loop over directions
      for (unsigned int s = 0; s < 1; s++)
      {
        result += copy_14[D_14[r][s]]*W_14[r][s];
      } // end loop over 's'
    } // end loop over 'r'
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::cell& c) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    
    
    // Compute Jacobian inverse and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3]*K[2]*3.0 + dof_values[4]*(K[2]*(-3.0)) + dof_values[5]*K[2] + dof_values[6]*K[0]*3.0 + dof_values[7]*(K[0]*(-3.0)) + dof_values[8]*K[0] + dof_values[9]*(K[0]*(-2.99760216649e-15) + K[2]*(-1.88737914186e-15)) + dof_values[10]*(K[0]*(8.70245834404e-15) + K[2]*(1.66533453694e-15)) + dof_values[11]*(K[0]*(4.4408920985e-15)) + dof_values[12]*(K[0]*(-1.31995384584e-15) + K[2]*(-2.58126853225e-15)) + dof_values[13]*(K[0]*(-7.60618524276e-15) + K[2]*(7.45883834406e-15)) + dof_values[14]*(K[0]*(-9.1172980658e-15) + K[2]*(1.44328993201e-15));
    vertex_values[2] = dof_values[0]*K[2]*3.0 + dof_values[1]*(K[2]*(-3.0)) + dof_values[2]*K[2]*1.0 + dof_values[4]*(K[0]*(1.27675647832e-15) + K[2]*(3.13638004457e-15)) + dof_values[5]*(K[0]*(-1.11022302463e-15) + K[2]*(-4.38538094727e-15)) + dof_values[6]*(K[0] + K[2]) + dof_values[7]*(K[0]*(-3.0) + K[2]*(-3.0)) + dof_values[8]*(K[0]*3.0 + K[2]*3.0) + dof_values[9]*(K[0]*(-5.44009282066e-15) + K[2]*(-8.54871728961e-15)) + dof_values[10]*(K[0]*(-4.62021795146e-15) + K[2]*(-1.29896093881e-14)) + dof_values[11]*(K[0]*(-4.88498130835e-15) + K[2]*(-2.6645352591e-15)) + dof_values[12]*(K[2]*(1.63757896132e-15)) + dof_values[13]*(K[0]*(-5.64029739014e-15) + K[2]*(-8.25081745439e-15)) + dof_values[14]*(K[0]*(6.42582427895e-15) + K[2]*(1.56541446472e-14));
    vertex_values[4] = dof_values[0]*(K[0]*(-1.0)) + dof_values[1]*(K[0]*3.0 + K[2]*(1.66533453694e-15)) + dof_values[2]*(K[0]*(-3.0)) + dof_values[3]*(K[0]*1.0 + K[2]) + dof_values[4]*(K[0]*(-3.0) + K[2]*(-3.0)) + dof_values[5]*(K[0]*3.0 + K[2]*3.0) + dof_values[6]*(K[0]*(2.22044604925e-15)) + dof_values[7]*(K[0]*(-4.55191440096e-15)) + dof_values[8]*(K[0]*(5.77315972805e-15)) + dof_values[9]*(K[0]*(-1.33226762955e-14) + K[2]*(2.22044604925e-15)) + dof_values[10]*(K[0]*(-1.39210614745e-14) + K[2]*(-4.66293670343e-15)) + dof_values[11]*(K[0]*(8.881784197e-15) + K[2]*(-4.4408920985e-15)) + dof_values[12]*(K[0]*(6.22531835578e-15) + K[2]*(-4.32986979604e-15)) + dof_values[13]*(K[0]*(-3.82742091067e-15) + K[2]*(2.26749681492e-15)) + dof_values[14]*(K[0]*(2.0470210698e-15) + K[2]*(-4.88498130835e-15));
    vertex_values[1] = dof_values[3]*K[3]*3.0 + dof_values[4]*(K[3]*(-3.0)) + dof_values[5]*K[3] + dof_values[6]*K[1]*3.0 + dof_values[7]*(K[1]*(-3.0)) + dof_values[8]*K[1] + dof_values[9]*(K[1]*(-2.99760216649e-15) + K[3]*(-1.88737914186e-15)) + dof_values[10]*(K[1]*(8.70245834404e-15) + K[3]*(1.66533453694e-15)) + dof_values[11]*(K[1]*(4.4408920985e-15)) + dof_values[12]*(K[1]*(-1.31995384584e-15) + K[3]*(-2.58126853225e-15)) + dof_values[13]*(K[1]*(-7.60618524276e-15) + K[3]*(7.45883834406e-15)) + dof_values[14]*(K[1]*(-9.1172980658e-15) + K[3]*(1.44328993201e-15));
    vertex_values[3] = dof_values[0]*K[3]*3.0 + dof_values[1]*(K[3]*(-3.0)) + dof_values[2]*K[3]*1.0 + dof_values[4]*(K[1]*(1.27675647832e-15) + K[3]*(3.13638004457e-15)) + dof_values[5]*(K[1]*(-1.11022302463e-15) + K[3]*(-4.38538094727e-15)) + dof_values[6]*(K[1] + K[3]) + dof_values[7]*(K[1]*(-3.0) + K[3]*(-3.0)) + dof_values[8]*(K[1]*3.0 + K[3]*3.0) + dof_values[9]*(K[1]*(-5.44009282066e-15) + K[3]*(-8.54871728961e-15)) + dof_values[10]*(K[1]*(-4.62021795146e-15) + K[3]*(-1.29896093881e-14)) + dof_values[11]*(K[1]*(-4.88498130835e-15) + K[3]*(-2.6645352591e-15)) + dof_values[12]*(K[3]*(1.63757896132e-15)) + dof_values[13]*(K[1]*(-5.64029739014e-15) + K[3]*(-8.25081745439e-15)) + dof_values[14]*(K[1]*(6.42582427895e-15) + K[3]*(1.56541446472e-14));
    vertex_values[5] = dof_values[0]*(K[1]*(-1.0)) + dof_values[1]*(K[1]*3.0 + K[3]*(1.66533453694e-15)) + dof_values[2]*(K[1]*(-3.0)) + dof_values[3]*(K[1]*1.0 + K[3]) + dof_values[4]*(K[1]*(-3.0) + K[3]*(-3.0)) + dof_values[5]*(K[1]*3.0 + K[3]*3.0) + dof_values[6]*(K[1]*(2.22044604925e-15)) + dof_values[7]*(K[1]*(-4.55191440096e-15)) + dof_values[8]*(K[1]*(5.77315972805e-15)) + dof_values[9]*(K[1]*(-1.33226762955e-14) + K[3]*(2.22044604925e-15)) + dof_values[10]*(K[1]*(-1.39210614745e-14) + K[3]*(-4.66293670343e-15)) + dof_values[11]*(K[1]*(8.881784197e-15) + K[3]*(-4.4408920985e-15)) + dof_values[12]*(K[1]*(6.22531835578e-15) + K[3]*(-4.32986979604e-15)) + dof_values[13]*(K[1]*(-3.82742091067e-15) + K[3]*(2.26749681492e-15)) + dof_values[14]*(K[1]*(2.0470210698e-15) + K[3]*(-4.88498130835e-15));
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return 0;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 1;
        break;
      }
    case 1:
      {
        return 2;
        break;
      }
    case 2:
      {
        return 3;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return true;
        break;
      }
    case 1:
      {
        return false;
        break;
      }
    case 2:
      {
        return false;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2*num_global_entities[0];
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 0;
        break;
      }
    case 2:
      {
        return 0;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 2;
        break;
      }
    case 1:
      {
        return 4;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    unsigned int offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 1;
      dofs[1] = 2;
      dofs[2] = 4;
      dofs[3] = 5;
        break;
      }
    case 1:
      {
        dofs[0] = 0;
      dofs[1] = 2;
      dofs[2] = 3;
      dofs[3] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 3;
      dofs[3] = 4;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        
        break;
      }
    case 2:
      {
        
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 3;
          break;
        }
      case 1:
        {
          dofs[0] = 1;
        dofs[1] = 4;
          break;
        }
      case 2:
        {
          dofs[0] = 2;
        dofs[1] = 5;
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
          break;
        }
      case 1:
        {
          dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_0();
        break;
      }
    case 1:
      {
        return new forms_dofmap_0();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return false;
        break;
      }
    case 1:
      {
        return true;
        break;
      }
    case 2:
      {
        return true;
        break;
      }
    }
    
    return false;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3*num_global_entities[1] + 6*num_global_entities[2];
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 0;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 6;
        break;
      }
    }
    
    return 0;
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    switch (d)
    {
    case 0:
      {
        return 0;
        break;
      }
    case 1:
      {
        return 3;
        break;
      }
    case 2:
      {
        return 15;
        break;
      }
    }
    
    return 0;
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    unsigned int offset = 0;
    dofs[0] = offset + 3*entity_indices[1][0];
    dofs[1] = offset + 3*entity_indices[1][0] + 1;
    dofs[2] = offset + 3*entity_indices[1][0] + 2;
    dofs[3] = offset + 3*entity_indices[1][1];
    dofs[4] = offset + 3*entity_indices[1][1] + 1;
    dofs[5] = offset + 3*entity_indices[1][1] + 2;
    dofs[6] = offset + 3*entity_indices[1][2];
    dofs[7] = offset + 3*entity_indices[1][2] + 1;
    dofs[8] = offset + 3*entity_indices[1][2] + 2;
    offset += 3*num_global_entities[1];
    dofs[9] = offset + 6*entity_indices[2][0];
    dofs[10] = offset + 6*entity_indices[2][0] + 1;
    dofs[11] = offset + 6*entity_indices[2][0] + 2;
    dofs[12] = offset + 6*entity_indices[2][0] + 3;
    dofs[13] = offset + 6*entity_indices[2][0] + 4;
    dofs[14] = offset + 6*entity_indices[2][0] + 5;
    offset += 6*num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
      {
        dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
        break;
      }
    case 1:
      {
        dofs[0] = 3;
      dofs[1] = 4;
      dofs[2] = 5;
        break;
      }
    case 2:
      {
        dofs[0] = 6;
      dofs[1] = 7;
      dofs[2] = 8;
        break;
      }
    }
    
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 9;
      dofs[1] = 10;
      dofs[2] = 11;
      dofs[3] = 12;
      dofs[4] = 13;
      dofs[5] = 14;
        break;
      }
    }
    
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    if (d > 2)
    {
    throw std::runtime_error("d is larger than dimension (2)");
    }
    
    switch (d)
    {
    case 0:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          
          break;
        }
      case 1:
        {
          
          break;
        }
      case 2:
        {
          
          break;
        }
      }
      
        break;
      }
    case 1:
      {
        if (i > 2)
      {
      throw std::runtime_error("i is larger than number of entities (2)");
      }
      
      switch (i)
      {
      case 0:
        {
          dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
          break;
        }
      case 1:
        {
          dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
          break;
        }
      case 2:
        {
          dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
          break;
        }
      }
      
        break;
      }
    case 2:
      {
        if (i > 0)
      {
      throw std::runtime_error("i is larger than number of entities (0)");
      }
      
      dofs[0] = 0;
      dofs[1] = 1;
      dofs[2] = 2;
      dofs[3] = 3;
      dofs[4] = 4;
      dofs[5] = 5;
      dofs[6] = 6;
      dofs[7] = 7;
      dofs[8] = 8;
      dofs[9] = 9;
      dofs[10] = 10;
      dofs[11] = 11;
      dofs[12] = 12;
      dofs[13] = 13;
      dofs[14] = 14;
        break;
      }
    }
    
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return 0;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 4
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 4
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           4
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333347 * sp[33] + 0.3583333333333403 * sp[34] + -0.6083333333333348 * sp[28] + -0.608333333333329 * sp[31] + 0.3583333333333403 * sp[34] + 0.8583333333333483 * sp[35] + -1.875000000000023 * sp[29] + -0.6083333333333397 * sp[32] + -0.6083333333333348 * sp[28] + -1.875000000000023 * sp[29] + 6.191666666666694 * sp[26] + 1.691666666666663 * sp[27] + -0.608333333333329 * sp[31] + -0.6083333333333397 * sp[32] + 1.691666666666663 * sp[27] + 0.6333333333333291 * sp[30];
    A[1] = -2.016666666666673 * sp[33] + 1.116666666666664 * sp[34] + -0.6166666666666692 * sp[28] + -0.6166666666666804 * sp[31] + 0.2833333333333339 * sp[34] + -0.8000000000000103 * sp[35] + 1.0 * sp[29] + -0.6166666666666807 * sp[32] + 0.2166666666666656 * sp[28] + 1.666666666666685 * sp[29] + -3.466666666666688 * sp[26] + 2.783333333333351 * sp[27] + 0.2166666666666593 * sp[31] + 0.2166666666666741 * sp[32] + -0.7166666666666668 * sp[27] + 0.8166666666666623 * sp[30];
    A[2] = -0.03333333333332916 * sp[33] + -0.8916666666666657 * sp[34] + -0.1916666666666679 * sp[28] + -0.1916666666666637 * sp[31] + 0.4416666666666709 * sp[34] + 1.275000000000009 * sp[35] + -0.7916666666666765 * sp[29] + -0.1916666666666619 * sp[32] + -0.1916666666666685 * sp[28] + -0.7916666666666725 * sp[29] + 1.275000000000009 * sp[26] + -0.8916666666666733 * sp[27] + -0.1916666666666696 * sp[31] + -0.1916666666666731 * sp[32] + 0.4416666666666692 * sp[27] + -0.03333333333332877 * sp[30];
    A[3] = -1.591666666666677 * sp[33] + -0.6500000000000061 * sp[34] + -2.28333333333335 * sp[28] + -0.6500000000000127 * sp[31] + -0.9416666666666769 * sp[34] + -1.295833333333348 * sp[35] + -0.112500000000004 * sp[29] + -0.4666666666666739 * sp[32] + 0.6916666666666684 * sp[28] + 1.520833333333348 * sp[29] + -1.095833333333332 * sp[26] + -0.2666666666666587 * sp[27] + 0.6916666666666678 * sp[31] + 0.6916666666666722 * sp[32] + 0.6916666666666669 * sp[27] + 0.5083333333333385 * sp[30];
    A[4] = -0.06666666666666266 * sp[33] + -0.5333333333333306 * sp[34] + -0.09999999999999098 * sp[28] + -0.5333333333333307 * sp[31] + 0.8833333333333411 * sp[34] + 1.675000000000012 * sp[35] + 0.1416666666666681 * sp[29] + 0.9333333333333305 * sp[32] + -0.3833333333333338 * sp[28] + -0.9583333333333403 * sp[29] + 0.4416666666666673 * sp[26] + -0.133333333333332 * sp[27] + -0.3833333333333384 * sp[31] + -0.3833333333333411 * sp[32] + -0.383333333333338 * sp[27] + -0.6000000000000051 * sp[30];
    A[5] = -1.008333333333333 * sp[33] + 1.183333333333333 * sp[34] + -2.116666666666671 * sp[28] + 1.183333333333333 * sp[31] + 0.1416666666666675 * sp[34] + -0.837500000000007 * sp[35] + 0.5125000000000047 * sp[29] + -0.4666666666666676 * sp[32] + 0.1083333333333307 * sp[28] + 1.145833333333343 * sp[29] + -0.6375000000000097 * sp[26] + 0.40000000000001 * sp[27] + 0.1083333333333287 * sp[31] + 0.1083333333333392 * sp[32] + 0.1083333333333248 * sp[27] + 0.09166666666667571 * sp[30];
    A[6] = -1.091666666666674 * sp[33] + -1.108333333333342 * sp[34] + -1.108333333333335 * sp[28] + -1.108333333333336 * sp[31] + -0.7333333333333441 * sp[34] + -0.3624999999999955 * sp[35] + -1.479166666666684 * sp[29] + -1.108333333333341 * sp[32] + 2.133333333333345 * sp[28] + 1.154166666666652 * sp[29] + 3.170833333333344 * sp[26] + 2.191666666666666 * sp[27] + 1.149999999999999 * sp[31] + 1.116666666666661 * sp[32] + 1.149999999999999 * sp[27] + 1.008333333333332 * sp[30];
    A[7] = 2.600000000000012 * sp[33] + 1.216666666666668 * sp[34] + 1.216666666666667 * sp[28] + 1.216666666666664 * sp[31] + 1.466666666666686 * sp[34] + 0.3083333333333405 * sp[35] + 2.375000000000028 * sp[29] + 1.216666666666679 * sp[32] + -4.933333333333356 * sp[28] + -1.058333333333326 * sp[29] + -7.258333333333363 * sp[26] + -3.383333333333328 * sp[27] + -2.133333333333325 * sp[31] + -0.8999999999999939 * sp[32] + -2.133333333333328 * sp[27] + -1.266666666666658 * sp[30];
    A[8] = -1.50833333333334 * sp[33] + 0.3083333333333479 * sp[34] + 0.3083333333333363 * sp[28] + 0.3083333333333468 * sp[31] + -0.7333333333333422 * sp[34] + 0.7625000000000104 * sp[35] + -1.187500000000014 * sp[29] + 0.3083333333333421 * sp[32] + 2.80000000000001 * sp[28] + -2.887500000000012 * sp[29] + 4.295833333333356 * sp[26] + -1.391666666666683 * sp[27] + 0.9833333333333261 * sp[31] + -0.7166666666666609 * sp[32] + 0.9833333333333314 * sp[27] + -0.4083333333333338 * sp[30];
    A[9] = 1.649915822768648 * sp[33] + 0.4714045207910273 * sp[34] + -5.185449728701356 * sp[28] + -5.185449728701383 * sp[31] + 3.064129385141741 * sp[34] + 1.767766952966346 * sp[35] + -3.889087296526053 * sp[29] + -5.185449728701424 * sp[32] + -1.649915822768629 * sp[28] + 5.06759859850361 * sp[29] + 10.72445284799599 * sp[26] + 17.44196726926821 * sp[27] + -1.649915822768631 * sp[31] + -0.2357022603955496 * sp[32] + 4.006938426723752 * sp[27] + 5.892556509887863 * sp[30];
    A[10] = 10.96965511460293 * sp[33] + 0.7216878364869752 * sp[34] + -10.5366424127107 * sp[28] + -10.53664241271074 * sp[31] + 0.1443375672973413 * sp[34] + -1.732050807568894 * sp[35] + -8.660254037844483 * sp[29] + -10.53664241271079 * sp[32] + 0.7216878364870857 * sp[28] + 11.54700538379247 * sp[29] + 18.47520861406806 * sp[26] + 29.30052616137358 * sp[27] + 0.7216878364870798 * sp[31] + 5.051814855409184 * sp[32] + 7.649891066762525 * sp[27] + 10.96965511460285 * sp[30];
    A[11] = -6.833333333333346 * sp[33] + 1.583333333333338 * sp[34] + 0.08333333333333037 * sp[28] + 0.0833333333333437 * sp[31] + 2.416666666666682 * sp[34] + 3.75 * sp[35] + -1.250000000000009 * sp[29] + 0.08333333333338611 * sp[32] + 0.08333333333332001 * sp[28] + -4.916666666666647 * sp[29] + -5.916666666666699 * sp[26] + -10.91666666666671 * sp[27] + 0.08333333333330037 * sp[31] + 0.5833333333333779 * sp[32] + -0.9166666666666465 * sp[27] + -1.833333333333291 * sp[30];
    A[12] = 5.892556509887893 * sp[33] + -1.649915822768612 * sp[34] + 16.73486048808169 * sp[28] + 4.006938426723798 * sp[31] + -3.299831645537247 * sp[34] + -2.474873734152921 * sp[35] + 3.181980515339517 * sp[29] + 4.006938426723848 * sp[32] + 0.4714045207910404 * sp[28] + -2.003469213361917 * sp[29] + -7.660323462854288 * sp[26] + -10.13519719700728 * sp[27] + 0.4714045207910685 * sp[31] + 0.4714045207910328 * sp[32] + -5.185449728701313 * sp[27] + -4.006938426723792 * sp[30];
    A[13] = -16.88749537379666 * sp[33] + -7.361215932167781 * sp[34] + -7.361215932167801 * sp[28] + 3.897114317029952 * sp[31] + -5.196152422706692 * sp[34] + -6.278684177437289 * sp[35] + 4.979646071760496 * sp[29] + 3.897114317029932 * sp[32] + 5.196152422706645 * sp[28] + 11.90784930203617 * sp[29] + -21.8671414455571 * sp[26] + -15.15544456622756 * sp[27] + 5.196152422706618 * sp[31] + 5.196152422706667 * sp[32] + -1.732050807568854 * sp[27] + -3.897114317029886 * sp[30];
    A[14] = 10.41666666666666 * sp[33] + -2.916666666666671 * sp[34] + 10.08333333333334 * sp[28] + -1.416666666666686 * sp[31] + -5.83333333333338 * sp[34] + -4.375000000000007 * sp[35] + -2.875000000000028 * sp[29] + -1.416666666666758 * sp[32] + 0.8333333333333597 * sp[28] + -3.541666666666717 * sp[29] + 7.958333333333405 * sp[26] + 3.583333333333325 * sp[27] + 0.833333333333401 * sp[31] + 0.8333333333333373 * sp[32] + 1.833333333333368 * sp[27] + 2.916666666666643 * sp[30];
    A[15] = -2.016666666666673 * sp[33] + 0.2833333333333339 * sp[34] + 0.2166666666666656 * sp[28] + 0.2166666666666593 * sp[31] + 1.116666666666664 * sp[34] + -0.8000000000000103 * sp[35] + 1.666666666666685 * sp[29] + 0.2166666666666741 * sp[32] + -0.6166666666666692 * sp[28] + 1.0 * sp[29] + -3.466666666666688 * sp[26] + -0.7166666666666668 * sp[27] + -0.6166666666666804 * sp[31] + -0.6166666666666807 * sp[32] + 2.783333333333351 * sp[27] + 0.8166666666666623 * sp[30];
    A[16] = 2.533333333333342 * sp[33] + -1.73333333333334 * sp[34] + 0.7333333333333394 * sp[28] + 0.7333333333333495 * sp[31] + -1.73333333333334 * sp[34] + 2.766666666666676 * sp[35] + -2.166666666666679 * sp[29] + 0.733333333333347 * sp[32] + 0.7333333333333394 * sp[28] + -2.166666666666679 * sp[29] + 2.766666666666684 * sp[26] + -1.733333333333343 * sp[27] + 0.7333333333333495 * sp[31] + 0.733333333333347 * sp[32] + -1.733333333333343 * sp[27] + 2.533333333333348 * sp[30];
    A[17] = 0.8166666666666679 * sp[33] + 2.783333333333347 * sp[34] + -0.6166666666666732 * sp[28] + -0.6166666666666744 * sp[31] + -0.716666666666673 * sp[34] + -3.466666666666688 * sp[35] + 1.0 * sp[29] + -0.6166666666666745 * sp[32] + 0.2166666666666703 * sp[28] + 1.66666666666668 * sp[29] + -0.8000000000000094 * sp[26] + 1.116666666666668 * sp[27] + 0.2166666666666709 * sp[31] + 0.216666666666671 * sp[32] + 0.2833333333333339 * sp[27] + -2.016666666666679 * sp[30];
    A[18] = -0.06666666666666884 * sp[33] + -0.950000000000004 * sp[34] + 0.3166666666666714 * sp[28] + -0.949999999999996 * sp[31] + 0.4666666666666792 * sp[34] + 1.258333333333353 * sp[35] + -0.1083333333333333 * sp[29] + 0.6833333333333421 * sp[32] + 0.03333333333332944 * sp[28] + -0.7083333333333474 * sp[29] + 0.8583333333333331 * sp[26] + 0.1166666666666587 * sp[27] + 0.03333333333333344 * sp[31] + 0.03333333333333757 * sp[32] + 0.03333333333333249 * sp[27] + -0.1833333333333357 * sp[30];
    A[19] = 1.63333333333334 * sp[33] + 3.066666666666682 * sp[34] + 1.199999999999994 * sp[28] + 3.066666666666673 * sp[31] + -1.433333333333346 * sp[34] + -3.683333333333361 * sp[35] + -0.283333333333331 * sp[29] + -2.533333333333331 * sp[32] + 0.4333333333333392 * sp[28] + 1.58333333333335 * sp[29] + -0.216666666666666 * sp[26] + 0.9333333333333433 * sp[27] + 0.4333333333333441 * sp[31] + 0.4333333333333397 * sp[32] + 0.4333333333333446 * sp[27] + 1.200000000000019 * sp[30];
    A[20] = 1.266666666666667 * sp[33] + -2.116666666666677 * sp[34] + 2.483333333333341 * sp[28] + -2.116666666666676 * sp[31] + -0.8666666666666685 * sp[34] + 3.008333333333344 * sp[35] + -2.025000000000011 * sp[29] + 1.849999999999995 * sp[32] + 0.3666666666666698 * sp[28] + -1.958333333333343 * sp[29] + 1.275000000000012 * sp[26] + -1.050000000000009 * sp[27] + 0.366666666666673 * sp[31] + 0.3666666666666709 * sp[32] + 0.3666666666666765 * sp[27] + -1.016666666666666 * sp[30];
    A[21] = 0.1833333333333397 * sp[33] + -0.03333333333332378 * sp[34] + -0.03333333333333929 * sp[28] + -0.03333333333333585 * sp[31] + -0.1166666666666611 * sp[34] + -0.8583333333333498 * sp[35] + 0.7083333333333544 * sp[29] + -0.03333333333332811 * sp[32] + -0.6833333333333431 * sp[28] + 0.1083333333333386 * sp[29] + -1.258333333333347 * sp[26] + -0.4666666666666703 * sp[27] + 0.9500000000000037 * sp[31] + -0.3166666666666879 * sp[32] + 0.9500000000000044 * sp[27] + 0.0666666666666586 * sp[30];
    A[22] = -1.200000000000006 * sp[33] + -0.4333333333333302 * sp[34] + -0.4333333333333311 * sp[28] + -0.4333333333333266 * sp[31] + -0.9333333333333437 * sp[34] + 0.2166666666666575 * sp[35] + -1.58333333333336 * sp[29] + -0.4333333333333468 * sp[32] + 2.53333333333335 * sp[28] + 0.2833333333333323 * sp[29] + 3.68333333333336 * sp[26] + 1.433333333333335 * sp[27] + -3.066666666666685 * sp[31] + -1.199999999999991 * sp[32] + -3.066666666666686 * sp[27] + -1.633333333333326 * sp[30];
    A[23] = 1.016666666666668 * sp[33] + -0.366666666666687 * sp[34] + -0.3666666666666703 * sp[28] + -0.3666666666666815 * sp[31] + 1.050000000000004 * sp[34] + -1.275000000000009 * sp[35] + 1.958333333333347 * sp[29] + -0.3666666666666726 * sp[32] + -1.850000000000007 * sp[28] + 2.025000000000006 * sp[29] + -3.008333333333353 * sp[26] + 0.8666666666666748 * sp[27] + 2.116666666666682 * sp[31] + -2.483333333333345 * sp[32] + 2.11666666666668 * sp[27] + -1.266666666666679 * sp[30];
    A[24] = 3.77123616632826 * sp[33] + 6.128258770283455 * sp[34] + 3.299831645537228 * sp[28] + 3.299831645537251 * sp[31] + -3.771236166328295 * sp[34] + 1.178511301977608 * sp[35] + -1.64991582276857 * sp[29] + 3.299831645537293 * sp[32] + 0.9428090415820849 * sp[28] + -5.421151989096847 * sp[29] + -2.592724864350695 * sp[26] + -8.956685895029631 * sp[27] + 0.9428090415820771 * sp[31] + 12.25651754056689 * sp[32] + 3.771236166328277 * sp[27] + 11.78511301977581 * sp[30];
    A[25] = -8.948929172439174 * sp[33] + -1.443375672973963 * sp[34] + 3.752776749732562 * sp[28] + 3.752776749732618 * sp[31] + -3.175426480542823 * sp[34] + 2.020725942163682 * sp[35] + -1.443375672973955 * sp[29] + 3.75277674973267 * sp[32] + 1.443375672974014 * sp[28] + -7.216878364870303 * sp[29] + -3.752776749732616 * sp[26] + -12.41303078757702 * sp[27] + 1.443375672973947 * sp[31] + 10.10362971081836 * sp[32] + 4.907477288111845 * sp[27] + 14.14508159514585 * sp[30];
    A[26] = 11.1666666666667 * sp[33] + 1.833333333333356 * sp[34] + -5.166666666666718 * sp[28] + -5.166666666666707 * sp[31] + -8.166666666666712 * sp[34] + -16.66666666666674 * sp[35] + 3.333333333333383 * sp[29] + -5.166666666666746 * sp[32] + 3.166666666666703 * sp[28] + 10.66666666666669 * sp[29] + 2.666666666666668 * sp[26] + 10.16666666666669 * sp[27] + 3.166666666666733 * sp[31] + -7.833333333333411 * sp[32] + -4.833333333333391 * sp[27] + -17.16666666666675 * sp[30];
    A[27] = -11.78511301977583 * sp[33] + -3.771236166328274 * sp[34] + -12.25651754056684 * sp[28] + -0.9428090415820516 * sp[31] + 8.956685895029656 * sp[34] + 2.592724864350725 * sp[35] + 5.421151989096832 * sp[29] + -0.94280904158212 * sp[32] + -3.299831645537257 * sp[28] + 1.6499158227686 * sp[29] + -1.178511301977575 * sp[26] + 3.771236166328311 * sp[27] + -3.299831645537294 * sp[31] + -3.29983164553728 * sp[32] + -6.128258770283498 * sp[27] + -3.771236166328309 * sp[30];
    A[28] = 7.794228634059997 * sp[33] + 1.732050807568885 * sp[34] + 1.732050807568896 * sp[28] + -3.464101615137759 * sp[31] + -2.598076211353287 * sp[34] + -0.4330127018921264 * sp[35] + -5.629165124598781 * sp[29] + -3.464101615137685 * sp[32] + 2.598076211353324 * sp[28] + -2.165063509461184 * sp[29] + 13.42339375865884 * sp[26] + 8.660254037844336 * sp[27] + 2.598076211353373 * sp[31] + 2.598076211353395 * sp[32] + -0.8660254037845139 * sp[27] + -5.196152422706581 * sp[30];
    A[29] = -20.83333333333339 * sp[33] + -6.666666666666699 * sp[34] + -12.66666666666667 * sp[28] + 0.3333333333333777 * sp[31] + 15.83333333333343 * sp[34] + 4.583333333333418 * sp[35] + 11.58333333333335 * sp[29] + 0.3333333333335253 * sp[32] + -5.833333333333398 * sp[28] + 2.916666666666646 * sp[29] + -10.0833333333334 * sp[26] + -1.333333333333345 * sp[27] + -5.833333333333455 * sp[31] + -5.83333333333343 * sp[32] + 2.166666666666629 * sp[27] + 13.33333333333326 * sp[30];
    A[30] = -0.03333333333332916 * sp[33] + 0.4416666666666709 * sp[34] + -0.1916666666666685 * sp[28] + -0.1916666666666696 * sp[31] + -0.8916666666666657 * sp[34] + 1.275000000000009 * sp[35] + -0.7916666666666725 * sp[29] + -0.1916666666666731 * sp[32] + -0.1916666666666679 * sp[28] + -0.7916666666666765 * sp[29] + 1.275000000000009 * sp[26] + 0.4416666666666692 * sp[27] + -0.1916666666666637 * sp[31] + -0.1916666666666619 * sp[32] + -0.8916666666666733 * sp[27] + -0.03333333333332877 * sp[30];
    A[31] = 0.8166666666666679 * sp[33] + -0.716666666666673 * sp[34] + 0.2166666666666703 * sp[28] + 0.2166666666666709 * sp[31] + 2.783333333333347 * sp[34] + -3.466666666666688 * sp[35] + 1.66666666666668 * sp[29] + 0.216666666666671 * sp[32] + -0.6166666666666732 * sp[28] + 1.0 * sp[29] + -0.8000000000000094 * sp[26] + 0.2833333333333339 * sp[27] + -0.6166666666666744 * sp[31] + -0.6166666666666745 * sp[32] + 1.116666666666668 * sp[27] + -2.016666666666679 * sp[30];
    A[32] = 0.6333333333333359 * sp[33] + 1.691666666666676 * sp[34] + -0.6083333333333386 * sp[28] + -0.6083333333333368 * sp[31] + 1.691666666666676 * sp[34] + 6.191666666666701 * sp[35] + -1.875000000000016 * sp[29] + -0.6083333333333348 * sp[32] + -0.6083333333333386 * sp[28] + -1.875000000000016 * sp[29] + 0.8583333333333422 * sp[26] + 0.3583333333333358 * sp[27] + -0.6083333333333368 * sp[31] + -0.6083333333333348 * sp[32] + 0.3583333333333358 * sp[27] + 2.633333333333348 * sp[30];
    A[33] = -1.00833333333334 * sp[33] + -1.150000000000005 * sp[34] + -1.116666666666672 * sp[28] + -1.150000000000003 * sp[31] + -2.191666666666683 * sp[34] + -3.17083333333335 * sp[35] + -1.154166666666676 * sp[29] + -2.133333333333344 * sp[32] + 1.108333333333342 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000071 * sp[26] + 0.7333333333333414 * sp[27] + 1.108333333333338 * sp[31] + 1.108333333333332 * sp[32] + 1.10833333333334 * sp[27] + 1.091666666666669 * sp[30];
    A[34] = 1.266666666666673 * sp[33] + 2.133333333333344 * sp[34] + 0.8999999999999989 * sp[28] + 2.133333333333337 * sp[31] + 3.383333333333353 * sp[34] + 7.258333333333374 * sp[35] + 1.058333333333332 * sp[29] + 4.933333333333347 * sp[32] + -1.216666666666677 * sp[28] + -2.37500000000002 * sp[29] + -0.3083333333333363 * sp[26] + -1.466666666666678 * sp[27] + -1.216666666666675 * sp[31] + -1.21666666666667 * sp[32] + -1.216666666666673 * sp[27] + -2.600000000000015 * sp[30];
    A[35] = 0.4083333333333335 * sp[33] + -0.9833333333333406 * sp[34] + 0.7166666666666683 * sp[28] + -0.9833333333333405 * sp[31] + 1.391666666666671 * sp[34] + -4.295833333333358 * sp[35] + 2.887500000000015 * sp[29] + -2.800000000000019 * sp[32] + -0.3083333333333368 * sp[28] + 1.187500000000014 * sp[29] + -0.7625000000000084 * sp[26] + 0.7333333333333468 * sp[27] + -0.3083333333333366 * sp[31] + -0.308333333333336 * sp[32] + -0.3083333333333385 * sp[27] + 1.508333333333338 * sp[30];
    A[36] = -0.5083333333333319 * sp[33] + -0.691666666666664 * sp[34] + -0.6916666666666714 * sp[28] + -0.6916666666666695 * sp[31] + 0.2666666666666717 * sp[34] + 1.095833333333348 * sp[35] + -1.520833333333348 * sp[29] + -0.6916666666666692 * sp[32] + 0.4666666666666699 * sp[28] + 0.1124999999999979 * sp[29] + 1.295833333333342 * sp[26] + 0.9416666666666711 * sp[27] + 0.6499999999999988 * sp[31] + 2.283333333333354 * sp[32] + 0.6499999999999997 * sp[27] + 1.591666666666678 * sp[30];
    A[37] = 0.600000000000003 * sp[33] + 0.3833333333333363 * sp[34] + 0.3833333333333354 * sp[28] + 0.3833333333333364 * sp[31] + 0.1333333333333359 * sp[34] + -0.4416666666666573 * sp[35] + 0.9583333333333414 * sp[29] + 0.3833333333333414 * sp[32] + -0.9333333333333422 * sp[28] + -0.1416666666666695 * sp[29] + -1.67500000000001 * sp[26] + -0.8833333333333369 * sp[27] + 0.5333333333333374 * sp[31] + 0.09999999999999376 * sp[32] + 0.5333333333333425 * sp[27] + 0.06666666666665966 * sp[30];
    A[38] = -0.09166666666667111 * sp[33] + -0.1083333333333406 * sp[34] + -0.1083333333333348 * sp[28] + -0.108333333333337 * sp[31] + -0.4000000000000071 * sp[34] + 0.6374999999999883 * sp[35] + -1.145833333333341 * sp[29] + -0.1083333333333398 * sp[32] + 0.466666666666672 * sp[28] + -0.5124999999999975 * sp[29] + 0.8375000000000079 * sp[26] + -0.1416666666666673 * sp[27] + -1.183333333333337 * sp[31] + 2.116666666666679 * sp[32] + -1.183333333333339 * sp[27] + 1.008333333333342 * sp[30];
    A[39] = 4.006938426723792 * sp[33] + 5.185449728701373 * sp[34] + -0.4714045207910307 * sp[28] + -0.4714045207910284 * sp[31] + 10.13519719700724 * sp[34] + 7.660323462854305 * sp[35] + 2.003469213361893 * sp[29] + -0.4714045207910381 * sp[32] + -4.006938426723807 * sp[28] + -3.181980515339495 * sp[29] + 2.47487373415292 * sp[26] + 3.299831645537234 * sp[27] + -4.006938426723791 * sp[31] + -16.7348604880817 * sp[32] + 1.649915822768595 * sp[27] + -5.89255650988791 * sp[30];
    A[40] = -0.577350269189568 * sp[33] + -0.721687836486982 * sp[34] + -3.319764047840363 * sp[28] + -3.319764047840347 * sp[31] + 4.474464586219653 * sp[34] + 4.041451884327479 * sp[35] + -2.886751345948163 * sp[29] + -3.319764047840345 * sp[32] + -0.7216878364870516 * sp[28] + 6.92820323027554 * sp[26] + 7.649891066762572 * sp[27] + -0.7216878364870305 * sp[31] + -5.051814855409194 * sp[32] + 6.206515393788466 * sp[27] + -0.5773502691896146 * sp[30];
    A[41] = 4.833333333333342 * sp[33] + 2.416666666666693 * sp[34] + -4.08333333333337 * sp[28] + -4.083333333333353 * sp[31] + 14.91666666666673 * sp[34] + 22.91666666666679 * sp[35] + -12.08333333333345 * sp[29] + -4.083333333333332 * sp[32] + -4.08333333333337 * sp[28] + -5.750000000000027 * sp[29] + 3.25000000000004 * sp[26] + 1.583333333333347 * sp[27] + -4.083333333333366 * sp[31] + 11.41666666666674 * sp[32] + 4.916666666666712 * sp[27] + 19.83333333333344 * sp[30];
    A[42] = -5.892556509887917 * sp[33] + -4.006938426723782 * sp[34] + 0.2357022603955437 * sp[28] + 1.649915822768636 * sp[31] + -17.44196726926827 * sp[34] + -10.72445284799603 * sp[35] + -5.067598598503574 * sp[29] + 1.649915822768657 * sp[32] + 5.185449728701398 * sp[28] + 3.889087296526027 * sp[29] + -1.767766952966384 * sp[26] + -3.064129385141752 * sp[27] + 5.185449728701393 * sp[31] + 5.185449728701382 * sp[32] + -0.4714045207910114 * sp[27] + -1.649915822768603 * sp[30];
    A[43] = -3.897114317030001 * sp[33] + -3.031088913245556 * sp[34] + -3.031088913245558 * sp[28] + -0.4330127018922296 * sp[31] + -5.196152422706644 * sp[34] + -4.113620667976123 * sp[35] + -1.515544456622841 * sp[29] + -0.433012701892269 * sp[32] + 5.196152422706659 * sp[28] + 5.412658773652796 * sp[29] + -2.381569860407192 * sp[26] + -2.165063509461067 * sp[27] + 5.196152422706632 * sp[31] + 5.196152422706609 * sp[32] + -1.732050807568832 * sp[27] + 0.4330127018921683 * sp[30];
    A[44] = -10.4166666666667 * sp[33] + -7.08333333333335 * sp[34] + -4.083333333333326 * sp[28] + -0.5833333333332997 * sp[31] + -30.83333333333348 * sp[34] + -18.95833333333342 * sp[35] + -12.45833333333336 * sp[29] + -0.5833333333333515 * sp[32] + 9.166666666666753 * sp[28] + 6.875000000000025 * sp[29] + 3.375000000000038 * sp[26] + 1.083333333333313 * sp[27] + 9.166666666666742 * sp[31] + 9.166666666666719 * sp[32] + 0.1666666666666874 * sp[27] + -12.9166666666667 * sp[30];
    A[45] = -1.591666666666677 * sp[33] + -0.9416666666666769 * sp[34] + 0.6916666666666684 * sp[28] + 0.6916666666666678 * sp[31] + -0.6500000000000061 * sp[34] + -1.295833333333348 * sp[35] + 1.520833333333348 * sp[29] + 0.6916666666666722 * sp[32] + -2.28333333333335 * sp[28] + -0.112500000000004 * sp[29] + -1.095833333333332 * sp[26] + 0.6916666666666669 * sp[27] + -0.6500000000000127 * sp[31] + -0.4666666666666739 * sp[32] + -0.2666666666666587 * sp[27] + 0.5083333333333385 * sp[30];
    A[46] = -0.06666666666666884 * sp[33] + 0.4666666666666792 * sp[34] + 0.03333333333332944 * sp[28] + 0.03333333333333344 * sp[31] + -0.950000000000004 * sp[34] + 1.258333333333353 * sp[35] + -0.7083333333333474 * sp[29] + 0.03333333333333757 * sp[32] + 0.3166666666666714 * sp[28] + -0.1083333333333333 * sp[29] + 0.8583333333333331 * sp[26] + 0.03333333333333249 * sp[27] + -0.949999999999996 * sp[31] + 0.6833333333333421 * sp[32] + 0.1166666666666587 * sp[27] + -0.1833333333333357 * sp[30];
    A[47] = -1.00833333333334 * sp[33] + -2.191666666666683 * sp[34] + 1.108333333333342 * sp[28] + 1.108333333333338 * sp[31] + -1.150000000000005 * sp[34] + -3.17083333333335 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333332 * sp[32] + -1.116666666666672 * sp[28] + -1.154166666666676 * sp[29] + 0.3625000000000071 * sp[26] + 1.10833333333334 * sp[27] + -1.150000000000003 * sp[31] + -2.133333333333344 * sp[32] + 0.7333333333333414 * sp[27] + 1.091666666666669 * sp[30];
    A[48] = 2.633333333333349 * sp[33] + 2.275000000000012 * sp[34] + 3.241666666666683 * sp[28] + 2.275000000000012 * sp[31] + 2.275000000000012 * sp[34] + 2.775000000000011 * sp[35] + 1.008333333333344 * sp[29] + 1.508333333333341 * sp[32] + 3.241666666666683 * sp[28] + 1.008333333333344 * sp[29] + 10.04166666666667 * sp[26] + 5.50833333333334 * sp[27] + 2.275000000000012 * sp[31] + 1.508333333333341 * sp[32] + 5.50833333333334 * sp[27] + 3.683333333333336 * sp[30];
    A[49] = -2.016666666666679 * sp[33] + -3.133333333333353 * sp[34] + -1.400000000000005 * sp[28] + -3.133333333333342 * sp[31] + -2.30000000000001 * sp[34] + -4.216666666666684 * sp[35] + -0.6833333333333343 * sp[29] + -2.600000000000005 * sp[32] + -2.233333333333344 * sp[28] + -1.68333333333335 * sp[29] + -5.083333333333334 * sp[26] + -7.933333333333332 * sp[27] + -2.300000000000007 * sp[31] + -2.766666666666681 * sp[32] + -3.433333333333327 * sp[27] + -5.866666666666664 * sp[30];
    A[50] = -0.03333333333333585 * sp[33] + 0.8583333333333466 * sp[34] + 0.1583333333333301 * sp[28] + 0.8583333333333469 * sp[31] + -0.4750000000000023 * sp[34] + 1.691666666666684 * sp[35] + -1.075000000000007 * sp[29] + 1.091666666666682 * sp[32] + 0.1583333333333346 * sp[28] + 0.2583333333333384 * sp[29] + 1.625000000000001 * sp[26] + 2.425 * sp[27] + -0.4749999999999975 * sp[31] + 1.091666666666678 * sp[32] + -0.2416666666666655 * sp[27] + 2.183333333333339 * sp[30];
    A[51] = 1.508333333333334 * sp[33] + 1.816666666666668 * sp[34] + 1.816666666666674 * sp[28] + 1.816666666666671 * sp[31] + 0.7750000000000037 * sp[34] + 0.3208333333333283 * sp[35] + 2.270833333333345 * sp[29] + 1.816666666666672 * sp[32] + 4.308333333333327 * sp[28] + 7.504166666666666 * sp[29] + 0.3208333333333401 * sp[26] + 1.816666666666674 * sp[27] + 2.591666666666663 * sp[31] + 4.308333333333326 * sp[32] + 0.7750000000000079 * sp[27] + 1.508333333333337 * sp[30];
    A[52] = -2.600000000000008 * sp[33] + -1.383333333333338 * sp[34] + -1.383333333333334 * sp[28] + -1.383333333333335 * sp[31] + -1.133333333333349 * sp[34] + -0.2250000000000075 * sp[35] + -2.291666666666682 * sp[29] + -1.383333333333341 * sp[32] + -7.533333333333333 * sp[28] + -5.258333333333333 * sp[29] + 0.9416666666666662 * sp[26] + -1.383333333333333 * sp[27] + -3.933333333333342 * sp[31] + -2.86666666666667 * sp[32] + 0.03333333333332594 * sp[27] + -1.016666666666672 * sp[30];
    A[53] = 1.091666666666675 * sp[33] + -0.01666666666666289 * sp[34] + -0.01666666666666672 * sp[28] + -0.01666666666666833 * sp[31] + 0.3583333333333455 * sp[34] + -0.3874999999999975 * sp[35] + 0.7291666666666781 * sp[29] + -0.01666666666666848 * sp[32] + 3.225000000000008 * sp[28] + 0.9625000000000006 * sp[29] + -1.054166666666669 * sp[26] + -0.01666666666666893 * sp[27] + 1.34166666666668 * sp[31] + 0.5583333333333393 * sp[32] + -0.3083333333333279 * sp[27] + 0.09166666666666919 * sp[30];
    A[54] = -7.542472332656567 * sp[33] + -8.720983634634127 * sp[34] + 4.006938426723765 * sp[28] + 4.006938426723776 * sp[31] + -7.778174593052068 * sp[34] + -8.249579113843062 * sp[35] + 4.478342947514809 * sp[29] + 4.006938426723806 * sp[32] + -8.720983634634145 * sp[28] + -12.96362432175341 * sp[29] + -0.2357022603955121 * sp[26] + 4.006938426723768 * sp[27] + -7.778174593052059 * sp[31] + -11.07800623858926 * sp[32] + 0.2357022603955192 * sp[27] + 2.357022603955168 * sp[30];
    A[55] = -5.917840259193747 * sp[33] + 0.7216878364869923 * sp[34] + 11.98001808568476 * sp[28] + 11.98001808568476 * sp[31] + -0.8660254037844877 * sp[34] + -2.237232293109841 * sp[35] + 13.35122497501013 * sp[29] + 11.98001808568479 * sp[32] + -11.83568051838745 * sp[28] + 18.25870226312187 * sp[29] + 2.670244995002064 * sp[26] + 11.98001808568476 * sp[27] + -0.8660254037845783 * sp[31] + 10.96965511460281 * sp[32] + 4.04145188432741 * sp[27] + 8.804591605141807 * sp[30];
    A[56] = -3.583333333333354 * sp[33] + -4.916666666666697 * sp[34] + 6.583333333333396 * sp[28] + 6.583333333333364 * sp[31] + -7.000000000000024 * sp[34] + -7.708333333333363 * sp[35] + 7.291666666666713 * sp[29] + 6.583333333333314 * sp[32] + -2.666666666666649 * sp[28] + 4.458333333333289 * sp[29] + 5.458333333333387 * sp[26] + 6.583333333333383 * sp[27] + -6.999999999999984 * sp[31] + 2.166666666666598 * sp[32] + 6.16666666666671 * sp[27] + 6.91666666666667 * sp[30];
    A[57] = 5.892556509887943 * sp[33] + 7.542472332656526 * sp[34] + -10.84230397819378 * sp[28] + -5.185449728701402 * sp[31] + 9.19238815542516 * sp[34] + 8.367430244040808 * sp[35] + -4.360491817317088 * sp[29] + -5.185449728701423 * sp[32] + 5.421151989096883 * sp[28] + 5.067598598503627 * sp[29] + -18.9740319618391 * sp[26] + -5.185449728701383 * sp[27] + 9.192388155425126 * sp[31] + 5.892556509887905 * sp[32] + -6.835365551470035 * sp[27] + -4.006938426723817 * sp[30];
    A[58] = 16.88749537379664 * sp[33] + 9.526279441628882 * sp[34] + 9.526279441628906 * sp[28] + -1.732050807568834 * sp[31] + 11.69134295108997 * sp[34] + 10.60881119635945 * sp[35] + -0.6495190528382926 * sp[29] + -1.732050807568841 * sp[32] + 22.08364779650329 * sp[28] + 2.814582562299456 * sp[29] + 36.58957330989259 * sp[26] + -1.732050807568859 * sp[27] + 11.69134295108999 * sp[31] + 3.897114317030005 * sp[32] + 19.4855715851499 * sp[27] + 0.4330127018922278 * sp[30];
    A[59] = 10.41666666666675 * sp[33] + 13.33333333333336 * sp[34] + 0.3333333333333379 * sp[28] + 1.833333333333298 * sp[31] + 16.25000000000008 * sp[34] + 14.79166666666666 * sp[35] + 3.291666666666697 * sp[29] + 1.833333333333316 * sp[32] + 9.58333333333335 * sp[28] + 8.958333333333393 * sp[29] + 7.458333333333292 * sp[26] + 1.833333333333306 * sp[27] + 16.25 * sp[31] + 10.41666666666667 * sp[32] + 9.416666666666636 * sp[27] + 2.916666666666619 * sp[30];
    A[60] = -0.06666666666666266 * sp[33] + 0.8833333333333411 * sp[34] + -0.3833333333333338 * sp[28] + -0.3833333333333384 * sp[31] + -0.5333333333333306 * sp[34] + 1.675000000000012 * sp[35] + -0.9583333333333403 * sp[29] + -0.3833333333333411 * sp[32] + -0.09999999999999098 * sp[28] + 0.1416666666666681 * sp[29] + 0.4416666666666673 * sp[26] + -0.383333333333338 * sp[27] + -0.5333333333333307 * sp[31] + 0.9333333333333305 * sp[32] + -0.133333333333332 * sp[27] + -0.6000000000000051 * sp[30];
    A[61] = 1.63333333333334 * sp[33] + -1.433333333333346 * sp[34] + 0.4333333333333392 * sp[28] + 0.4333333333333441 * sp[31] + 3.066666666666682 * sp[34] + -3.683333333333361 * sp[35] + 1.58333333333335 * sp[29] + 0.4333333333333397 * sp[32] + 1.199999999999994 * sp[28] + -0.283333333333331 * sp[29] + -0.216666666666666 * sp[26] + 0.4333333333333446 * sp[27] + 3.066666666666673 * sp[31] + -2.533333333333331 * sp[32] + 0.9333333333333433 * sp[27] + 1.200000000000019 * sp[30];
    A[62] = 1.266666666666673 * sp[33] + 3.383333333333353 * sp[34] + -1.216666666666677 * sp[28] + -1.216666666666675 * sp[31] + 2.133333333333344 * sp[34] + 7.258333333333374 * sp[35] + -2.37500000000002 * sp[29] + -1.21666666666667 * sp[32] + 0.8999999999999989 * sp[28] + 1.058333333333332 * sp[29] + -0.3083333333333363 * sp[26] + -1.216666666666673 * sp[27] + 2.133333333333337 * sp[31] + 4.933333333333347 * sp[32] + -1.466666666666678 * sp[27] + -2.600000000000015 * sp[30];
    A[63] = -2.016666666666679 * sp[33] + -2.30000000000001 * sp[34] + -2.233333333333344 * sp[28] + -2.300000000000007 * sp[31] + -3.133333333333353 * sp[34] + -4.216666666666684 * sp[35] + -1.68333333333335 * sp[29] + -2.766666666666681 * sp[32] + -1.400000000000005 * sp[28] + -0.6833333333333343 * sp[29] + -5.083333333333334 * sp[26] + -3.433333333333327 * sp[27] + -3.133333333333342 * sp[31] + -2.600000000000005 * sp[32] + -7.933333333333332 * sp[27] + -5.866666666666664 * sp[30];
    A[64] = 2.533333333333347 * sp[33] + 4.26666666666669 * sp[34] + 1.800000000000001 * sp[28] + 4.266666666666678 * sp[31] + 4.26666666666669 * sp[34] + 8.766666666666712 * sp[35] + 1.366666666666667 * sp[29] + 5.866666666666687 * sp[32] + 1.800000000000001 * sp[28] + 1.366666666666667 * sp[29] + 3.833333333333325 * sp[26] + 5.866666666666656 * sp[27] + 4.266666666666678 * sp[31] + 5.866666666666687 * sp[32] + 5.866666666666656 * sp[27] + 11.73333333333334 * sp[30];
    A[65] = 0.8166666666666693 * sp[33] + -1.966666666666682 * sp[34] + 1.43333333333334 * sp[28] + -1.966666666666684 * sp[31] + 1.533333333333339 * sp[34] + -4.716666666666699 * sp[35] + 3.150000000000015 * sp[29] + -3.100000000000029 * sp[32] + 0.5999999999999953 * sp[28] + -0.5166666666666666 * sp[29] + 0.4166666666666621 * sp[26] + -2.433333333333331 * sp[27] + 1.533333333333333 * sp[31] + -3.266666666666674 * sp[32] + 2.066666666666676 * sp[27] + -5.866666666666673 * sp[30];
    A[66] = -1.016666666666664 * sp[33] + -1.383333333333329 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333338 * sp[31] + 0.03333333333333732 * sp[34] + 0.9416666666666779 * sp[35] + -2.291666666666682 * sp[29] + -1.383333333333337 * sp[32] + -2.866666666666659 * sp[28] + -5.258333333333324 * sp[29] + -0.2250000000000023 * sp[26] + -1.383333333333336 * sp[27] + -3.933333333333318 * sp[31] + -7.533333333333328 * sp[32] + -1.133333333333338 * sp[27] + -2.600000000000006 * sp[30];
    A[67] = 1.200000000000002 * sp[33] + 0.7666666666666726 * sp[34] + 0.7666666666666668 * sp[28] + 0.766666666666671 * sp[31] + 0.2666666666666755 * sp[34] + -0.3833333333333203 * sp[35] + 1.416666666666675 * sp[29] + 0.7666666666666757 * sp[32] + 3.73333333333333 * sp[28] + 3.016666666666667 * sp[29] + -0.3833333333333352 * sp[26] + 0.766666666666669 * sp[27] + 5.866666666666658 * sp[31] + 3.733333333333335 * sp[32] + 0.2666666666666623 * sp[27] + 1.200000000000003 * sp[30];
    A[68] = -0.1833333333333382 * sp[33] + -0.2166666666666833 * sp[34] + -0.2166666666666679 * sp[28] + -0.2166666666666752 * sp[31] + -0.3000000000000127 * sp[34] + 0.5249999999999839 * sp[35] + -1.041666666666677 * sp[29] + -0.2166666666666747 * sp[32] + -0.8666666666666717 * sp[28] + -1.008333333333348 * sp[29] + 0.3583333333333346 * sp[26] + -0.2166666666666751 * sp[27] + -1.933333333333338 * sp[31] + -1.533333333333357 * sp[32] + -0.4666666666666703 * sp[27] + -0.6000000000000137 * sp[30];
    A[69] = 8.013876853447588 * sp[33] + 10.37089945740276 * sp[34] + -0.9428090415820536 * sp[28] + -0.9428090415820456 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977585 * sp[35] + 0.4714045207910482 * sp[29] + -0.9428090415820688 * sp[32] + 5.65685424949239 * sp[28] + 11.78511301977581 * sp[29] + 0.4714045207910345 * sp[26] + -0.9428090415820389 * sp[27] + 13.19932658214892 * sp[31] + 24.51303508113374 * sp[32] + 1.88561808316416 * sp[27];
    A[70] = -1.154700538379172 * sp[33] + -1.443375672973972 * sp[34] + -6.639528095680715 * sp[28] + -6.639528095680678 * sp[31] + 4.618802153517112 * sp[34] + 5.917840259193776 * sp[35] + -7.938566201357379 * sp[29] + -6.63952809568069 * sp[32] + -5.196152422706532 * sp[28] + -14.86676943163276 * sp[29] + -1.010362971081855 * sp[26] + -6.639528095680663 * sp[27] + 4.618802153517141 * sp[31] + -16.16580753730939 * sp[32] + -2.309401076758483 * sp[27] + -10.3923048454132 * sp[30];
    A[71] = 9.666666666666703 * sp[33] + 4.833333333333361 * sp[34] + -8.166666666666748 * sp[28] + -8.166666666666721 * sp[31] + 17.33333333333341 * sp[34] + 24.58333333333346 * sp[35] + -15.4166666666668 * sp[29] + -8.166666666666675 * sp[32] + 6.999999999999967 * sp[28] + -11.41666666666666 * sp[29] + -3.416666666666693 * sp[26] + -8.166666666666703 * sp[27] + 17.33333333333335 * sp[31] + -2.666666666666629 * sp[32] + -10.66666666666676 * sp[27] + -18.0000000000001 * sp[30];
    A[72] = -11.78511301977585 * sp[33] + -8.013876853447567 * sp[34] + 0.4714045207910602 * sp[28] + 3.299831645537267 * sp[31] + -20.7417989148055 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141675 * sp[29] + 3.299831645537287 * sp[32] + -8.485281374238548 * sp[28] + -3.064129385141709 * sp[29] + 2.592724864350728 * sp[26] + 3.299831645537247 * sp[27] + -20.74179891480543 * sp[31] + -9.428090415820687 * sp[32] + 1.885618083164142 * sp[27] + 5.656854249492397 * sp[30];
    A[73] = -7.794228634059981 * sp[33] + -6.062177826491105 * sp[34] + -6.062177826491127 * sp[28] + -0.8660254037844766 * sp[31] + -10.39230484541329 * sp[34] + -8.227241335952211 * sp[35] + -3.031088913245625 * sp[29] + -0.8660254037844877 * sp[32] + -5.19615242270666 * sp[28] + -1.299038105676664 * sp[29] + -16.88749537379658 * sp[26] + -0.8660254037844569 * sp[27] + -10.39230484541324 * sp[31] + -3.464101615137731 * sp[32] + -17.32050807568881 * sp[27] + 3.464101615137753 * sp[30];
    A[74] = -20.83333333333343 * sp[33] + -14.16666666666671 * sp[34] + -8.166666666666673 * sp[28] + -1.166666666666608 * sp[31] + -36.66666666666684 * sp[34] + -25.41666666666674 * sp[35] + -12.4166666666667 * sp[29] + -1.166666666666637 * sp[32] + -14.99999999999995 * sp[28] + -5.416666666666665 * sp[29] + -12.41666666666661 * sp[26] + -1.166666666666613 * sp[27] + -36.66666666666672 * sp[31] + -16.66666666666675 * sp[32] + -24.66666666666664 * sp[27] + 10.00000000000008 * sp[30];
    A[75] = -1.008333333333333 * sp[33] + 0.1416666666666675 * sp[34] + 0.1083333333333307 * sp[28] + 0.1083333333333287 * sp[31] + 1.183333333333333 * sp[34] + -0.837500000000007 * sp[35] + 1.145833333333343 * sp[29] + 0.1083333333333392 * sp[32] + -2.116666666666671 * sp[28] + 0.5125000000000047 * sp[29] + -0.6375000000000097 * sp[26] + 0.1083333333333248 * sp[27] + 1.183333333333333 * sp[31] + -0.4666666666666676 * sp[32] + 0.40000000000001 * sp[27] + 0.09166666666667571 * sp[30];
    A[76] = 1.266666666666667 * sp[33] + -0.8666666666666685 * sp[34] + 0.3666666666666698 * sp[28] + 0.366666666666673 * sp[31] + -2.116666666666677 * sp[34] + 3.008333333333344 * sp[35] + -1.958333333333343 * sp[29] + 0.3666666666666709 * sp[32] + 2.483333333333341 * sp[28] + -2.025000000000011 * sp[29] + 1.275000000000012 * sp[26] + 0.3666666666666765 * sp[27] + -2.116666666666676 * sp[31] + 1.849999999999995 * sp[32] + -1.050000000000009 * sp[27] + -1.016666666666666 * sp[30];
    A[77] = 0.4083333333333335 * sp[33] + 1.391666666666671 * sp[34] + -0.3083333333333368 * sp[28] + -0.3083333333333366 * sp[31] + -0.9833333333333406 * sp[34] + -4.295833333333358 * sp[35] + 1.187500000000014 * sp[29] + -0.308333333333336 * sp[32] + 0.7166666666666683 * sp[28] + 2.887500000000015 * sp[29] + -0.7625000000000084 * sp[26] + -0.3083333333333385 * sp[27] + -0.9833333333333405 * sp[31] + -2.800000000000019 * sp[32] + 0.7333333333333468 * sp[27] + 1.508333333333338 * sp[30];
    A[78] = -0.03333333333333585 * sp[33] + -0.4750000000000023 * sp[34] + 0.1583333333333346 * sp[28] + -0.4749999999999975 * sp[31] + 0.8583333333333466 * sp[34] + 1.691666666666684 * sp[35] + 0.2583333333333384 * sp[29] + 1.091666666666678 * sp[32] + 0.1583333333333301 * sp[28] + -1.075000000000007 * sp[29] + 1.625000000000001 * sp[26] + -0.2416666666666655 * sp[27] + 0.8583333333333469 * sp[31] + 1.091666666666682 * sp[32] + 2.425 * sp[27] + 2.183333333333339 * sp[30];
    A[79] = 0.8166666666666693 * sp[33] + 1.533333333333339 * sp[34] + 0.5999999999999953 * sp[28] + 1.533333333333333 * sp[31] + -1.966666666666682 * sp[34] + -4.716666666666699 * sp[35] + -0.5166666666666666 * sp[29] + -3.266666666666674 * sp[32] + 1.43333333333334 * sp[28] + 3.150000000000015 * sp[29] + 0.4166666666666621 * sp[26] + 2.066666666666676 * sp[27] + -1.966666666666684 * sp[31] + -3.100000000000029 * sp[32] + -2.433333333333331 * sp[27] + -5.866666666666673 * sp[30];
    A[80] = 0.633333333333332 * sp[33] + -1.058333333333336 * sp[34] + 1.241666666666668 * sp[28] + -1.058333333333336 * sp[31] + -1.058333333333336 * sp[34] + 3.441666666666681 * sp[35] + -2.325000000000011 * sp[29] + 2.175000000000004 * sp[32] + 1.241666666666668 * sp[28] + -2.325000000000011 * sp[29] + 2.708333333333341 * sp[26] + -1.825000000000012 * sp[27] + -1.058333333333336 * sp[31] + 2.175000000000004 * sp[32] + -1.825000000000012 * sp[27] + 3.683333333333326 * sp[30];
    A[81] = 0.09166666666666894 * sp[33] + -0.01666666666666186 * sp[34] + -0.01666666666667128 * sp[28] + -0.01666666666666905 * sp[31] + -0.3083333333333318 * sp[34] + -1.054166666666679 * sp[35] + 0.7291666666666833 * sp[29] + -0.01666666666666317 * sp[32] + 0.5583333333333336 * sp[28] + 0.9625000000000068 * sp[29] + -0.3875000000000099 * sp[26] + -0.01666666666667116 * sp[27] + 1.341666666666665 * sp[31] + 3.224999999999997 * sp[32] + 0.3583333333333503 * sp[27] + 1.091666666666679 * sp[30];
    A[82] = -0.5999999999999996 * sp[33] + -0.2166666666666642 * sp[34] + -0.2166666666666625 * sp[28] + -0.2166666666666614 * sp[31] + -0.4666666666666719 * sp[34] + 0.3583333333333236 * sp[35] + -1.041666666666681 * sp[29] + -0.2166666666666761 * sp[32] + -1.533333333333327 * sp[28] + -1.008333333333328 * sp[29] + 0.5250000000000128 * sp[26] + -0.2166666666666568 * sp[27] + -1.933333333333334 * sp[31] + -0.8666666666666752 * sp[32] + -0.3000000000000148 * sp[27] + -0.1833333333333493 * sp[30];
    A[83] = 0.5083333333333313 * sp[33] + -0.1833333333333421 * sp[34] + -0.1833333333333359 * sp[28] + -0.18333333333334 * sp[31] + 0.775000000000003 * sp[34] + -1.012499999999999 * sp[35] + 1.604166666666675 * sp[29] + -0.1833333333333331 * sp[32] + 0.9749999999999953 * sp[28] + 0.1708333333333183 * sp[29] + -1.012500000000011 * sp[26] + -0.1833333333333441 * sp[27] + 0.5916666666666676 * sp[31] + 0.9749999999999994 * sp[32] + 0.7750000000000078 * sp[27] + 0.5083333333333359 * sp[30];
    A[84] = 1.885618083164129 * sp[33] + 3.064129385141721 * sp[34] + 1.649915822768605 * sp[28] + 1.649915822768616 * sp[31] + -5.42115198909691 * sp[34] + -1.178511301977587 * sp[35] + -2.592724864350657 * sp[29] + 1.649915822768645 * sp[32] + 3.064129385141716 * sp[28] + 3.535533905932771 * sp[29] + 2.121320343559636 * sp[26] + 1.649915822768613 * sp[27] + -5.421151989096911 * sp[31] + -13.43502884254444 * sp[32] + -2.121320343559625 * sp[27] + -2.357022603955114 * sp[30];
    A[85] = -4.47446458621957 * sp[33] + -0.7216878364869789 * sp[34] + 1.876388374866266 * sp[28] + 1.876388374866292 * sp[31] + -3.752776749732504 * sp[34] + -0.07216878364873935 * sp[35] + -1.804219591217512 * sp[29] + 1.876388374866327 * sp[32] + -8.948929172439181 * sp[28] + 0.2165063509461903 * sp[29] + 1.948557158514961 * sp[26] + 1.876388374866291 * sp[27] + -3.752776749732487 * sp[31] + 5.196152422706637 * sp[32] + -1.732050807568799 * sp[27] + 1.587713240271555 * sp[30];
    A[86] = 5.583333333333337 * sp[33] + 0.9166666666666845 * sp[34] + -2.583333333333355 * sp[28] + -2.583333333333346 * sp[31] + -10.33333333333339 * sp[34] + -18.95833333333341 * sp[35] + 6.04166666666674 * sp[29] + -2.583333333333369 * sp[32] + 10.6666666666667 * sp[28] + 4.875000000000029 * sp[29] + -4.125000000000037 * sp[26] + -2.58333333333335 * sp[27] + -10.33333333333339 * sp[31] + 0.5 * sp[32] + 4.500000000000076 * sp[27] + 11.08333333333335 * sp[30];
    A[87] = -5.892556509887902 * sp[33] + -1.885618083164137 * sp[34] + -6.128258770283398 * sp[28] + -0.4714045207910202 * sp[31] + 11.54941075938034 * sp[34] + 4.831896338108131 * sp[35] + 6.246109900481153 * sp[29] + -0.4714045207910718 * sp[32] + -11.07800623858928 * sp[28] + -3.18198051533948 * sp[29] + -13.08147545195113 * sp[26] + -0.4714045207910007 * sp[27] + 11.54941075938035 * sp[31] + 3.535533905932826 * sp[32] + 4.94974746830582 * sp[27] + -1.649915822768632 * sp[30];
    A[88] = 3.897114317029978 * sp[33] + 0.8660254037844326 * sp[34] + 0.8660254037844487 * sp[28] + -1.73205080756887 * sp[31] + -1.299038105676645 * sp[34] + -0.2165063509460512 * sp[35] + -2.814582562299341 * sp[29] + -1.732050807568813 * sp[32] + 9.093266739736643 * sp[28] + 0.6495190528383092 * sp[29] + 8.443747686898309 * sp[26] + -1.732050807568873 * sp[27] + -1.299038105676638 * sp[31] + -0.4330127018921792 * sp[32] + -2.165063509461007 * sp[27] + -3.897114317029972 * sp[30];
    A[89] = -10.41666666666667 * sp[33] + -3.333333333333347 * sp[34] + -6.333333333333318 * sp[28] + 0.1666666666666874 * sp[31] + 20.41666666666679 * sp[34] + 8.541666666666762 * sp[35] + 12.04166666666669 * sp[29] + 0.1666666666667926 * sp[32] + -19.58333333333339 * sp[28] + -5.625000000000021 * sp[29] + -12.12500000000002 * sp[26] + 0.1666666666667045 * sp[27] + 20.41666666666678 * sp[31] + 6.250000000000149 * sp[32] + 15.25000000000001 * sp[27] + -12.91666666666651 * sp[30];
    A[90] = -1.091666666666674 * sp[33] + -0.7333333333333441 * sp[34] + 2.133333333333345 * sp[28] + 1.149999999999999 * sp[31] + -1.108333333333342 * sp[34] + -0.3624999999999955 * sp[35] + 1.154166666666652 * sp[29] + 1.116666666666661 * sp[32] + -1.108333333333335 * sp[28] + -1.479166666666684 * sp[29] + 3.170833333333344 * sp[26] + 1.149999999999999 * sp[27] + -1.108333333333336 * sp[31] + -1.108333333333341 * sp[32] + 2.191666666666666 * sp[27] + 1.008333333333332 * sp[30];
    A[91] = 0.1833333333333397 * sp[33] + -0.1166666666666611 * sp[34] + -0.6833333333333431 * sp[28] + 0.9500000000000037 * sp[31] + -0.03333333333332378 * sp[34] + -0.8583333333333498 * sp[35] + 0.1083333333333386 * sp[29] + -0.3166666666666879 * sp[32] + -0.03333333333333929 * sp[28] + 0.7083333333333544 * sp[29] + -1.258333333333347 * sp[26] + 0.9500000000000044 * sp[27] + -0.03333333333333585 * sp[31] + -0.03333333333332811 * sp[32] + -0.4666666666666703 * sp[27] + 0.0666666666666586 * sp[30];
    A[92] = -0.5083333333333319 * sp[33] + 0.2666666666666717 * sp[34] + 0.4666666666666699 * sp[28] + 0.6499999999999988 * sp[31] + -0.691666666666664 * sp[34] + 1.095833333333348 * sp[35] + 0.1124999999999979 * sp[29] + 2.283333333333354 * sp[32] + -0.6916666666666714 * sp[28] + -1.520833333333348 * sp[29] + 1.295833333333342 * sp[26] + 0.6499999999999997 * sp[27] + -0.6916666666666695 * sp[31] + -0.6916666666666692 * sp[32] + 0.9416666666666711 * sp[27] + 1.591666666666678 * sp[30];
    A[93] = 1.508333333333334 * sp[33] + 0.7750000000000037 * sp[34] + 4.308333333333327 * sp[28] + 2.591666666666663 * sp[31] + 1.816666666666668 * sp[34] + 0.3208333333333283 * sp[35] + 7.504166666666666 * sp[29] + 4.308333333333326 * sp[32] + 1.816666666666674 * sp[28] + 2.270833333333345 * sp[29] + 0.3208333333333401 * sp[26] + 0.7750000000000079 * sp[27] + 1.816666666666671 * sp[31] + 1.816666666666672 * sp[32] + 1.816666666666674 * sp[27] + 1.508333333333337 * sp[30];
    A[94] = -1.016666666666664 * sp[33] + 0.03333333333333732 * sp[34] + -2.866666666666659 * sp[28] + -3.933333333333318 * sp[31] + -1.383333333333329 * sp[34] + 0.9416666666666779 * sp[35] + -5.258333333333324 * sp[29] + -7.533333333333328 * sp[32] + -1.383333333333342 * sp[28] + -2.291666666666682 * sp[29] + -0.2250000000000023 * sp[26] + -1.133333333333338 * sp[27] + -1.383333333333338 * sp[31] + -1.383333333333337 * sp[32] + -1.383333333333336 * sp[27] + -2.600000000000006 * sp[30];
    A[95] = 0.09166666666666894 * sp[33] + -0.3083333333333318 * sp[34] + 0.5583333333333336 * sp[28] + 1.341666666666665 * sp[31] + -0.01666666666666186 * sp[34] + -1.054166666666679 * sp[35] + 0.9625000000000068 * sp[29] + 3.224999999999997 * sp[32] + -0.01666666666667128 * sp[28] + 0.7291666666666833 * sp[29] + -0.3875000000000099 * sp[26] + 0.3583333333333503 * sp[27] + -0.01666666666666905 * sp[31] + -0.01666666666666317 * sp[32] + -0.01666666666667116 * sp[27] + 1.091666666666679 * sp[30];
    A[96] = 3.683333333333331 * sp[33] + 5.508333333333319 * sp[34] + 1.508333333333336 * sp[28] + 2.274999999999999 * sp[31] + 5.508333333333319 * sp[34] + 10.04166666666667 * sp[35] + 1.008333333333323 * sp[29] + 3.241666666666669 * sp[32] + 1.508333333333336 * sp[28] + 1.008333333333323 * sp[29] + 2.775000000000007 * sp[26] + 2.275 * sp[27] + 2.274999999999999 * sp[31] + 3.241666666666669 * sp[32] + 2.275 * sp[27] + 2.633333333333338 * sp[30];
    A[97] = -5.866666666666672 * sp[33] + -3.433333333333325 * sp[34] + -2.766666666666677 * sp[28] + -2.299999999999996 * sp[31] + -7.933333333333318 * sp[34] + -5.083333333333318 * sp[35] + -1.683333333333312 * sp[29] + -2.233333333333319 * sp[32] + -2.600000000000009 * sp[28] + -0.6833333333333306 * sp[29] + -4.216666666666677 * sp[26] + -2.299999999999997 * sp[27] + -3.133333333333333 * sp[31] + -1.399999999999995 * sp[32] + -3.13333333333333 * sp[27] + -2.016666666666661 * sp[30];
    A[98] = 2.183333333333341 * sp[33] + -0.2416666666666683 * sp[34] + 1.091666666666676 * sp[28] + -0.4750000000000057 * sp[31] + 2.424999999999999 * sp[34] + 1.625000000000021 * sp[35] + 0.2583333333333242 * sp[29] + 0.1583333333333411 * sp[32] + 1.091666666666673 * sp[28] + -1.075 * sp[29] + 1.691666666666678 * sp[26] + -0.4750000000000058 * sp[27] + 0.8583333333333339 * sp[31] + 0.1583333333333449 * sp[32] + 0.8583333333333337 * sp[27] + -0.0333333333333318 * sp[30];
    A[99] = -4.006938426723776 * sp[33] + -6.835365551469938 * sp[34] + 5.892556509887898 * sp[28] + 9.192388155425125 * sp[31] + -5.18544972870135 * sp[34] + -18.97403196183912 * sp[35] + 5.067598598503546 * sp[29] + 5.421151989096768 * sp[32] + -5.185449728701388 * sp[28] + -4.360491817317055 * sp[29] + 8.367430244040804 * sp[26] + 9.192388155425128 * sp[27] + -5.185449728701376 * sp[31] + -10.8423039781938 * sp[32] + 7.542472332656487 * sp[27] + 5.892556509887863 * sp[30];
    A[100] = 2.742413778650681 * sp[33] + 17.89785834487833 * sp[34] + 10.9696551146029 * sp[28] + 19.9185842870421 * sp[31] + 0.7216878364868515 * sp[34] + 24.75389279150508 * sp[35] + 9.165435523385241 * sp[29] + 19.34123401785236 * sp[32] + 0.721687836487015 * sp[28] + 2.525907427704556 * sp[29] + 18.11436469582451 * sp[26] + 19.91858428704211 * sp[27] + 0.7216878364869777 * sp[31] + 5.051814855409161 * sp[32] + 16.31014510460691 * sp[27] + 17.46484564298616 * sp[30];
    A[101] = -1.0833333333333 * sp[33] + 12.16666666666668 * sp[34] + -1.833333333333353 * sp[28] + 1.999999999999988 * sp[31] + -2.416666666666613 * sp[34] + 27.95833333333339 * sp[35] + -2.041666666666655 * sp[29] + 14.3333333333335 * sp[32] + -2.4166666666667 * sp[28] + -2.20833333333334 * sp[29] + 1.791666666666695 * sp[26] + 2.0 * sp[27] + -2.416666666666679 * sp[31] + 8.083333333333396 * sp[32] + 1.58333333333336 * sp[27] + 9.416666666666757 * sp[30];
    A[102] = 2.357022603955131 * sp[33] + 0.2357022603954846 * sp[34] + -11.07800623858928 * sp[28] + -7.778174593052078 * sp[31] + 4.006938426723726 * sp[34] + -0.2357022603955086 * sp[35] + -12.9636243217534 * sp[29] + -8.720983634634081 * sp[32] + 4.006938426723814 * sp[28] + 4.478342947514788 * sp[29] + -8.249579113843065 * sp[26] + -7.778174593052094 * sp[27] + 4.006938426723792 * sp[31] + 4.006938426723767 * sp[32] + -8.720983634634095 * sp[27] + -7.542472332656549 * sp[30];
    A[103] = 10.39230484541329 * sp[33] + 7.361215932167788 * sp[34] + 7.36121593216771 * sp[28] + -6.49519052838323 * sp[31] + 11.69134295108995 * sp[34] + 6.06217782649105 * sp[35] + 12.99038105676659 * sp[29] + -8.227241335952161 * sp[32] + 11.69134295108995 * sp[28] + 12.99038105676667 * sp[29] + -7.794228634059923 * sp[26] + -6.495190528383204 * sp[27] + 11.69134295108995 * sp[31] + 11.69134295108997 * sp[32] + -3.897114317029954 * sp[27] + -6.062177826491025 * sp[30];
    A[104] = 4.166666666666618 * sp[33] + 0.416666666666611 * sp[34] + 8.416666666666657 * sp[28] + 2.749999999999959 * sp[31] + 7.083333333333249 * sp[34] + -0.4166666666666554 * sp[35] + 13.58333333333326 * sp[29] + -8.916666666666863 * sp[32] + 7.083333333333417 * sp[28] + 7.916666666666643 * sp[29] + 1.916666666666718 * sp[26] + 2.749999999999956 * sp[27] + 7.083333333333377 * sp[31] + 7.083333333333326 * sp[32] + 3.08333333333335 * sp[27] + -3.333333333333447 * sp[30];
    A[105] = 2.600000000000012 * sp[33] + 1.466666666666686 * sp[34] + -4.933333333333356 * sp[28] + -2.133333333333325 * sp[31] + 1.216666666666668 * sp[34] + 0.3083333333333405 * sp[35] + -1.058333333333326 * sp[29] + -0.8999999999999939 * sp[32] + 1.216666666666667 * sp[28] + 2.375000000000028 * sp[29] + -7.258333333333363 * sp[26] + -2.133333333333328 * sp[27] + 1.216666666666664 * sp[31] + 1.216666666666679 * sp[32] + -3.383333333333328 * sp[27] + -1.266666666666658 * sp[30];
    A[106] = -1.200000000000006 * sp[33] + -0.9333333333333437 * sp[34] + 2.53333333333335 * sp[28] + -3.066666666666685 * sp[31] + -0.4333333333333302 * sp[34] + 0.2166666666666575 * sp[35] + 0.2833333333333323 * sp[29] + -1.199999999999991 * sp[32] + -0.4333333333333311 * sp[28] + -1.58333333333336 * sp[29] + 3.68333333333336 * sp[26] + -3.066666666666686 * sp[27] + -0.4333333333333266 * sp[31] + -0.4333333333333468 * sp[32] + 1.433333333333335 * sp[27] + -1.633333333333326 * sp[30];
    A[107] = 0.600000000000003 * sp[33] + 0.1333333333333359 * sp[34] + -0.9333333333333422 * sp[28] + 0.5333333333333374 * sp[31] + 0.3833333333333363 * sp[34] + -0.4416666666666573 * sp[35] + -0.1416666666666695 * sp[29] + 0.09999999999999376 * sp[32] + 0.3833333333333354 * sp[28] + 0.9583333333333414 * sp[29] + -1.67500000000001 * sp[26] + 0.5333333333333425 * sp[27] + 0.3833333333333364 * sp[31] + 0.3833333333333414 * sp[32] + -0.8833333333333369 * sp[27] + 0.06666666666665966 * sp[30];
    A[108] = -2.600000000000008 * sp[33] + -1.133333333333349 * sp[34] + -7.533333333333333 * sp[28] + -3.933333333333342 * sp[31] + -1.383333333333338 * sp[34] + -0.2250000000000075 * sp[35] + -5.258333333333333 * sp[29] + -2.86666666666667 * sp[32] + -1.383333333333334 * sp[28] + -2.291666666666682 * sp[29] + 0.9416666666666662 * sp[26] + 0.03333333333332594 * sp[27] + -1.383333333333335 * sp[31] + -1.383333333333341 * sp[32] + -1.383333333333333 * sp[27] + -1.016666666666672 * sp[30];
    A[109] = 1.200000000000002 * sp[33] + 0.2666666666666755 * sp[34] + 3.73333333333333 * sp[28] + 5.866666666666658 * sp[31] + 0.7666666666666726 * sp[34] + -0.3833333333333203 * sp[35] + 3.016666666666667 * sp[29] + 3.733333333333335 * sp[32] + 0.7666666666666668 * sp[28] + 1.416666666666675 * sp[29] + -0.3833333333333352 * sp[26] + 0.2666666666666623 * sp[27] + 0.766666666666671 * sp[31] + 0.7666666666666757 * sp[32] + 0.766666666666669 * sp[27] + 1.200000000000003 * sp[30];
    A[110] = -0.5999999999999996 * sp[33] + -0.4666666666666719 * sp[34] + -1.533333333333327 * sp[28] + -1.933333333333334 * sp[31] + -0.2166666666666642 * sp[34] + 0.3583333333333236 * sp[35] + -1.008333333333328 * sp[29] + -0.8666666666666752 * sp[32] + -0.2166666666666625 * sp[28] + -1.041666666666681 * sp[29] + 0.5250000000000128 * sp[26] + -0.3000000000000148 * sp[27] + -0.2166666666666614 * sp[31] + -0.2166666666666761 * sp[32] + -0.2166666666666568 * sp[27] + -0.1833333333333493 * sp[30];
    A[111] = -5.866666666666672 * sp[33] + -7.933333333333318 * sp[34] + -2.600000000000009 * sp[28] + -3.133333333333333 * sp[31] + -3.433333333333325 * sp[34] + -5.083333333333318 * sp[35] + -0.6833333333333306 * sp[29] + -1.399999999999995 * sp[32] + -2.766666666666677 * sp[28] + -1.683333333333312 * sp[29] + -4.216666666666677 * sp[26] + -3.13333333333333 * sp[27] + -2.299999999999996 * sp[31] + -2.233333333333319 * sp[32] + -2.299999999999997 * sp[27] + -2.016666666666661 * sp[30];
    A[112] = 11.73333333333335 * sp[33] + 5.866666666666653 * sp[34] + 5.86666666666669 * sp[28] + 4.266666666666655 * sp[31] + 5.866666666666653 * sp[34] + 3.833333333333321 * sp[35] + 1.366666666666656 * sp[29] + 1.799999999999986 * sp[32] + 5.86666666666669 * sp[28] + 1.366666666666656 * sp[29] + 8.766666666666698 * sp[26] + 4.266666666666658 * sp[27] + 4.266666666666655 * sp[31] + 1.799999999999986 * sp[32] + 4.266666666666658 * sp[27] + 2.533333333333315 * sp[30];
    A[113] = -5.866666666666678 * sp[33] + 2.066666666666682 * sp[34] + -3.266666666666685 * sp[28] + 1.533333333333355 * sp[31] + -2.433333333333329 * sp[34] + 0.4166666666666574 * sp[35] + -0.5166666666666625 * sp[29] + 0.5999999999999986 * sp[32] + -3.100000000000013 * sp[28] + 3.150000000000013 * sp[29] + -4.716666666666693 * sp[26] + 1.533333333333353 * sp[27] + -1.966666666666658 * sp[31] + 1.433333333333322 * sp[32] + -1.966666666666665 * sp[27] + 0.8166666666666683 * sp[30];
    A[114] = 5.656854249492421 * sp[33] + 1.88561808316412 * sp[34] + -9.428090415820643 * sp[28] + -20.74179891480541 * sp[31] + 3.299831645537252 * sp[34] + 2.592724864350713 * sp[35] + -3.064129385141678 * sp[29] + -8.485281374238507 * sp[32] + 3.299831645537244 * sp[28] + -3.064129385141741 * sp[29] + -14.37783788412647 * sp[26] + -20.74179891480543 * sp[27] + 3.299831645537248 * sp[31] + 0.4714045207910851 * sp[32] + -8.013876853447504 * sp[27] + -11.78511301977573 * sp[30];
    A[115] = 10.39230484541329 * sp[33] + -30.02221399786049 * sp[34] + -16.16580753730956 * sp[28] + -36.95041722813611 * sp[31] + -1.443375672974015 * sp[34] + -19.19689645055495 * sp[35] + -5.34048999000401 * sp[29] + -15.58845726811981 * sp[32] + -1.443375672974104 * sp[28] + -12.26869322027949 * sp[29] + -26.12509968083058 * sp[26] + -36.95041722813611 * sp[27] + -1.443375672974065 * sp[31] + -10.10362971081834 * sp[32] + -15.29978213352504 * sp[27] + -21.9393102292057 * sp[30];
    A[116] = -2.000000000000023 * sp[33] + -2.666666666666662 * sp[34] + 5.333333333333357 * sp[28] + 9.333333333333353 * sp[31] + -0.1666666666666557 * sp[34] + -8.416666666666659 * sp[35] + 1.583333333333302 * sp[29] + 2.999999999999942 * sp[32] + -0.1666666666666499 * sp[28] + 3.583333333333323 * sp[29] + 5.583333333333367 * sp[26] + 9.333333333333393 * sp[27] + -0.1666666666666368 * sp[31] + -1.166666666666715 * sp[32] + 1.833333333333309 * sp[27] + 3.666666666666595 * sp[30];
    A[117] = 1.885618083164142 * sp[34] + 24.5130350811337 * sp[28] + 13.19932658214898 * sp[31] + -0.9428090415820881 * sp[34] + 0.4714045207910273 * sp[35] + 11.78511301977578 * sp[29] + 5.656854249492404 * sp[32] + -0.9428090415820765 * sp[28] + 0.4714045207910826 * sp[29] + 11.78511301977581 * sp[26] + 13.199326582149 * sp[27] + -0.9428090415820982 * sp[31] + -0.9428090415820514 * sp[32] + 10.37089945740266 * sp[27] + 8.013876853447579 * sp[30];
    A[118] = -20.78460969082659 * sp[33] + -10.3923048454134 * sp[34] + -10.39230484541326 * sp[28] + 17.32050807568865 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137781 * sp[35] + -17.3205080756888 * sp[29] + 3.464101615137646 * sp[32] + -10.39230484541327 * sp[28] + -17.32050807568893 * sp[29] + 24.24871130596431 * sp[26] + 17.32050807568862 * sp[27] + -10.39230484541326 * sp[31] + -10.39230484541332 * sp[32] + 3.464101615137738 * sp[27] + 7.794228634059805 * sp[30];
    A[119] = 3.333333333333353 * sp[34] + -12.6666666666667 * sp[28] + -4.666666666666648 * sp[31] + -1.666666666666707 * sp[34] + 0.8333333333333242 * sp[35] + -7.166666666666669 * sp[29] + -7.999999999999925 * sp[32] + -1.666666666666704 * sp[28] + 0.8333333333334174 * sp[29] + -7.166666666666758 * sp[26] + -4.666666666666632 * sp[27] + -1.666666666666734 * sp[31] + -1.666666666666648 * sp[32] + -3.6666666666667 * sp[27] + -5.833333333333231 * sp[30];
    A[120] = -1.50833333333334 * sp[33] + -0.7333333333333422 * sp[34] + 2.80000000000001 * sp[28] + 0.9833333333333261 * sp[31] + 0.3083333333333479 * sp[34] + 0.7625000000000104 * sp[35] + -2.887500000000012 * sp[29] + -0.7166666666666609 * sp[32] + 0.3083333333333363 * sp[28] + -1.187500000000014 * sp[29] + 4.295833333333356 * sp[26] + 0.9833333333333314 * sp[27] + 0.3083333333333468 * sp[31] + 0.3083333333333421 * sp[32] + -1.391666666666683 * sp[27] + -0.4083333333333338 * sp[30];
    A[121] = 1.016666666666668 * sp[33] + 1.050000000000004 * sp[34] + -1.850000000000007 * sp[28] + 2.116666666666682 * sp[31] + -0.366666666666687 * sp[34] + -1.275000000000009 * sp[35] + 2.025000000000006 * sp[29] + -2.483333333333345 * sp[32] + -0.3666666666666703 * sp[28] + 1.958333333333347 * sp[29] + -3.008333333333353 * sp[26] + 2.11666666666668 * sp[27] + -0.3666666666666815 * sp[31] + -0.3666666666666726 * sp[32] + 0.8666666666666748 * sp[27] + -1.266666666666679 * sp[30];
    A[122] = -0.09166666666667111 * sp[33] + -0.4000000000000071 * sp[34] + 0.466666666666672 * sp[28] + -1.183333333333337 * sp[31] + -0.1083333333333406 * sp[34] + 0.6374999999999883 * sp[35] + -0.5124999999999975 * sp[29] + 2.116666666666679 * sp[32] + -0.1083333333333348 * sp[28] + -1.145833333333341 * sp[29] + 0.8375000000000079 * sp[26] + -1.183333333333339 * sp[27] + -0.108333333333337 * sp[31] + -0.1083333333333398 * sp[32] + -0.1416666666666673 * sp[27] + 1.008333333333342 * sp[30];
    A[123] = 1.091666666666675 * sp[33] + 0.3583333333333455 * sp[34] + 3.225000000000008 * sp[28] + 1.34166666666668 * sp[31] + -0.01666666666666289 * sp[34] + -0.3874999999999975 * sp[35] + 0.9625000000000006 * sp[29] + 0.5583333333333393 * sp[32] + -0.01666666666666672 * sp[28] + 0.7291666666666781 * sp[29] + -1.054166666666669 * sp[26] + -0.3083333333333279 * sp[27] + -0.01666666666666833 * sp[31] + -0.01666666666666848 * sp[32] + -0.01666666666666893 * sp[27] + 0.09166666666666919 * sp[30];
    A[124] = -0.1833333333333382 * sp[33] + -0.3000000000000127 * sp[34] + -0.8666666666666717 * sp[28] + -1.933333333333338 * sp[31] + -0.2166666666666833 * sp[34] + 0.5249999999999839 * sp[35] + -1.008333333333348 * sp[29] + -1.533333333333357 * sp[32] + -0.2166666666666679 * sp[28] + -1.041666666666677 * sp[29] + 0.3583333333333346 * sp[26] + -0.4666666666666703 * sp[27] + -0.2166666666666752 * sp[31] + -0.2166666666666747 * sp[32] + -0.2166666666666751 * sp[27] + -0.6000000000000137 * sp[30];
    A[125] = 0.5083333333333313 * sp[33] + 0.775000000000003 * sp[34] + 0.9749999999999953 * sp[28] + 0.5916666666666676 * sp[31] + -0.1833333333333421 * sp[34] + -1.012499999999999 * sp[35] + 0.1708333333333183 * sp[29] + 0.9749999999999994 * sp[32] + -0.1833333333333359 * sp[28] + 1.604166666666675 * sp[29] + -1.012500000000011 * sp[26] + 0.7750000000000078 * sp[27] + -0.18333333333334 * sp[31] + -0.1833333333333331 * sp[32] + -0.1833333333333441 * sp[27] + 0.5083333333333359 * sp[30];
    A[126] = 2.183333333333341 * sp[33] + 2.424999999999999 * sp[34] + 1.091666666666673 * sp[28] + 0.8583333333333339 * sp[31] + -0.2416666666666683 * sp[34] + 1.625000000000021 * sp[35] + -1.075 * sp[29] + 0.1583333333333449 * sp[32] + 1.091666666666676 * sp[28] + 0.2583333333333242 * sp[29] + 1.691666666666678 * sp[26] + 0.8583333333333337 * sp[27] + -0.4750000000000057 * sp[31] + 0.1583333333333411 * sp[32] + -0.4750000000000058 * sp[27] + -0.0333333333333318 * sp[30];
    A[127] = -5.866666666666678 * sp[33] + -2.433333333333329 * sp[34] + -3.100000000000013 * sp[28] + -1.966666666666658 * sp[31] + 2.066666666666682 * sp[34] + 0.4166666666666574 * sp[35] + 3.150000000000013 * sp[29] + 1.433333333333322 * sp[32] + -3.266666666666685 * sp[28] + -0.5166666666666625 * sp[29] + -4.716666666666693 * sp[26] + -1.966666666666665 * sp[27] + 1.533333333333355 * sp[31] + 0.5999999999999986 * sp[32] + 1.533333333333353 * sp[27] + 0.8166666666666683 * sp[30];
    A[128] = 3.683333333333338 * sp[33] + -1.825000000000015 * sp[34] + 2.175000000000008 * sp[28] + -1.05833333333335 * sp[31] + -1.825000000000015 * sp[34] + 2.70833333333334 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666677 * sp[32] + 2.175000000000008 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666689 * sp[26] + -1.058333333333345 * sp[27] + -1.05833333333335 * sp[31] + 1.241666666666677 * sp[32] + -1.058333333333345 * sp[27] + 0.6333333333333423 * sp[30];
    A[129] = -1.649915822768645 * sp[33] + 4.949747468305825 * sp[34] + 3.535533905932746 * sp[28] + 11.5494107593803 * sp[31] + -0.4714045207910645 * sp[34] + -13.0814754519512 * sp[35] + -3.181980515339478 * sp[29] + -11.07800623858925 * sp[32] + -0.4714045207910409 * sp[28] + 6.246109900481178 * sp[29] + 4.831896338108091 * sp[26] + 11.54941075938031 * sp[27] + -0.4714045207910435 * sp[31] + -6.128258770283465 * sp[32] + -1.885618083164157 * sp[27] + -5.892556509887937 * sp[30];
    A[130] = -13.13471862406397 * sp[33] + 12.12435565298216 * sp[34] + 5.196152422706665 * sp[28] + 17.03183294109401 * sp[31] + -0.7216878364868773 * sp[34] + -6.278684177437071 * sp[35] + -4.546633369868304 * sp[29] + -12.41303078757693 * sp[32] + -0.721687836486977 * sp[28] + 9.021097956087885 * sp[29] + 7.289047148519061 * sp[26] + 17.03183294109402 * sp[27] + -0.7216878364869284 * sp[31] + -5.051814855409193 * sp[32] + -2.453738644055949 * sp[27] + -7.07254079757297 * sp[30];
    A[131] = 3.083333333333326 * sp[33] + -9.500000000000027 * sp[34] + -3.500000000000004 * sp[28] + -11.33333333333335 * sp[31] + -1.583333333333422 * sp[34] + 13.37500000000006 * sp[35] + 3.375000000000066 * sp[29] + 17.66666666666675 * sp[32] + -1.583333333333356 * sp[28] + -8.458333333333343 * sp[29] + -4.458333333333359 * sp[26] + -11.33333333333337 * sp[27] + -1.583333333333394 * sp[31] + 3.916666666666722 * sp[32] + 2.416666666666714 * sp[27] + 8.583333333333405 * sp[30];
    A[132] = -2.357022603955141 * sp[33] + -2.121320343559625 * sp[34] + -13.43502884254443 * sp[28] + -5.421151989096901 * sp[31] + 1.649915822768712 * sp[34] + 2.121320343559717 * sp[35] + 3.535533905932831 * sp[29] + 3.064129385141747 * sp[32] + 1.649915822768626 * sp[28] + -2.592724864350687 * sp[29] + -1.178511301977581 * sp[26] + -5.421151989096927 * sp[27] + 1.649915822768675 * sp[31] + 1.649915822768651 * sp[32] + 3.064129385141797 * sp[27] + 1.88561808316417 * sp[30];
    A[133] = 10.39230484541331 * sp[33] + 3.03108891324561 * sp[34] + 3.031088913245566 * sp[28] + -10.82531754730541 * sp[31] + -1.299038105676699 * sp[34] + -2.598076211353374 * sp[35] + 4.330127018922271 * sp[29] + 4.763139720814371 * sp[32] + -1.299038105676677 * sp[28] + 4.330127018922285 * sp[29] + -16.45448267190438 * sp[26] + -10.82531754730542 * sp[27] + -1.29903810567672 * sp[31] + -1.299038105676714 * sp[32] + 0.4330127018922756 * sp[27] + 2.598076211353326 * sp[30];
    A[134] = -4.166666666666638 * sp[33] + -3.749999999999963 * sp[34] + 4.250000000000034 * sp[28] + 1.916666666666705 * sp[31] + 2.916666666666839 * sp[34] + 3.750000000000124 * sp[35] + -2.249999999999933 * sp[29] + -13.08333333333321 * sp[32] + 2.9166666666667 * sp[28] + -4.583333333333351 * sp[29] + 9.416666666666737 * sp[26] + 1.916666666666674 * sp[27] + 2.916666666666778 * sp[31] + 2.916666666666734 * sp[32] + -1.083333333333296 * sp[27] + -6.66666666666662 * sp[30];
    A[135] = 1.649915822768648 * sp[33] + 3.064129385141741 * sp[34] + -1.649915822768629 * sp[28] + -1.649915822768631 * sp[31] + 0.4714045207910273 * sp[34] + 1.767766952966346 * sp[35] + 5.06759859850361 * sp[29] + -0.2357022603955496 * sp[32] + -5.185449728701356 * sp[28] + -3.889087296526053 * sp[29] + 10.72445284799599 * sp[26] + 4.006938426723752 * sp[27] + -5.185449728701383 * sp[31] + -5.185449728701424 * sp[32] + 17.44196726926821 * sp[27] + 5.892556509887863 * sp[30];
    A[136] = 3.77123616632826 * sp[33] + -3.771236166328295 * sp[34] + 0.9428090415820849 * sp[28] + 0.9428090415820771 * sp[31] + 6.128258770283455 * sp[34] + 1.178511301977608 * sp[35] + -5.421151989096847 * sp[29] + 12.25651754056689 * sp[32] + 3.299831645537228 * sp[28] + -1.64991582276857 * sp[29] + -2.592724864350695 * sp[26] + 3.771236166328277 * sp[27] + 3.299831645537251 * sp[31] + 3.299831645537293 * sp[32] + -8.956685895029631 * sp[27] + 11.78511301977581 * sp[30];
    A[137] = 4.006938426723792 * sp[33] + 10.13519719700724 * sp[34] + -4.006938426723807 * sp[28] + -4.006938426723791 * sp[31] + 5.185449728701373 * sp[34] + 7.660323462854305 * sp[35] + -3.181980515339495 * sp[29] + -16.7348604880817 * sp[32] + -0.4714045207910307 * sp[28] + 2.003469213361893 * sp[29] + 2.47487373415292 * sp[26] + 1.649915822768595 * sp[27] + -0.4714045207910284 * sp[31] + -0.4714045207910381 * sp[32] + 3.299831645537234 * sp[27] + -5.89255650988791 * sp[30];
    A[138] = -7.542472332656567 * sp[33] + -7.778174593052068 * sp[34] + -8.720983634634145 * sp[28] + -7.778174593052059 * sp[31] + -8.720983634634127 * sp[34] + -8.249579113843062 * sp[35] + -12.96362432175341 * sp[29] + -11.07800623858926 * sp[32] + 4.006938426723765 * sp[28] + 4.478342947514809 * sp[29] + -0.2357022603955121 * sp[26] + 0.2357022603955192 * sp[27] + 4.006938426723776 * sp[31] + 4.006938426723806 * sp[32] + 4.006938426723768 * sp[27] + 2.357022603955168 * sp[30];
    A[139] = 8.013876853447588 * sp[33] + 13.19932658214896 * sp[34] + 5.65685424949239 * sp[28] + 13.19932658214892 * sp[31] + 10.37089945740276 * sp[34] + 11.78511301977585 * sp[35] + 11.78511301977581 * sp[29] + 24.51303508113374 * sp[32] + -0.9428090415820536 * sp[28] + 0.4714045207910482 * sp[29] + 0.4714045207910345 * sp[26] + 1.88561808316416 * sp[27] + -0.9428090415820456 * sp[31] + -0.9428090415820688 * sp[32] + -0.9428090415820389 * sp[27];
    A[140] = 1.885618083164129 * sp[33] + -5.42115198909691 * sp[34] + 3.064129385141716 * sp[28] + -5.421151989096911 * sp[31] + 3.064129385141721 * sp[34] + -1.178511301977587 * sp[35] + 3.535533905932771 * sp[29] + -13.43502884254444 * sp[32] + 1.649915822768605 * sp[28] + -2.592724864350657 * sp[29] + 2.121320343559636 * sp[26] + -2.121320343559625 * sp[27] + 1.649915822768616 * sp[31] + 1.649915822768645 * sp[32] + 1.649915822768613 * sp[27] + -2.357022603955114 * sp[30];
    A[141] = -4.006938426723776 * sp[33] + -5.18544972870135 * sp[34] + -5.185449728701388 * sp[28] + -5.185449728701376 * sp[31] + -6.835365551469938 * sp[34] + -18.97403196183912 * sp[35] + -4.360491817317055 * sp[29] + -10.8423039781938 * sp[32] + 5.892556509887898 * sp[28] + 5.067598598503546 * sp[29] + 8.367430244040804 * sp[26] + 7.542472332656487 * sp[27] + 9.192388155425125 * sp[31] + 5.421151989096768 * sp[32] + 9.192388155425128 * sp[27] + 5.892556509887863 * sp[30];
    A[142] = 5.656854249492421 * sp[33] + 3.299831645537252 * sp[34] + 3.299831645537244 * sp[28] + 3.299831645537248 * sp[31] + 1.88561808316412 * sp[34] + 2.592724864350713 * sp[35] + -3.064129385141741 * sp[29] + 0.4714045207910851 * sp[32] + -9.428090415820643 * sp[28] + -3.064129385141678 * sp[29] + -14.37783788412647 * sp[26] + -8.013876853447504 * sp[27] + -20.74179891480541 * sp[31] + -8.485281374238507 * sp[32] + -20.74179891480543 * sp[27] + -11.78511301977573 * sp[30];
    A[143] = -1.649915822768645 * sp[33] + -0.4714045207910645 * sp[34] + -0.4714045207910409 * sp[28] + -0.4714045207910435 * sp[31] + 4.949747468305825 * sp[34] + -13.0814754519512 * sp[35] + 6.246109900481178 * sp[29] + -6.128258770283465 * sp[32] + 3.535533905932746 * sp[28] + -3.181980515339478 * sp[29] + 4.831896338108091 * sp[26] + -1.885618083164157 * sp[27] + 11.5494107593803 * sp[31] + -11.07800623858925 * sp[32] + 11.54941075938031 * sp[27] + -5.892556509887937 * sp[30];
    A[144] = 26.66666666666686 * sp[33] + 33.3333333333335 * sp[34] + -6.666666666666689 * sp[28] + -6.666666666666705 * sp[31] + 33.3333333333335 * sp[34] + 113.3333333333338 * sp[35] + -6.666666666666563 * sp[29] + 33.33333333333338 * sp[32] + -6.666666666666689 * sp[28] + -6.666666666666563 * sp[29] + 33.33333333333327 * sp[26] + 33.33333333333333 * sp[27] + -6.666666666666705 * sp[31] + 33.33333333333338 * sp[32] + 33.33333333333333 * sp[27] + 66.66666666666656 * sp[30];
    A[145] = 4.082482904638951 * sp[33] + -4.082482904638407 * sp[34] + -28.57738033247058 * sp[28] + -28.57738033247053 * sp[31] + 8.164965809277515 * sp[34] + 14.28869016623513 * sp[35] + -34.70110468942831 * sp[29] + -4.082482904638731 * sp[32] + 8.164965809277252 * sp[28] + 14.28869016623506 * sp[29] + 63.27848502189866 * sp[26] + 69.40220937885668 * sp[27] + 8.16496580927695 * sp[31] + 57.15476066494027 * sp[32] + 57.15476066494082 * sp[27] + 102.0620726159656 * sp[30];
    A[146] = 25.92724864350682 * sp[33] + 16.49915822768624 * sp[34] + -25.92724864350699 * sp[28] + -25.92724864350686 * sp[31] + 37.71236166328272 * sp[34] + -64.81812160876702 * sp[35] + -36.53385036130529 * sp[29] + -124.9221980096239 * sp[32] + 9.428090415820661 * sp[28] + 20.03469213361894 * sp[29] + -8.249579113843113 * sp[26] + 2.35702260395508 * sp[27] + 9.428090415820746 * sp[31] + -18.85618083164131 * sp[32] + -18.85618083164136 * sp[27] + -58.92556509887899 * sp[30];
    A[147] = -33.33333333333349 * sp[33] + -26.66666666666676 * sp[34] + 13.33333333333358 * sp[28] + 13.33333333333354 * sp[31] + -46.66666666666695 * sp[34] + -36.66666666666691 * sp[35] + 3.333333333333307 * sp[29] + 13.33333333333333 * sp[32] + -6.666666666666694 * sp[28] + 3.333333333333185 * sp[29] + -36.66666666666669 * sp[26] + -26.66666666666683 * sp[27] + -6.666666666666782 * sp[31] + -6.666666666666861 * sp[32] + -46.66666666666684 * sp[27] + -33.33333333333362 * sp[30];
    A[148] = -36.74234614174796 * sp[33] + -24.49489742783199 * sp[34] + -24.49489742783203 * sp[28] + -36.74234614174772 * sp[34] + -30.61862178478959 * sp[35] + -6.12372435695822 * sp[29] + 36.74234614174773 * sp[28] + 42.86607049870582 * sp[29] + -30.61862178478965 * sp[26] + -24.49489742783147 * sp[27] + 36.74234614174783 * sp[31] + 36.7423461417481 * sp[32] + -12.24744871391606 * sp[27] + -36.74234614174713 * sp[30];
    A[149] = -58.92556509887923 * sp[33] + -47.14045207910332 * sp[34] + -18.85618083164126 * sp[28] + -4.714045207910191 * sp[31] + -82.495791138431 * sp[34] + -64.81812160876723 * sp[35] + -22.3917147375741 * sp[29] + 80.13876853447557 * sp[32] + -11.78511301977581 * sp[28] + 5.892556509887648 * sp[29] + -8.249579113842987 * sp[26] + 9.428090415820513 * sp[27] + -11.78511301977596 * sp[31] + -11.78511301977611 * sp[32] + 16.49915822768607 * sp[27] + 54.21151989096815 * sp[30];
    A[150] = 10.96965511460293 * sp[33] + 0.1443375672973413 * sp[34] + 0.7216878364870857 * sp[28] + 0.7216878364870798 * sp[31] + 0.7216878364869752 * sp[34] + -1.732050807568894 * sp[35] + 11.54700538379247 * sp[29] + 5.051814855409184 * sp[32] + -10.5366424127107 * sp[28] + -8.660254037844483 * sp[29] + 18.47520861406806 * sp[26] + 7.649891066762525 * sp[27] + -10.53664241271074 * sp[31] + -10.53664241271079 * sp[32] + 29.30052616137358 * sp[27] + 10.96965511460285 * sp[30];
    A[151] = -8.948929172439174 * sp[33] + -3.175426480542823 * sp[34] + 1.443375672974014 * sp[28] + 1.443375672973947 * sp[31] + -1.443375672973963 * sp[34] + 2.020725942163682 * sp[35] + -7.216878364870303 * sp[29] + 10.10362971081836 * sp[32] + 3.752776749732562 * sp[28] + -1.443375672973955 * sp[29] + -3.752776749732616 * sp[26] + 4.907477288111845 * sp[27] + 3.752776749732618 * sp[31] + 3.75277674973267 * sp[32] + -12.41303078757702 * sp[27] + 14.14508159514585 * sp[30];
    A[152] = -0.577350269189568 * sp[33] + 4.474464586219653 * sp[34] + -0.7216878364870516 * sp[28] + -0.7216878364870305 * sp[31] + -0.721687836486982 * sp[34] + 4.041451884327479 * sp[35] + -5.051814855409194 * sp[32] + -3.319764047840363 * sp[28] + -2.886751345948163 * sp[29] + 6.92820323027554 * sp[26] + 6.206515393788466 * sp[27] + -3.319764047840347 * sp[31] + -3.319764047840345 * sp[32] + 7.649891066762572 * sp[27] + -0.5773502691896146 * sp[30];
    A[153] = -5.917840259193747 * sp[33] + -0.8660254037844877 * sp[34] + -11.83568051838745 * sp[28] + -0.8660254037845783 * sp[31] + 0.7216878364869923 * sp[34] + -2.237232293109841 * sp[35] + 18.25870226312187 * sp[29] + 10.96965511460281 * sp[32] + 11.98001808568476 * sp[28] + 13.35122497501013 * sp[29] + 2.670244995002064 * sp[26] + 4.04145188432741 * sp[27] + 11.98001808568476 * sp[31] + 11.98001808568479 * sp[32] + 11.98001808568476 * sp[27] + 8.804591605141807 * sp[30];
    A[154] = -1.154700538379172 * sp[33] + 4.618802153517112 * sp[34] + -5.196152422706532 * sp[28] + 4.618802153517141 * sp[31] + -1.443375672973972 * sp[34] + 5.917840259193776 * sp[35] + -14.86676943163276 * sp[29] + -16.16580753730939 * sp[32] + -6.639528095680715 * sp[28] + -7.938566201357379 * sp[29] + -1.010362971081855 * sp[26] + -2.309401076758483 * sp[27] + -6.639528095680678 * sp[31] + -6.63952809568069 * sp[32] + -6.639528095680663 * sp[27] + -10.3923048454132 * sp[30];
    A[155] = -4.47446458621957 * sp[33] + -3.752776749732504 * sp[34] + -8.948929172439181 * sp[28] + -3.752776749732487 * sp[31] + -0.7216878364869789 * sp[34] + -0.07216878364873935 * sp[35] + 0.2165063509461903 * sp[29] + 5.196152422706637 * sp[32] + 1.876388374866266 * sp[28] + -1.804219591217512 * sp[29] + 1.948557158514961 * sp[26] + -1.732050807568799 * sp[27] + 1.876388374866292 * sp[31] + 1.876388374866327 * sp[32] + 1.876388374866291 * sp[27] + 1.587713240271555 * sp[30];
    A[156] = 2.742413778650681 * sp[33] + 0.7216878364868515 * sp[34] + 0.721687836487015 * sp[28] + 0.7216878364869777 * sp[31] + 17.89785834487833 * sp[34] + 24.75389279150508 * sp[35] + 2.525907427704556 * sp[29] + 5.051814855409161 * sp[32] + 10.9696551146029 * sp[28] + 9.165435523385241 * sp[29] + 18.11436469582451 * sp[26] + 16.31014510460691 * sp[27] + 19.9185842870421 * sp[31] + 19.34123401785236 * sp[32] + 19.91858428704211 * sp[27] + 17.46484564298616 * sp[30];
    A[157] = 10.39230484541329 * sp[33] + -1.443375672974015 * sp[34] + -1.443375672974104 * sp[28] + -1.443375672974065 * sp[31] + -30.02221399786049 * sp[34] + -19.19689645055495 * sp[35] + -12.26869322027949 * sp[29] + -10.10362971081834 * sp[32] + -16.16580753730956 * sp[28] + -5.34048999000401 * sp[29] + -26.12509968083058 * sp[26] + -15.29978213352504 * sp[27] + -36.95041722813611 * sp[31] + -15.58845726811981 * sp[32] + -36.95041722813611 * sp[27] + -21.9393102292057 * sp[30];
    A[158] = -13.13471862406397 * sp[33] + -0.7216878364868773 * sp[34] + -0.721687836486977 * sp[28] + -0.7216878364869284 * sp[31] + 12.12435565298216 * sp[34] + -6.278684177437071 * sp[35] + 9.021097956087885 * sp[29] + -5.051814855409193 * sp[32] + 5.196152422706665 * sp[28] + -4.546633369868304 * sp[29] + 7.289047148519061 * sp[26] + -2.453738644055949 * sp[27] + 17.03183294109401 * sp[31] + -12.41303078757693 * sp[32] + 17.03183294109402 * sp[27] + -7.07254079757297 * sp[30];
    A[159] = 4.082482904638951 * sp[33] + 8.164965809277515 * sp[34] + 8.164965809277252 * sp[28] + 8.16496580927695 * sp[31] + -4.082482904638407 * sp[34] + 14.28869016623513 * sp[35] + 14.28869016623506 * sp[29] + 57.15476066494027 * sp[32] + -28.57738033247058 * sp[28] + -34.70110468942831 * sp[29] + 63.27848502189866 * sp[26] + 57.15476066494082 * sp[27] + -28.57738033247053 * sp[31] + -4.082482904638731 * sp[32] + 69.40220937885668 * sp[27] + 102.0620726159656 * sp[30];
    A[160] = 189.9999999999995 * sp[33] + 57.49999999999883 * sp[34] + 12.49999999999979 * sp[28] + 12.49999999999929 * sp[31] + 57.49999999999883 * sp[34] + 132.4999999999988 * sp[35] + 12.49999999999966 * sp[29] + 87.49999999999915 * sp[32] + 12.49999999999979 * sp[28] + 12.49999999999966 * sp[29] + 132.4999999999999 * sp[26] + 132.5 * sp[27] + 12.49999999999929 * sp[31] + 87.49999999999915 * sp[32] + 132.5 * sp[27] + 189.9999999999999 * sp[30];
    A[161] = -31.75426480542917 * sp[33] + 105.3664241271069 * sp[34] + -7.216878364870597 * sp[28] + -7.216878364870436 * sp[31] + -7.216878364869801 * sp[34] + 57.73502691896259 * sp[35] + -28.86751345948152 * sp[29] + -50.51814855409195 * sp[32] + 1.443375672974018 * sp[28] + 23.09401076758514 * sp[29] + 5.77350269189632 * sp[26] + 27.42413778650719 * sp[27] + 1.443375672974261 * sp[31] + 10.10362971081858 * sp[32] + -15.87713240271479 * sp[27] + -31.75426480542926 * sp[30];
    A[162] = 28.57738033247005 * sp[33] + -4.082482904639258 * sp[34] + 69.40220937885675 * sp[28] + -4.082482904638921 * sp[31] + 8.164965809276685 * sp[34] + -22.4536559755128 * sp[35] + -22.45365597551278 * sp[29] + -28.57738033247049 * sp[32] + 8.164965809277358 * sp[28] + 26.53613888015089 * sp[29] + -71.44345083117614 * sp[26] + -53.0722777603026 * sp[27] + 8.164965809277097 * sp[31] + 8.164965809276961 * sp[32] + -89.81462390205024 * sp[27] + -69.40220937885726 * sp[30];
    A[163] = -67.50000000000048 * sp[33] + 7.500000000000032 * sp[34] + 7.499999999999023 * sp[28] + 52.50000000000023 * sp[31] + 3.750000000000035 * sp[35] + 48.74999999999953 * sp[29] + -22.49999999999963 * sp[32] + 90.00000000000024 * sp[28] + 93.75000000000045 * sp[29] + -41.24999999999975 * sp[26] + -37.49999999999945 * sp[27] + 90.00000000000037 * sp[31] + 90.00000000000071 * sp[32] + -30.00000000000016 * sp[27] + -67.49999999999929 * sp[30];
    A[164] = 50.51814855409167 * sp[33] + -7.216878364871437 * sp[34] + 44.74464586219582 * sp[28] + 105.3664241271055 * sp[31] + 14.43375672973963 * sp[34] + -39.69283100678734 * sp[35] + 72.89047148518968 * sp[29] + 62.06515393788342 * sp[32] + 14.43375672974086 * sp[28] + 46.90970937165672 * sp[29] + -13.71206889325343 * sp[26] + 18.76388374866249 * sp[27] + 14.4337567297404 * sp[31] + 14.43375672974012 * sp[32] + 31.75426480542938 * sp[27] + 50.51814855409125 * sp[30];
    A[165] = -6.833333333333346 * sp[33] + 2.416666666666682 * sp[34] + 0.08333333333332001 * sp[28] + 0.08333333333330037 * sp[31] + 1.583333333333338 * sp[34] + 3.75 * sp[35] + -4.916666666666647 * sp[29] + 0.5833333333333779 * sp[32] + 0.08333333333333037 * sp[28] + -1.250000000000009 * sp[29] + -5.916666666666699 * sp[26] + -0.9166666666666465 * sp[27] + 0.0833333333333437 * sp[31] + 0.08333333333338611 * sp[32] + -10.91666666666671 * sp[27] + -1.833333333333291 * sp[30];
    A[166] = 11.1666666666667 * sp[33] + -8.166666666666712 * sp[34] + 3.166666666666703 * sp[28] + 3.166666666666733 * sp[31] + 1.833333333333356 * sp[34] + -16.66666666666674 * sp[35] + 10.66666666666669 * sp[29] + -7.833333333333411 * sp[32] + -5.166666666666718 * sp[28] + 3.333333333333383 * sp[29] + 2.666666666666668 * sp[26] + -4.833333333333391 * sp[27] + -5.166666666666707 * sp[31] + -5.166666666666746 * sp[32] + 10.16666666666669 * sp[27] + -17.16666666666675 * sp[30];
    A[167] = 4.833333333333342 * sp[33] + 14.91666666666673 * sp[34] + -4.08333333333337 * sp[28] + -4.083333333333366 * sp[31] + 2.416666666666693 * sp[34] + 22.91666666666679 * sp[35] + -5.750000000000027 * sp[29] + 11.41666666666674 * sp[32] + -4.08333333333337 * sp[28] + -12.08333333333345 * sp[29] + 3.25000000000004 * sp[26] + 4.916666666666712 * sp[27] + -4.083333333333353 * sp[31] + -4.083333333333332 * sp[32] + 1.583333333333347 * sp[27] + 19.83333333333344 * sp[30];
    A[168] = -3.583333333333354 * sp[33] + -7.000000000000024 * sp[34] + -2.666666666666649 * sp[28] + -6.999999999999984 * sp[31] + -4.916666666666697 * sp[34] + -7.708333333333363 * sp[35] + 4.458333333333289 * sp[29] + 2.166666666666598 * sp[32] + 6.583333333333396 * sp[28] + 7.291666666666713 * sp[29] + 5.458333333333387 * sp[26] + 6.16666666666671 * sp[27] + 6.583333333333364 * sp[31] + 6.583333333333314 * sp[32] + 6.583333333333383 * sp[27] + 6.91666666666667 * sp[30];
    A[169] = 9.666666666666703 * sp[33] + 17.33333333333341 * sp[34] + 6.999999999999967 * sp[28] + 17.33333333333335 * sp[31] + 4.833333333333361 * sp[34] + 24.58333333333346 * sp[35] + -11.41666666666666 * sp[29] + -2.666666666666629 * sp[32] + -8.166666666666748 * sp[28] + -15.4166666666668 * sp[29] + -3.416666666666693 * sp[26] + -10.66666666666676 * sp[27] + -8.166666666666721 * sp[31] + -8.166666666666675 * sp[32] + -8.166666666666703 * sp[27] + -18.0000000000001 * sp[30];
    A[170] = 5.583333333333337 * sp[33] + -10.33333333333339 * sp[34] + 10.6666666666667 * sp[28] + -10.33333333333339 * sp[31] + 0.9166666666666845 * sp[34] + -18.95833333333341 * sp[35] + 4.875000000000029 * sp[29] + 0.5 * sp[32] + -2.583333333333355 * sp[28] + 6.04166666666674 * sp[29] + -4.125000000000037 * sp[26] + 4.500000000000076 * sp[27] + -2.583333333333346 * sp[31] + -2.583333333333369 * sp[32] + -2.58333333333335 * sp[27] + 11.08333333333335 * sp[30];
    A[171] = -1.0833333333333 * sp[33] + -2.416666666666613 * sp[34] + -2.4166666666667 * sp[28] + -2.416666666666679 * sp[31] + 12.16666666666668 * sp[34] + 27.95833333333339 * sp[35] + -2.20833333333334 * sp[29] + 8.083333333333396 * sp[32] + -1.833333333333353 * sp[28] + -2.041666666666655 * sp[29] + 1.791666666666695 * sp[26] + 1.58333333333336 * sp[27] + 1.999999999999988 * sp[31] + 14.3333333333335 * sp[32] + 2.0 * sp[27] + 9.416666666666757 * sp[30];
    A[172] = -2.000000000000023 * sp[33] + -0.1666666666666557 * sp[34] + -0.1666666666666499 * sp[28] + -0.1666666666666368 * sp[31] + -2.666666666666662 * sp[34] + -8.416666666666659 * sp[35] + 3.583333333333323 * sp[29] + -1.166666666666715 * sp[32] + 5.333333333333357 * sp[28] + 1.583333333333302 * sp[29] + 5.583333333333367 * sp[26] + 1.833333333333309 * sp[27] + 9.333333333333353 * sp[31] + 2.999999999999942 * sp[32] + 9.333333333333393 * sp[27] + 3.666666666666595 * sp[30];
    A[173] = 3.083333333333326 * sp[33] + -1.583333333333422 * sp[34] + -1.583333333333356 * sp[28] + -1.583333333333394 * sp[31] + -9.500000000000027 * sp[34] + 13.37500000000006 * sp[35] + -8.458333333333343 * sp[29] + 3.916666666666722 * sp[32] + -3.500000000000004 * sp[28] + 3.375000000000066 * sp[29] + -4.458333333333359 * sp[26] + 2.416666666666714 * sp[27] + -11.33333333333335 * sp[31] + 17.66666666666675 * sp[32] + -11.33333333333337 * sp[27] + 8.583333333333405 * sp[30];
    A[174] = 25.92724864350682 * sp[33] + 37.71236166328272 * sp[34] + 9.428090415820661 * sp[28] + 9.428090415820746 * sp[31] + 16.49915822768624 * sp[34] + -64.81812160876702 * sp[35] + 20.03469213361894 * sp[29] + -18.85618083164131 * sp[32] + -25.92724864350699 * sp[28] + -36.53385036130529 * sp[29] + -8.249579113843113 * sp[26] + -18.85618083164136 * sp[27] + -25.92724864350686 * sp[31] + -124.9221980096239 * sp[32] + 2.35702260395508 * sp[27] + -58.92556509887899 * sp[30];
    A[175] = -31.75426480542917 * sp[33] + -7.216878364869801 * sp[34] + 1.443375672974018 * sp[28] + 1.443375672974261 * sp[31] + 105.3664241271069 * sp[34] + 57.73502691896259 * sp[35] + 23.09401076758514 * sp[29] + 10.10362971081858 * sp[32] + -7.216878364870597 * sp[28] + -28.86751345948152 * sp[29] + 5.77350269189632 * sp[26] + -15.87713240271479 * sp[27] + -7.216878364870436 * sp[31] + -50.51814855409195 * sp[32] + 27.42413778650719 * sp[27] + -31.75426480542926 * sp[30];
    A[176] = 53.33333333333346 * sp[33] + 14.16666666666683 * sp[34] + -30.8333333333336 * sp[28] + -30.83333333333351 * sp[31] + 14.16666666666683 * sp[34] + 219.1666666666675 * sp[35] + -30.83333333333356 * sp[29] + 84.16666666666714 * sp[32] + -30.8333333333336 * sp[28] + -30.83333333333356 * sp[29] + 39.1666666666671 * sp[26] + 39.16666666666697 * sp[27] + -30.83333333333351 * sp[31] + 84.16666666666714 * sp[32] + 39.16666666666697 * sp[27] + 153.333333333334 * sp[30];
    A[177] = -58.92556509887913 * sp[33] + -25.92724864350683 * sp[34] + -40.06938426723771 * sp[28] + 2.35702260395527 * sp[31] + -18.85618083164146 * sp[34] + -22.39171473757415 * sp[35] + 5.892556509887871 * sp[29] + -11.78511301977589 * sp[32] + 37.71236166328291 * sp[28] + 34.17682775735003 * sp[29] + 5.892556509887889 * sp[26] + 2.357022603955107 * sp[27] + 37.71236166328278 * sp[31] + 37.7123616632828 * sp[32] + 9.428090415820705 * sp[27] + -2.357022603955047 * sp[30];
    A[178] = 12.99038105676672 * sp[33] + -4.330127018922218 * sp[34] + -4.330127018922123 * sp[28] + -12.99038105676662 * sp[31] + -25.98076211353316 * sp[34] + 10.82531754730553 * sp[35] + 2.165063509460808 * sp[29] + 12.99038105676635 * sp[32] + 25.98076211353331 * sp[28] + 10.82531754730549 * sp[29] + 36.80607966083892 * sp[26] + 21.65063509461098 * sp[27] + 25.9807621135332 * sp[31] + 25.9807621135329 * sp[32] + -8.660254037844101 * sp[27] + 12.99038105676599 * sp[30];
    A[179] = -104.1666666666669 * sp[33] + -45.83333333333345 * sp[34] + -55.83333333333331 * sp[28] + -0.833333333333067 * sp[31] + -33.33333333333368 * sp[34] + -39.58333333333359 * sp[35] + 5.416666666666579 * sp[29] + -25.83333333333363 * sp[32] + 66.66666666666727 * sp[28] + 60.41666666666704 * sp[29] + 5.416666666666723 * sp[26] + -0.8333333333334867 * sp[27] + 66.66666666666708 * sp[31] + 66.66666666666708 * sp[32] + -3.333333333333284 * sp[27] + -104.1666666666668 * sp[30];
    A[180] = 5.892556509887893 * sp[33] + -3.299831645537247 * sp[34] + 0.4714045207910404 * sp[28] + 0.4714045207910685 * sp[31] + -1.649915822768612 * sp[34] + -2.474873734152921 * sp[35] + -2.003469213361917 * sp[29] + 0.4714045207910328 * sp[32] + 16.73486048808169 * sp[28] + 3.181980515339517 * sp[29] + -7.660323462854288 * sp[26] + -5.185449728701313 * sp[27] + 4.006938426723798 * sp[31] + 4.006938426723848 * sp[32] + -10.13519719700728 * sp[27] + -4.006938426723792 * sp[30];
    A[181] = -11.78511301977583 * sp[33] + 8.956685895029656 * sp[34] + -3.299831645537257 * sp[28] + -3.299831645537294 * sp[31] + -3.771236166328274 * sp[34] + 2.592724864350725 * sp[35] + 1.6499158227686 * sp[29] + -3.29983164553728 * sp[32] + -12.25651754056684 * sp[28] + 5.421151989096832 * sp[29] + -1.178511301977575 * sp[26] + -6.128258770283498 * sp[27] + -0.9428090415820516 * sp[31] + -0.94280904158212 * sp[32] + 3.771236166328311 * sp[27] + -3.771236166328309 * sp[30];
    A[182] = -5.892556509887917 * sp[33] + -17.44196726926827 * sp[34] + 5.185449728701398 * sp[28] + 5.185449728701393 * sp[31] + -4.006938426723782 * sp[34] + -10.72445284799603 * sp[35] + 3.889087296526027 * sp[29] + 5.185449728701382 * sp[32] + 0.2357022603955437 * sp[28] + -5.067598598503574 * sp[29] + -1.767766952966384 * sp[26] + -0.4714045207910114 * sp[27] + 1.649915822768636 * sp[31] + 1.649915822768657 * sp[32] + -3.064129385141752 * sp[27] + -1.649915822768603 * sp[30];
    A[183] = 5.892556509887943 * sp[33] + 9.19238815542516 * sp[34] + 5.421151989096883 * sp[28] + 9.192388155425126 * sp[31] + 7.542472332656526 * sp[34] + 8.367430244040808 * sp[35] + 5.067598598503627 * sp[29] + 5.892556509887905 * sp[32] + -10.84230397819378 * sp[28] + -4.360491817317088 * sp[29] + -18.9740319618391 * sp[26] + -6.835365551470035 * sp[27] + -5.185449728701402 * sp[31] + -5.185449728701423 * sp[32] + -5.185449728701383 * sp[27] + -4.006938426723817 * sp[30];
    A[184] = -11.78511301977585 * sp[33] + -20.7417989148055 * sp[34] + -8.485281374238548 * sp[28] + -20.74179891480543 * sp[31] + -8.013876853447567 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141709 * sp[29] + -9.428090415820687 * sp[32] + 0.4714045207910602 * sp[28] + -3.064129385141675 * sp[29] + 2.592724864350728 * sp[26] + 1.885618083164142 * sp[27] + 3.299831645537267 * sp[31] + 3.299831645537287 * sp[32] + 3.299831645537247 * sp[27] + 5.656854249492397 * sp[30];
    A[185] = -5.892556509887902 * sp[33] + 11.54941075938034 * sp[34] + -11.07800623858928 * sp[28] + 11.54941075938035 * sp[31] + -1.885618083164137 * sp[34] + 4.831896338108131 * sp[35] + -3.18198051533948 * sp[29] + 3.535533905932826 * sp[32] + -6.128258770283398 * sp[28] + 6.246109900481153 * sp[29] + -13.08147545195113 * sp[26] + 4.94974746830582 * sp[27] + -0.4714045207910202 * sp[31] + -0.4714045207910718 * sp[32] + -0.4714045207910007 * sp[27] + -1.649915822768632 * sp[30];
    A[186] = 2.357022603955131 * sp[33] + 4.006938426723726 * sp[34] + 4.006938426723814 * sp[28] + 4.006938426723792 * sp[31] + 0.2357022603954846 * sp[34] + -0.2357022603955086 * sp[35] + 4.478342947514788 * sp[29] + 4.006938426723767 * sp[32] + -11.07800623858928 * sp[28] + -12.9636243217534 * sp[29] + -8.249579113843065 * sp[26] + -8.720983634634095 * sp[27] + -7.778174593052078 * sp[31] + -8.720983634634081 * sp[32] + -7.778174593052094 * sp[27] + -7.542472332656549 * sp[30];
    A[187] = -0.9428090415820881 * sp[34] + -0.9428090415820765 * sp[28] + -0.9428090415820982 * sp[31] + 1.885618083164142 * sp[34] + 0.4714045207910273 * sp[35] + 0.4714045207910826 * sp[29] + -0.9428090415820514 * sp[32] + 24.5130350811337 * sp[28] + 11.78511301977578 * sp[29] + 11.78511301977581 * sp[26] + 10.37089945740266 * sp[27] + 13.19932658214898 * sp[31] + 5.656854249492404 * sp[32] + 13.199326582149 * sp[27] + 8.013876853447579 * sp[30];
    A[188] = -2.357022603955141 * sp[33] + 1.649915822768712 * sp[34] + 1.649915822768626 * sp[28] + 1.649915822768675 * sp[31] + -2.121320343559625 * sp[34] + 2.121320343559717 * sp[35] + -2.592724864350687 * sp[29] + 1.649915822768651 * sp[32] + -13.43502884254443 * sp[28] + 3.535533905932831 * sp[29] + -1.178511301977581 * sp[26] + 3.064129385141797 * sp[27] + -5.421151989096901 * sp[31] + 3.064129385141747 * sp[32] + -5.421151989096927 * sp[27] + 1.88561808316417 * sp[30];
    A[189] = -33.33333333333349 * sp[33] + -46.66666666666695 * sp[34] + -6.666666666666694 * sp[28] + -6.666666666666782 * sp[31] + -26.66666666666676 * sp[34] + -36.66666666666691 * sp[35] + 3.333333333333185 * sp[29] + -6.666666666666861 * sp[32] + 13.33333333333358 * sp[28] + 3.333333333333307 * sp[29] + -36.66666666666669 * sp[26] + -46.66666666666684 * sp[27] + 13.33333333333354 * sp[31] + 13.33333333333333 * sp[32] + -26.66666666666683 * sp[27] + -33.33333333333362 * sp[30];
    A[190] = 28.57738033247005 * sp[33] + 8.164965809276685 * sp[34] + 8.164965809277358 * sp[28] + 8.164965809277097 * sp[31] + -4.082482904639258 * sp[34] + -22.4536559755128 * sp[35] + 26.53613888015089 * sp[29] + 8.164965809276961 * sp[32] + 69.40220937885675 * sp[28] + -22.45365597551278 * sp[29] + -71.44345083117614 * sp[26] + -89.81462390205024 * sp[27] + -4.082482904638921 * sp[31] + -28.57738033247049 * sp[32] + -53.0722777603026 * sp[27] + -69.40220937885726 * sp[30];
    A[191] = -58.92556509887913 * sp[33] + -18.85618083164146 * sp[34] + 37.71236166328291 * sp[28] + 37.71236166328278 * sp[31] + -25.92724864350683 * sp[34] + -22.39171473757415 * sp[35] + 34.17682775735003 * sp[29] + 37.7123616632828 * sp[32] + -40.06938426723771 * sp[28] + 5.892556509887871 * sp[29] + 5.892556509887889 * sp[26] + 9.428090415820705 * sp[27] + 2.35702260395527 * sp[31] + -11.78511301977589 * sp[32] + 2.357022603955107 * sp[27] + -2.357022603955047 * sp[30];
    A[192] = 66.66666666666688 * sp[33] + 33.33333333333348 * sp[34] + 33.33333333333325 * sp[28] + -6.666666666666839 * sp[31] + 33.33333333333348 * sp[34] + 33.33333333333334 * sp[35] + -6.666666666666664 * sp[29] + -6.666666666666691 * sp[32] + 33.33333333333325 * sp[28] + -6.666666666666664 * sp[29] + 113.3333333333336 * sp[26] + 33.33333333333355 * sp[27] + -6.666666666666839 * sp[31] + -6.666666666666691 * sp[32] + 33.33333333333355 * sp[27] + 26.66666666666707 * sp[30];
    A[193] = 12.24744871391599 * sp[34] + 12.24744871391599 * sp[28] + 12.24744871391598 * sp[31] + 36.74234614174767 * sp[34] + 24.49489742783166 * sp[35] + 24.4948974278318 * sp[29] + 12.24744871391584 * sp[32] + -110.2270384252435 * sp[28] + -48.98979485566392 * sp[29] + -48.98979485566394 * sp[26] + 36.74234614174738 * sp[27] + -36.74234614174799 * sp[31] + -36.74234614174821 * sp[32] + 12.24744871391574 * sp[27] + 24.49489742783151 * sp[30];
    A[194] = 117.8511301977583 * sp[33] + 58.92556509887917 * sp[34] + 58.92556509887893 * sp[28] + 2.357022603954859 * sp[31] + 58.9255650988792 * sp[34] + 58.92556509887893 * sp[35] + 2.357022603955178 * sp[29] + 2.357022603954524 * sp[32] + 58.92556509887879 * sp[28] + -11.78511301977581 * sp[29] + 44.78342947514788 * sp[26] + -11.78511301977594 * sp[27] + -11.78511301977611 * sp[31] + -11.78511301977584 * sp[32] + -11.78511301977601 * sp[27] + -9.428090415820938 * sp[30];
    A[195] = -16.88749537379666 * sp[33] + -5.196152422706692 * sp[34] + 5.196152422706645 * sp[28] + 5.196152422706618 * sp[31] + -7.361215932167781 * sp[34] + -6.278684177437289 * sp[35] + 11.90784930203617 * sp[29] + 5.196152422706667 * sp[32] + -7.361215932167801 * sp[28] + 4.979646071760496 * sp[29] + -21.8671414455571 * sp[26] + -1.732050807568854 * sp[27] + 3.897114317029952 * sp[31] + 3.897114317029932 * sp[32] + -15.15544456622756 * sp[27] + -3.897114317029886 * sp[30];
    A[196] = 7.794228634059997 * sp[33] + -2.598076211353287 * sp[34] + 2.598076211353324 * sp[28] + 2.598076211353373 * sp[31] + 1.732050807568885 * sp[34] + -0.4330127018921264 * sp[35] + -2.165063509461184 * sp[29] + 2.598076211353395 * sp[32] + 1.732050807568896 * sp[28] + -5.629165124598781 * sp[29] + 13.42339375865884 * sp[26] + -0.8660254037845139 * sp[27] + -3.464101615137759 * sp[31] + -3.464101615137685 * sp[32] + 8.660254037844336 * sp[27] + -5.196152422706581 * sp[30];
    A[197] = -3.897114317030001 * sp[33] + -5.196152422706644 * sp[34] + 5.196152422706659 * sp[28] + 5.196152422706632 * sp[31] + -3.031088913245556 * sp[34] + -4.113620667976123 * sp[35] + 5.412658773652796 * sp[29] + 5.196152422706609 * sp[32] + -3.031088913245558 * sp[28] + -1.515544456622841 * sp[29] + -2.381569860407192 * sp[26] + -1.732050807568832 * sp[27] + -0.4330127018922296 * sp[31] + -0.433012701892269 * sp[32] + -2.165063509461067 * sp[27] + 0.4330127018921683 * sp[30];
    A[198] = 16.88749537379664 * sp[33] + 11.69134295108997 * sp[34] + 22.08364779650329 * sp[28] + 11.69134295108999 * sp[31] + 9.526279441628882 * sp[34] + 10.60881119635945 * sp[35] + 2.814582562299456 * sp[29] + 3.897114317030005 * sp[32] + 9.526279441628906 * sp[28] + -0.6495190528382926 * sp[29] + 36.58957330989259 * sp[26] + 19.4855715851499 * sp[27] + -1.732050807568834 * sp[31] + -1.732050807568841 * sp[32] + -1.732050807568859 * sp[27] + 0.4330127018922278 * sp[30];
    A[199] = -7.794228634059981 * sp[33] + -10.39230484541329 * sp[34] + -5.19615242270666 * sp[28] + -10.39230484541324 * sp[31] + -6.062177826491105 * sp[34] + -8.227241335952211 * sp[35] + -1.299038105676664 * sp[29] + -3.464101615137731 * sp[32] + -6.062177826491127 * sp[28] + -3.031088913245625 * sp[29] + -16.88749537379658 * sp[26] + -17.32050807568881 * sp[27] + -0.8660254037844766 * sp[31] + -0.8660254037844877 * sp[32] + -0.8660254037844569 * sp[27] + 3.464101615137753 * sp[30];
    A[200] = 3.897114317029978 * sp[33] + -1.299038105676645 * sp[34] + 9.093266739736643 * sp[28] + -1.299038105676638 * sp[31] + 0.8660254037844326 * sp[34] + -0.2165063509460512 * sp[35] + 0.6495190528383092 * sp[29] + -0.4330127018921792 * sp[32] + 0.8660254037844487 * sp[28] + -2.814582562299341 * sp[29] + 8.443747686898309 * sp[26] + -2.165063509461007 * sp[27] + -1.73205080756887 * sp[31] + -1.732050807568813 * sp[32] + -1.732050807568873 * sp[27] + -3.897114317029972 * sp[30];
    A[201] = 10.39230484541329 * sp[33] + 11.69134295108995 * sp[34] + 11.69134295108995 * sp[28] + 11.69134295108995 * sp[31] + 7.361215932167788 * sp[34] + 6.06217782649105 * sp[35] + 12.99038105676667 * sp[29] + 11.69134295108997 * sp[32] + 7.36121593216771 * sp[28] + 12.99038105676659 * sp[29] + -7.794228634059923 * sp[26] + -3.897114317029954 * sp[27] + -6.49519052838323 * sp[31] + -8.227241335952161 * sp[32] + -6.495190528383204 * sp[27] + -6.062177826491025 * sp[30];
    A[202] = -20.78460969082659 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541327 * sp[28] + -10.39230484541326 * sp[31] + -10.3923048454134 * sp[34] + -3.464101615137781 * sp[35] + -17.32050807568893 * sp[29] + -10.39230484541332 * sp[32] + -10.39230484541326 * sp[28] + -17.3205080756888 * sp[29] + 24.24871130596431 * sp[26] + 3.464101615137738 * sp[27] + 17.32050807568865 * sp[31] + 3.464101615137646 * sp[32] + 17.32050807568862 * sp[27] + 7.794228634059805 * sp[30];
    A[203] = 10.39230484541331 * sp[33] + -1.299038105676699 * sp[34] + -1.299038105676677 * sp[28] + -1.29903810567672 * sp[31] + 3.03108891324561 * sp[34] + -2.598076211353374 * sp[35] + 4.330127018922285 * sp[29] + -1.299038105676714 * sp[32] + 3.031088913245566 * sp[28] + 4.330127018922271 * sp[29] + -16.45448267190438 * sp[26] + 0.4330127018922756 * sp[27] + -10.82531754730541 * sp[31] + 4.763139720814371 * sp[32] + -10.82531754730542 * sp[27] + 2.598076211353326 * sp[30];
    A[204] = -36.74234614174796 * sp[33] + -36.74234614174772 * sp[34] + 36.74234614174773 * sp[28] + 36.74234614174783 * sp[31] + -24.49489742783199 * sp[34] + -30.61862178478959 * sp[35] + 42.86607049870582 * sp[29] + 36.7423461417481 * sp[32] + -24.49489742783203 * sp[28] + -6.12372435695822 * sp[29] + -30.61862178478965 * sp[26] + -12.24744871391606 * sp[27] + -24.49489742783147 * sp[27] + -36.74234614174713 * sp[30];
    A[205] = -67.50000000000048 * sp[33] + 90.00000000000024 * sp[28] + 90.00000000000037 * sp[31] + 7.500000000000032 * sp[34] + 3.750000000000035 * sp[35] + 93.75000000000045 * sp[29] + 90.00000000000071 * sp[32] + 7.499999999999023 * sp[28] + 48.74999999999953 * sp[29] + -41.24999999999975 * sp[26] + -30.00000000000016 * sp[27] + 52.50000000000023 * sp[31] + -22.49999999999963 * sp[32] + -37.49999999999945 * sp[27] + -67.49999999999929 * sp[30];
    A[206] = 12.99038105676672 * sp[33] + -25.98076211353316 * sp[34] + 25.98076211353331 * sp[28] + 25.9807621135332 * sp[31] + -4.330127018922218 * sp[34] + 10.82531754730553 * sp[35] + 10.82531754730549 * sp[29] + 25.9807621135329 * sp[32] + -4.330127018922123 * sp[28] + 2.165063509460808 * sp[29] + 36.80607966083892 * sp[26] + -8.660254037844101 * sp[27] + -12.99038105676662 * sp[31] + 12.99038105676635 * sp[32] + 21.65063509461098 * sp[27] + 12.99038105676599 * sp[30];
    A[207] = 36.74234614174767 * sp[34] + -110.2270384252435 * sp[28] + -36.74234614174799 * sp[31] + 12.24744871391599 * sp[34] + 24.49489742783166 * sp[35] + -48.98979485566392 * sp[29] + -36.74234614174821 * sp[32] + 12.24744871391599 * sp[28] + 24.4948974278318 * sp[29] + -48.98979485566394 * sp[26] + 12.24744871391574 * sp[27] + 12.24744871391598 * sp[31] + 12.24744871391584 * sp[32] + 36.74234614174738 * sp[27] + 24.49489742783151 * sp[30];
    A[208] = 135.0000000000008 * sp[33] + 67.50000000000044 * sp[34] + 67.50000000000048 * sp[28] + -22.49999999999977 * sp[31] + 67.50000000000044 * sp[34] + 67.50000000000067 * sp[35] + -22.49999999999999 * sp[29] + -22.49999999999982 * sp[32] + 67.50000000000048 * sp[28] + -22.49999999999999 * sp[29] + 247.4999999999999 * sp[26] + 67.49999999999997 * sp[27] + -22.49999999999977 * sp[31] + -22.49999999999982 * sp[32] + 67.49999999999997 * sp[27] + 59.99999999999972 * sp[30];
    A[209] = 64.95190528383287 * sp[34] + -38.97114317029992 * sp[28] + 12.99038105676648 * sp[31] + 21.65063509461117 * sp[34] + 43.30127018922171 * sp[35] + -8.660254037844199 * sp[29] + 12.99038105676669 * sp[32] + 21.65063509461108 * sp[28] + 43.30127018922193 * sp[29] + -8.660254037844645 * sp[26] + 99.59292143520975 * sp[27] + 21.65063509461113 * sp[31] + 21.65063509461085 * sp[32] + -12.99038105676647 * sp[27] + 43.30127018922258 * sp[30];
    A[210] = 10.41666666666666 * sp[33] + -5.83333333333338 * sp[34] + 0.8333333333333597 * sp[28] + 0.833333333333401 * sp[31] + -2.916666666666671 * sp[34] + -4.375000000000007 * sp[35] + -3.541666666666717 * sp[29] + 0.8333333333333373 * sp[32] + 10.08333333333334 * sp[28] + -2.875000000000028 * sp[29] + 7.958333333333405 * sp[26] + 1.833333333333368 * sp[27] + -1.416666666666686 * sp[31] + -1.416666666666758 * sp[32] + 3.583333333333325 * sp[27] + 2.916666666666643 * sp[30];
    A[211] = -20.83333333333339 * sp[33] + 15.83333333333343 * sp[34] + -5.833333333333398 * sp[28] + -5.833333333333455 * sp[31] + -6.666666666666699 * sp[34] + 4.583333333333418 * sp[35] + 2.916666666666646 * sp[29] + -5.83333333333343 * sp[32] + -12.66666666666667 * sp[28] + 11.58333333333335 * sp[29] + -10.0833333333334 * sp[26] + 2.166666666666629 * sp[27] + 0.3333333333333777 * sp[31] + 0.3333333333335253 * sp[32] + -1.333333333333345 * sp[27] + 13.33333333333326 * sp[30];
    A[212] = -10.4166666666667 * sp[33] + -30.83333333333348 * sp[34] + 9.166666666666753 * sp[28] + 9.166666666666742 * sp[31] + -7.08333333333335 * sp[34] + -18.95833333333342 * sp[35] + 6.875000000000025 * sp[29] + 9.166666666666719 * sp[32] + -4.083333333333326 * sp[28] + -12.45833333333336 * sp[29] + 3.375000000000038 * sp[26] + 0.1666666666666874 * sp[27] + -0.5833333333332997 * sp[31] + -0.5833333333333515 * sp[32] + 1.083333333333313 * sp[27] + -12.9166666666667 * sp[30];
    A[213] = 10.41666666666675 * sp[33] + 16.25000000000008 * sp[34] + 9.58333333333335 * sp[28] + 16.25 * sp[31] + 13.33333333333336 * sp[34] + 14.79166666666666 * sp[35] + 8.958333333333393 * sp[29] + 10.41666666666667 * sp[32] + 0.3333333333333379 * sp[28] + 3.291666666666697 * sp[29] + 7.458333333333292 * sp[26] + 9.416666666666636 * sp[27] + 1.833333333333298 * sp[31] + 1.833333333333316 * sp[32] + 1.833333333333306 * sp[27] + 2.916666666666619 * sp[30];
    A[214] = -20.83333333333343 * sp[33] + -36.66666666666684 * sp[34] + -14.99999999999995 * sp[28] + -36.66666666666672 * sp[31] + -14.16666666666671 * sp[34] + -25.41666666666674 * sp[35] + -5.416666666666665 * sp[29] + -16.66666666666675 * sp[32] + -8.166666666666673 * sp[28] + -12.4166666666667 * sp[29] + -12.41666666666661 * sp[26] + -24.66666666666664 * sp[27] + -1.166666666666608 * sp[31] + -1.166666666666637 * sp[32] + -1.166666666666613 * sp[27] + 10.00000000000008 * sp[30];
    A[215] = -10.41666666666667 * sp[33] + 20.41666666666679 * sp[34] + -19.58333333333339 * sp[28] + 20.41666666666678 * sp[31] + -3.333333333333347 * sp[34] + 8.541666666666762 * sp[35] + -5.625000000000021 * sp[29] + 6.250000000000149 * sp[32] + -6.333333333333318 * sp[28] + 12.04166666666669 * sp[29] + -12.12500000000002 * sp[26] + 15.25000000000001 * sp[27] + 0.1666666666666874 * sp[31] + 0.1666666666667926 * sp[32] + 0.1666666666667045 * sp[27] + -12.91666666666651 * sp[30];
    A[216] = 4.166666666666618 * sp[33] + 7.083333333333249 * sp[34] + 7.083333333333417 * sp[28] + 7.083333333333377 * sp[31] + 0.416666666666611 * sp[34] + -0.4166666666666554 * sp[35] + 7.916666666666643 * sp[29] + 7.083333333333326 * sp[32] + 8.416666666666657 * sp[28] + 13.58333333333326 * sp[29] + 1.916666666666718 * sp[26] + 3.08333333333335 * sp[27] + 2.749999999999959 * sp[31] + -8.916666666666863 * sp[32] + 2.749999999999956 * sp[27] + -3.333333333333447 * sp[30];
    A[217] = -1.666666666666707 * sp[34] + -1.666666666666704 * sp[28] + -1.666666666666734 * sp[31] + 3.333333333333353 * sp[34] + 0.8333333333333242 * sp[35] + 0.8333333333334174 * sp[29] + -1.666666666666648 * sp[32] + -12.6666666666667 * sp[28] + -7.166666666666669 * sp[29] + -7.166666666666758 * sp[26] + -3.6666666666667 * sp[27] + -4.666666666666648 * sp[31] + -7.999999999999925 * sp[32] + -4.666666666666632 * sp[27] + -5.833333333333231 * sp[30];
    A[218] = -4.166666666666638 * sp[33] + 2.916666666666839 * sp[34] + 2.9166666666667 * sp[28] + 2.916666666666778 * sp[31] + -3.749999999999963 * sp[34] + 3.750000000000124 * sp[35] + -4.583333333333351 * sp[29] + 2.916666666666734 * sp[32] + 4.250000000000034 * sp[28] + -2.249999999999933 * sp[29] + 9.416666666666737 * sp[26] + -1.083333333333296 * sp[27] + 1.916666666666705 * sp[31] + -13.08333333333321 * sp[32] + 1.916666666666674 * sp[27] + -6.66666666666662 * sp[30];
    A[219] = -58.92556509887923 * sp[33] + -82.495791138431 * sp[34] + -11.78511301977581 * sp[28] + -11.78511301977596 * sp[31] + -47.14045207910332 * sp[34] + -64.81812160876723 * sp[35] + 5.892556509887648 * sp[29] + -11.78511301977611 * sp[32] + -18.85618083164126 * sp[28] + -22.3917147375741 * sp[29] + -8.249579113842987 * sp[26] + 16.49915822768607 * sp[27] + -4.714045207910191 * sp[31] + 80.13876853447557 * sp[32] + 9.428090415820513 * sp[27] + 54.21151989096815 * sp[30];
    A[220] = 50.51814855409167 * sp[33] + 14.43375672973963 * sp[34] + 14.43375672974086 * sp[28] + 14.4337567297404 * sp[31] + -7.216878364871437 * sp[34] + -39.69283100678734 * sp[35] + 46.90970937165672 * sp[29] + 14.43375672974012 * sp[32] + 44.74464586219582 * sp[28] + 72.89047148518968 * sp[29] + -13.71206889325343 * sp[26] + 31.75426480542938 * sp[27] + 105.3664241271055 * sp[31] + 62.06515393788342 * sp[32] + 18.76388374866249 * sp[27] + 50.51814855409125 * sp[30];
    A[221] = -104.1666666666669 * sp[33] + -33.33333333333368 * sp[34] + 66.66666666666727 * sp[28] + 66.66666666666708 * sp[31] + -45.83333333333345 * sp[34] + -39.58333333333359 * sp[35] + 60.41666666666704 * sp[29] + 66.66666666666708 * sp[32] + -55.83333333333331 * sp[28] + 5.416666666666579 * sp[29] + 5.416666666666723 * sp[26] + -3.333333333333284 * sp[27] + -0.833333333333067 * sp[31] + -25.83333333333363 * sp[32] + -0.8333333333334867 * sp[27] + -104.1666666666668 * sp[30];
    A[222] = 117.8511301977583 * sp[33] + 58.9255650988792 * sp[34] + 58.92556509887879 * sp[28] + -11.78511301977611 * sp[31] + 58.92556509887917 * sp[34] + 58.92556509887893 * sp[35] + -11.78511301977581 * sp[29] + -11.78511301977584 * sp[32] + 58.92556509887893 * sp[28] + 2.357022603955178 * sp[29] + 44.78342947514788 * sp[26] + -11.78511301977601 * sp[27] + 2.357022603954859 * sp[31] + 2.357022603954524 * sp[32] + -11.78511301977594 * sp[27] + -9.428090415820938 * sp[30];
    A[223] = 21.65063509461117 * sp[34] + 21.65063509461108 * sp[28] + 21.65063509461113 * sp[31] + 64.95190528383287 * sp[34] + 43.30127018922171 * sp[35] + 43.30127018922193 * sp[29] + 21.65063509461085 * sp[32] + -38.97114317029992 * sp[28] + -8.660254037844199 * sp[29] + -8.660254037844645 * sp[26] + -12.99038105676647 * sp[27] + 12.99038105676648 * sp[31] + 12.99038105676669 * sp[32] + 99.59292143520975 * sp[27] + 43.30127018922258 * sp[30];
    A[224] = 208.333333333334 * sp[33] + 104.166666666667 * sp[34] + 104.1666666666666 * sp[28] + 4.166666666666181 * sp[31] + 104.166666666667 * sp[34] + 104.1666666666666 * sp[35] + 4.166666666666675 * sp[29] + 4.166666666665556 * sp[32] + 104.1666666666666 * sp[28] + 4.166666666666675 * sp[29] + 104.1666666666666 * sp[26] + 4.16666666666646 * sp[27] + 4.166666666666181 * sp[31] + 4.166666666665556 * sp[32] + 4.16666666666646 * sp[27] + 183.3333333333318 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    //   num_cells:         None
    //   optimize:          True
    //   precision:         16
    //   quadrature_degree: 6
    //   quadrature_rule:   'default'
    //   representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    //   estimated_polynomial_degree: 6
    //   optimize:                    True
    //   precision:                   16
    //   quadrature_degree:           6
    //   quadrature_rule:             'default'
    //   representation:              'uflacs'
    
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698435 * sp[19] + -0.01116071428571435 * sp[18] + -0.01116071428571435 * sp[18] + 0.0573412698412703 * sp[17];
    A[1] = -0.02986111111111124 * sp[19] + 0.005952380952380875 * sp[18] + 0.009920634920635002 * sp[18] + -0.04871031746031775 * sp[17];
    A[2] = 0.01765873015873009 * sp[19] + -0.004712301587301555 * sp[18] + -0.00471230158730162 * sp[18] + 0.01765873015873019 * sp[17];
    A[3] = -0.0154265873015874 * sp[19] + -0.02447916666666678 * sp[18] + 0.009052579365079375 * sp[18] + 0.01860119047619061 * sp[17];
    A[4] = 0.01746031746031736 * sp[19] + 0.02167658730158715 * sp[18] + -0.005704365079365063 * sp[18] + -0.01190476190476189 * sp[17];
    A[5] = -0.02385912698412699 * sp[19] + -0.03266369047619055 * sp[18] + 0.006820436507936543 * sp[18] + 0.01116071428571419 * sp[17];
    A[6] = -0.01314484126984126 * sp[19] + -0.008804563492063528 * sp[18] + 0.03067956349206365 * sp[18] + 0.02385912698412707 * sp[17];
    A[7] = 0.02777777777777799 * sp[19] + 0.01413690476190486 * sp[18] + -0.07276785714285772 * sp[18] + -0.06111111111111161 * sp[17];
    A[8] = -0.0205853174603176 * sp[19] + -0.007068452380952358 * sp[18] + 0.05820932539682571 * sp[18] + 0.05114087301587341 * sp[17];
    A[9] = 0.04349267900155114 * sp[19] + -0.02314932914598859 * sp[18] + -0.06243303921190627 * sp[18] + 0.03507474113028557 * sp[17];
    A[10] = 0.06529556615835232 * sp[19] + -0.05154913117764579 * sp[18] + -0.1271545235715237 * sp[18] + 0.06529556615835085 * sp[17];
    A[11] = -0.01686507936508141 * sp[19] + -0.007440476190475746 * sp[18] + 0.0719246031746027 * sp[18] + -0.01091269841269967 * sp[17];
    A[12] = 0.03507474113028578 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429711 * sp[18] + -0.1248660784238148 * sp[17];
    A[13] = -0.1005208057964095 * sp[19] + -0.06314768569261553 * sp[18] + 0.07088005536926224 * sp[18] + -0.08505606644311364 * sp[17];
    A[14] = 0.06200396825396945 * sp[19] + 0.09598214285714186 * sp[18] + -0.02108134920634952 * sp[18] + 0.05307539682539828 * sp[17];
    A[15] = -0.02986111111111124 * sp[19] + 0.009920634920635002 * sp[18] + 0.005952380952380875 * sp[18] + -0.04871031746031775 * sp[17];
    A[16] = 0.06865079365079402 * sp[19] + -0.01289682539682544 * sp[18] + -0.01289682539682544 * sp[18] + 0.06865079365079425 * sp[17];
    A[17] = -0.04871031746031759 * sp[19] + 0.005952380952380876 * sp[18] + 0.009920634920634986 * sp[18] + -0.02986111111111132 * sp[17];
    A[18] = 0.01746031746031737 * sp[19] + 0.02316468253968247 * sp[18] + -0.004216269841269739 * sp[18] + -0.01041666666666659 * sp[17];
    A[19] = -0.04384920634920634 * sp[19] + -0.05327380952380961 * sp[18] + 0.009424603174603165 * sp[18] + 0.01785714285714283 * sp[17];
    A[20] = 0.06111111111111137 * sp[19] + 0.07524801587301629 * sp[18] + -0.01165674603174608 * sp[18] + -0.02529761904761911 * sp[17];
    A[21] = 0.01041666666666664 * sp[19] + 0.004216269841269746 * sp[18] + -0.02316468253968254 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.017857142857143 * sp[19] + -0.00942460317460324 * sp[18] + 0.05327380952380978 * sp[18] + 0.04384920634920658 * sp[17];
    A[23] = 0.02529761904761933 * sp[19] + 0.01165674603174614 * sp[18] + -0.07524801587301648 * sp[18] + -0.06111111111111168 * sp[17];
    A[24] = -0.07856742013183728 * sp[19] + -0.009820927516479887 * sp[18] + 0.1360899955855054 * sp[18] + 0.07014948226057133 * sp[17];
    A[25] = -0.05326743555023516 * sp[19] + -0.0085915218629416 * sp[18] + 0.1838585678669348 * sp[18] + 0.08419691425682245 * sp[17];
    A[26] = -0.004960317460314796 * sp[19] + 0.01984126984126904 * sp[18] + -0.1626984126984119 * sp[18] + -0.1021825396825403 * sp[17];
    A[27] = -0.07014948226057145 * sp[19] + -0.1360899955855056 * sp[18] + 0.00982092751647989 * sp[18] + 0.07856742013183692 * sp[17];
    A[28] = 0.04639421805988031 * sp[19] + 0.04897167461876184 * sp[18] + -0.01288728279441029 * sp[18] + 0.03092947870658618 * sp[17];
    A[29] = -0.1240079365079387 * sp[19] + -0.2405753968253963 * sp[18] + 0.01736111111111123 * sp[18] + 0.04365079365079537 * sp[17];
    A[30] = 0.01765873015873009 * sp[19] + -0.00471230158730162 * sp[18] + -0.004712301587301555 * sp[18] + 0.01765873015873019 * sp[17];
    A[31] = -0.04871031746031759 * sp[19] + 0.009920634920634986 * sp[18] + 0.005952380952380876 * sp[18] + -0.02986111111111132 * sp[17];
    A[32] = 0.05734126984127018 * sp[19] + -0.01116071428571434 * sp[18] + -0.01116071428571434 * sp[18] + 0.02162698412698437 * sp[17];
    A[33] = -0.02385912698412704 * sp[19] + -0.03067956349206364 * sp[18] + 0.008804563492063534 * sp[18] + 0.01314484126984126 * sp[17];
    A[34] = 0.06111111111111149 * sp[19] + 0.07276785714285768 * sp[18] + -0.01413690476190485 * sp[18] + -0.02777777777777795 * sp[17];
    A[35] = -0.05114087301587322 * sp[19] + -0.05820932539682565 * sp[18] + 0.007068452380952352 * sp[18] + 0.02058531746031755 * sp[17];
    A[36] = -0.01860119047619066 * sp[19] + -0.009052579365079395 * sp[18] + 0.02447916666666682 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.01190476190476204 * sp[19] + 0.005704365079365122 * sp[18] + -0.02167658730158726 * sp[18] + -0.01746031746031749 * sp[17];
    A[38] = -0.0111607142857144 * sp[19] + -0.006820436507936584 * sp[18] + 0.03266369047619068 * sp[18] + 0.02385912698412713 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429709 * sp[18] + -0.1283735525368425 * sp[18] + -0.03507474113028568 * sp[17];
    A[40] = -0.003436608745177203 * sp[19] + -0.01718304372588143 * sp[18] + -0.05154913117764433 * sp[18] + -0.003436608745176603 * sp[17];
    A[41] = 0.1001984126984121 * sp[19] + -0.07192460317460356 * sp[18] + 0.1026785714285715 * sp[18] + 0.1180555555555573 * sp[17];
    A[42] = -0.03507474113028564 * sp[19] + 0.06243303921190657 * sp[18] + 0.02314932914598861 * sp[18] + -0.04349267900155106 * sp[17];
    A[43] = -0.02319710902993958 * sp[19] + 0.001288728279441132 * sp[18] + 0.0322182069860282 * sp[18] + -0.01804219591217503 * sp[17];
    A[44] = -0.06200396825396921 * sp[19] + 0.1460813492063478 * sp[18] + 0.04092261904761981 * sp[18] + -0.06498015873016071 * sp[17];
    A[45] = -0.0154265873015874 * sp[19] + 0.009052579365079375 * sp[18] + -0.02447916666666678 * sp[18] + 0.01860119047619061 * sp[17];
    A[46] = 0.01746031746031737 * sp[19] + -0.004216269841269739 * sp[18] + 0.02316468253968247 * sp[18] + -0.01041666666666659 * sp[17];
    A[47] = -0.02385912698412704 * sp[19] + 0.008804563492063534 * sp[18] + -0.03067956349206364 * sp[18] + 0.01314484126984126 * sp[17];
    A[48] = 0.02162698412698432 * sp[19] + 0.03278769841269866 * sp[18] + 0.03278769841269866 * sp[18] + 0.1012896825396832 * sp[17];
    A[49] = -0.02986111111111125 * sp[19] + -0.03581349206349217 * sp[18] + -0.0397817460317463 * sp[18] + -0.09444444444444483 * sp[17];
    A[50] = 0.01765873015873008 * sp[19] + 0.02237103174603165 * sp[18] + 0.02237103174603173 * sp[18] + 0.04474206349206337 * sp[17];
    A[51] = 0.02058531746031756 * sp[19] + 0.01351686507936519 * sp[18] + 0.07879464285714317 * sp[18] + 0.02058531746031756 * sp[17];
    A[52] = -0.02777777777777796 * sp[19] + -0.01364087301587308 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761924 * sp[17];
    A[53] = 0.01314484126984126 * sp[19] + 0.004340277777777696 * sp[18] + 0.04382440476190486 * sp[18] + 0.01116071428571426 * sp[17];
    A[54] = -0.0785674201318369 * sp[19] + 0.02665680325901711 * sp[18] + -0.1529258713280409 * sp[18] + 0.0420896893563428 * sp[17];
    A[55] = -0.03522523963805749 * sp[19] + 0.07947157723220398 * sp[18] + 0.02104922856420367 * sp[18] + 0.1159855451497028 * sp[17];
    A[56] = -0.04513888888888812 * sp[19] + 0.04340277777777803 * sp[18] + 0.005704365079364766 * sp[18] + 0.05208333333333283 * sp[17];
    A[57] = 0.03507474113028563 * sp[19] + -0.09329881140655687 * sp[18] + 0.04700015311458285 * sp[18] + -0.206239477846075 * sp[17];
    A[58] = 0.1005208057964093 * sp[19] + 0.03737312010379379 * sp[18] + 0.1714008611656714 * sp[18] + 0.1933092419161693 * sp[17];
    A[59] = 0.06200396825396917 * sp[19] + -0.03397817460317274 * sp[18] + 0.08308531746031883 * sp[18] + 0.0401785714285746 * sp[17];
    A[60] = 0.01746031746031736 * sp[19] + -0.005704365079365063 * sp[18] + 0.02167658730158715 * sp[18] + -0.01190476190476189 * sp[17];
    A[61] = -0.04384920634920634 * sp[19] + 0.009424603174603165 * sp[18] + -0.05327380952380961 * sp[18] + 0.01785714285714283 * sp[17];
    A[62] = 0.06111111111111149 * sp[19] + -0.01413690476190485 * sp[18] + 0.07276785714285768 * sp[18] + -0.02777777777777795 * sp[17];
    A[63] = -0.02986111111111125 * sp[19] + -0.0397817460317463 * sp[18] + -0.03581349206349217 * sp[18] + -0.09444444444444483 * sp[17];
    A[64] = 0.06865079365079416 * sp[19] + 0.08154761904761972 * sp[18] + 0.08154761904761972 * sp[18] + 0.1630952380952394 * sp[17];
    A[65] = -0.04871031746031759 * sp[19] + -0.05466269841269856 * sp[18] + -0.05863095238095267 * sp[18] + -0.09444444444444489 * sp[17];
    A[66] = -0.02529761904761933 * sp[19] + -0.0136408730158731 * sp[18] + -0.1005456349206357 * sp[18] + -0.02777777777777796 * sp[17];
    A[67] = 0.01785714285714301 * sp[19] + 0.008432539682539705 * sp[18] + 0.0711309523809526 * sp[18] + 0.0178571428571429 * sp[17];
    A[68] = -0.01041666666666667 * sp[19] + -0.006200396825396817 * sp[18] + -0.03358134920634917 * sp[18] + -0.01190476190476187 * sp[17];
    A[69] = 0.148716902392409 * sp[19] + 0.002805979290422788 * sp[18] + 0.2946278254943953 * sp[18];
    A[70] = -0.006873217490354664 * sp[19] + -0.047253370246175 * sp[18] + -0.1778445025628795 * sp[18] + -0.103098262355291 * sp[17];
    A[71] = 0.1289682539682538 * sp[19] + -0.09176587301587376 * sp[18] + -0.0163690476190468 * sp[18] + -0.1785714285714299 * sp[17];
    A[72] = -0.07014948226057141 * sp[19] + 0.06594051332493447 * sp[18] + -0.07997040977705135 * sp[18] + 0.1346870059402923 * sp[17];
    A[73] = -0.04639421805988019 * sp[19] + 0.002577456558881516 * sp[18] + -0.0592815008542904 * sp[18] + -0.04123930494211515 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.1165674603174582 * sp[18] + -0.1413690476190499 * sp[18] + 0.1428571428571432 * sp[17];
    A[75] = -0.02385912698412699 * sp[19] + 0.006820436507936543 * sp[18] + -0.03266369047619055 * sp[18] + 0.01116071428571419 * sp[17];
    A[76] = 0.06111111111111137 * sp[19] + -0.01165674603174608 * sp[18] + 0.07524801587301629 * sp[18] + -0.02529761904761911 * sp[17];
    A[77] = -0.05114087301587322 * sp[19] + 0.007068452380952352 * sp[18] + -0.05820932539682565 * sp[18] + 0.02058531746031755 * sp[17];
    A[78] = 0.01765873015873008 * sp[19] + 0.02237103174603173 * sp[18] + 0.02237103174603165 * sp[18] + 0.04474206349206337 * sp[17];
    A[79] = -0.04871031746031759 * sp[19] + -0.05863095238095267 * sp[18] + -0.05466269841269856 * sp[18] + -0.09444444444444489 * sp[17];
    A[80] = 0.05734126984127008 * sp[19] + 0.06850198412698448 * sp[18] + 0.06850198412698448 * sp[18] + 0.1012896825396832 * sp[17];
    A[81] = 0.01116071428571435 * sp[19] + 0.004340277777777708 * sp[18] + 0.04382440476190493 * sp[18] + 0.01314484126984124 * sp[17];
    A[82] = -0.011904761904762 * sp[19] + -0.006200396825396842 * sp[18] + -0.03358134920634907 * sp[18] + -0.01041666666666655 * sp[17];
    A[83] = 0.01860119047619066 * sp[19] + 0.009548611111111202 * sp[18] + 0.0430803571428574 * sp[18] + 0.01860119047619052 * sp[17];
    A[84] = -0.08979133729352941 * sp[19] + -0.01543288609732565 * sp[18] + -0.1950155606843834 * sp[18] + -0.04208968935634277 * sp[17];
    A[85] = -0.02663371777511715 * sp[19] + -0.01073940232867686 * sp[18] + -0.007302793583500541 * sp[18] + -0.01288728279441236 * sp[17];
    A[86] = -0.03819444444444252 * sp[19] + 0.03596230158730127 * sp[18] + 0.1054067460317485 * sp[18] + 0.1264880952380961 * sp[17];
    A[87] = -0.03507474113028564 * sp[19] + -0.09750778034219186 * sp[18] + -0.05822407027627427 * sp[18] + -0.1641497884897316 * sp[17];
    A[88] = 0.02319710902993945 * sp[19] + 0.02448583730938063 * sp[18] + 0.05541531601596756 * sp[18] + 0.07474624020758409 * sp[17];
    A[89] = -0.06200396825396917 * sp[19] + -0.2080853174603166 * sp[18] + -0.1029265873015891 * sp[18] + -0.3139880952380976 * sp[17];
    A[90] = -0.01314484126984126 * sp[19] + 0.03067956349206365 * sp[18] + -0.008804563492063528 * sp[18] + 0.02385912698412707 * sp[17];
    A[91] = 0.01041666666666664 * sp[19] + -0.02316468253968254 * sp[18] + 0.004216269841269746 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619066 * sp[19] + 0.02447916666666682 * sp[18] + -0.009052579365079395 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031756 * sp[19] + 0.07879464285714317 * sp[18] + 0.01351686507936519 * sp[18] + 0.02058531746031756 * sp[17];
    A[94] = -0.02529761904761933 * sp[19] + -0.1005456349206357 * sp[18] + -0.0136408730158731 * sp[18] + -0.02777777777777796 * sp[17];
    A[95] = 0.01116071428571435 * sp[19] + 0.04382440476190493 * sp[18] + 0.004340277777777708 * sp[18] + 0.01314484126984124 * sp[17];
    A[96] = 0.1012896825396833 * sp[19] + 0.03278769841269868 * sp[18] + 0.03278769841269868 * sp[18] + 0.02162698412698434 * sp[17];
    A[97] = -0.0944444444444448 * sp[19] + -0.03978174603174629 * sp[18] + -0.03581349206349217 * sp[18] + -0.02986111111111128 * sp[17];
    A[98] = 0.04474206349206346 * sp[19] + 0.02237103174603177 * sp[18] + 0.02237103174603172 * sp[18] + 0.01765873015873017 * sp[17];
    A[99] = -0.2062394778460755 * sp[19] + 0.04700015311458268 * sp[18] + -0.09329881140655705 * sp[18] + 0.0350747411302855 * sp[17];
    A[100] = 0.131450284502998 * sp[19] + 0.1576544261849666 * sp[18] + -0.01073940232867423 * sp[18] + 0.1039574145415857 * sp[17];
    A[101] = 0.1473214285714276 * sp[19] + 0.106894841269842 * sp[18] + 0.04935515873015902 * sp[18] + 0.05605158730158804 * sp[17];
    A[102] = 0.04208968935634283 * sp[19] + -0.152925871328041 * sp[18] + 0.02665680325901717 * sp[18] + -0.07856742013183682 * sp[17];
    A[103] = 0.1030982623552902 * sp[19] + 0.01546473935329262 * sp[18] + 0.07732369676646841 * sp[18] + -0.05670404429540916 * sp[17];
    A[104] = 0.07440476190476314 * sp[19] + 0.01537698412698315 * sp[18] + 0.04712301587301673 * sp[18] + -0.007936507936507933 * sp[17];
    A[105] = 0.02777777777777799 * sp[19] + -0.07276785714285772 * sp[18] + 0.01413690476190486 * sp[18] + -0.06111111111111161 * sp[17];
    A[106] = -0.017857142857143 * sp[19] + 0.05327380952380978 * sp[18] + -0.00942460317460324 * sp[18] + 0.04384920634920658 * sp[17];
    A[107] = 0.01190476190476204 * sp[19] + -0.02167658730158726 * sp[18] + 0.005704365079365122 * sp[18] + -0.01746031746031749 * sp[17];
    A[108] = -0.02777777777777796 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587308 * sp[18] + -0.02529761904761924 * sp[17];
    A[109] = 0.01785714285714301 * sp[19] + 0.0711309523809526 * sp[18] + 0.008432539682539705 * sp[18] + 0.0178571428571429 * sp[17];
    A[110] = -0.011904761904762 * sp[19] + -0.03358134920634907 * sp[18] + -0.006200396825396842 * sp[18] + -0.01041666666666655 * sp[17];
    A[111] = -0.0944444444444448 * sp[19] + -0.03581349206349217 * sp[18] + -0.03978174603174629 * sp[18] + -0.02986111111111128 * sp[17];
    A[112] = 0.1630952380952393 * sp[19] + 0.08154761904761967 * sp[18] + 0.08154761904761967 * sp[18] + 0.06865079365079423 * sp[17];
    A[113] = -0.09444444444444489 * sp[19] + -0.0586309523809528 * sp[18] + -0.05466269841269866 * sp[18] + -0.04871031746031779 * sp[17];
    A[114] = 0.1346870059402925 * sp[19] + -0.07997040977705097 * sp[18] + 0.0659405133249347 * sp[18] + -0.07014948226057102 * sp[17];
    A[115] = 0.1030982623552917 * sp[19] + -0.1520699369740541 * sp[18] + 0.1022391101689948 * sp[18] + -0.1305911323167022 * sp[17];
    A[116] = -0.1071428571428563 * sp[19] + 0.01934523809524032 * sp[18] + -0.0560515873015872 * sp[18] + 0.02182539682539814 * sp[17];
    A[117] = 0.2946278254943949 * sp[18] + 0.002805979290422863 * sp[18] + 0.1487169023924086 * sp[17];
    A[118] = -0.2061965247105818 * sp[19] + -0.1030982623552906 * sp[18] + -0.1030982623552908 * sp[18] + 0.1082531754730541 * sp[17];
    A[119] = -0.1458333333333371 * sp[18] + 0.004960317460317543 * sp[18] + -0.07043650793651005 * sp[17];
    A[120] = -0.0205853174603176 * sp[19] + 0.05820932539682571 * sp[18] + -0.007068452380952358 * sp[18] + 0.05114087301587341 * sp[17];
    A[121] = 0.02529761904761933 * sp[19] + -0.07524801587301648 * sp[18] + 0.01165674603174614 * sp[18] + -0.06111111111111168 * sp[17];
    A[122] = -0.0111607142857144 * sp[19] + 0.03266369047619068 * sp[18] + -0.006820436507936584 * sp[18] + 0.02385912698412713 * sp[17];
    A[123] = 0.01314484126984126 * sp[19] + 0.04382440476190486 * sp[18] + 0.004340277777777696 * sp[18] + 0.01116071428571426 * sp[17];
    A[124] = -0.01041666666666667 * sp[19] + -0.03358134920634917 * sp[18] + -0.006200396825396817 * sp[18] + -0.01190476190476187 * sp[17];
    A[125] = 0.01860119047619066 * sp[19] + 0.0430803571428574 * sp[18] + 0.009548611111111202 * sp[18] + 0.01860119047619052 * sp[17];
    A[126] = 0.04474206349206346 * sp[19] + 0.02237103174603172 * sp[18] + 0.02237103174603177 * sp[18] + 0.01765873015873017 * sp[17];
    A[127] = -0.09444444444444489 * sp[19] + -0.05466269841269866 * sp[18] + -0.0586309523809528 * sp[18] + -0.04871031746031779 * sp[17];
    A[128] = 0.1012896825396833 * sp[19] + 0.0685019841269847 * sp[18] + 0.0685019841269847 * sp[18] + 0.0573412698412704 * sp[17];
    A[129] = -0.1641497884897321 * sp[19] + -0.05822407027627445 * sp[18] + -0.0975077803421921 * sp[18] + -0.0350747411302858 * sp[17];
    A[130] = -0.2345485468582884 * sp[19] + -0.06142938132002937 * sp[18] + -0.1679642524204942 * sp[18] + -0.04209845712841176 * sp[17];
    A[131] = 0.2217261904761909 * sp[19] + 0.09945436507936549 * sp[18] + 0.1252480158730156 * sp[18] + 0.05109126984126969 * sp[17];
    A[132] = -0.04208968935634282 * sp[19] + -0.1950155606843832 * sp[18] + -0.01543288609732568 * sp[18] + -0.08979133729352924 * sp[17];
    A[133] = 0.1030982623552903 * sp[19] + 0.08763352300199788 * sp[18] + 0.02577456558882181 * sp[18] + -0.04639421805987987 * sp[17];
    A[134] = -0.07440476190476315 * sp[19] + -0.05902777777777945 * sp[18] + -0.02728174603174644 * sp[18] + -0.003968253968254307 * sp[17];
    A[135] = 0.04349267900155114 * sp[19] + -0.06243303921190627 * sp[18] + -0.02314932914598859 * sp[18] + 0.03507474113028557 * sp[17];
    A[136] = -0.07856742013183728 * sp[19] + 0.1360899955855054 * sp[18] + -0.009820927516479887 * sp[18] + 0.07014948226057133 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368425 * sp[18] + 0.01192541198429709 * sp[18] + -0.03507474113028568 * sp[17];
    A[138] = -0.0785674201318369 * sp[19] + -0.1529258713280409 * sp[18] + 0.02665680325901711 * sp[18] + 0.0420896893563428 * sp[17];
    A[139] = 0.148716902392409 * sp[19] + 0.2946278254943953 * sp[18] + 0.002805979290422788 * sp[18];
    A[140] = -0.08979133729352941 * sp[19] + -0.1950155606843834 * sp[18] + -0.01543288609732565 * sp[18] + -0.04208968935634277 * sp[17];
    A[141] = -0.2062394778460755 * sp[19] + -0.09329881140655705 * sp[18] + 0.04700015311458268 * sp[18] + 0.0350747411302855 * sp[17];
    A[142] = 0.1346870059402925 * sp[19] + 0.0659405133249347 * sp[18] + -0.07997040977705097 * sp[18] + -0.07014948226057102 * sp[17];
    A[143] = -0.1641497884897321 * sp[19] + -0.0975077803421921 * sp[18] + -0.05822407027627445 * sp[18] + -0.0350747411302858 * sp[17];
    A[144] = 4.920634920634906 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 0.3968253968254025 * sp[17];
    A[145] = 0.0243004934799691 * sp[19] + -0.06075123369997169 * sp[18] + 0.2308546880599298 * sp[18] + 0.607512336999805 * sp[17];
    A[146] = -0.519106168728203 * sp[19] + -0.8067190459965525 * sp[18] + -0.3016427737204508 * sp[18] + -0.3507474113028567 * sp[17];
    A[147] = -0.1984126984127016 * sp[19] + 4.305555555555532 * sp[18] + 0.01984126984126998 * sp[18] + -0.1984126984127008 * sp[17];
    A[148] = -0.2187044413199086 * sp[19] + -0.03645074021998757 * sp[18] + 0.2551551815399186 * sp[18] + -0.2187044413199259 * sp[17];
    A[149] = -0.3507474113028559 * sp[19] + 0.5401510134063873 * sp[18] + 0.0350747411302854 * sp[18] + 0.3226876183986337 * sp[17];
    A[150] = 0.06529556615835232 * sp[19] + -0.1271545235715237 * sp[18] + -0.05154913117764579 * sp[18] + 0.06529556615835085 * sp[17];
    A[151] = -0.05326743555023516 * sp[19] + 0.1838585678669348 * sp[18] + -0.0085915218629416 * sp[18] + 0.08419691425682245 * sp[17];
    A[152] = -0.003436608745177203 * sp[19] + -0.05154913117764433 * sp[18] + -0.01718304372588143 * sp[18] + -0.003436608745176603 * sp[17];
    A[153] = -0.03522523963805749 * sp[19] + 0.02104922856420367 * sp[18] + 0.07947157723220398 * sp[18] + 0.1159855451497028 * sp[17];
    A[154] = -0.006873217490354664 * sp[19] + -0.1778445025628795 * sp[18] + -0.047253370246175 * sp[18] + -0.103098262355291 * sp[17];
    A[155] = -0.02663371777511715 * sp[19] + -0.007302793583500541 * sp[18] + -0.01073940232867686 * sp[18] + -0.01288728279441236 * sp[17];
    A[156] = 0.131450284502998 * sp[19] + -0.01073940232867423 * sp[18] + 0.1576544261849666 * sp[18] + 0.1039574145415857 * sp[17];
    A[157] = 0.1030982623552917 * sp[19] + 0.1022391101689948 * sp[18] + -0.1520699369740541 * sp[18] + -0.1305911323167022 * sp[17];
    A[158] = -0.2345485468582884 * sp[19] + -0.1679642524204942 * sp[18] + -0.06142938132002937 * sp[18] + -0.04209845712841176 * sp[17];
    A[159] = 0.0243004934799691 * sp[19] + 0.2308546880599298 * sp[18] + -0.06075123369997169 * sp[18] + 0.607512336999805 * sp[17];
    A[160] = 5.416666666666708 * sp[19] + 0.4315476190476331 * sp[18] + 0.4315476190476331 * sp[18] + 1.130952380952398 * sp[17];
    A[161] = -0.1890134809847096 * sp[19] + -0.06873217490352254 * sp[18] + -0.2749286996141045 * sp[18] + -0.1890134809847019 * sp[17];
    A[162] = 0.1701034543599528 * sp[19] + 0.4495591293798421 * sp[18] + 0.1579532076199495 * sp[18] + -0.413108389159858 * sp[17];
    A[163] = -0.4017857142857217 * sp[19] + 3.593749999999993 * sp[18] + 0.558035714285723 * sp[18] + -0.4017857142857142 * sp[17];
    A[164] = 0.3007032652029488 * sp[19] + 0.1761261981902897 * sp[18] + 0.2792244605455824 * sp[18] + 0.3007032652029426 * sp[17];
    A[165] = -0.01686507936508141 * sp[19] + 0.0719246031746027 * sp[18] + -0.007440476190475746 * sp[18] + -0.01091269841269967 * sp[17];
    A[166] = -0.004960317460314796 * sp[19] + -0.1626984126984119 * sp[18] + 0.01984126984126904 * sp[18] + -0.1021825396825403 * sp[17];
    A[167] = 0.1001984126984121 * sp[19] + 0.1026785714285715 * sp[18] + -0.07192460317460356 * sp[18] + 0.1180555555555573 * sp[17];
    A[168] = -0.04513888888888812 * sp[19] + 0.005704365079364766 * sp[18] + 0.04340277777777803 * sp[18] + 0.05208333333333283 * sp[17];
    A[169] = 0.1289682539682538 * sp[19] + -0.0163690476190468 * sp[18] + -0.09176587301587376 * sp[18] + -0.1785714285714299 * sp[17];
    A[170] = -0.03819444444444252 * sp[19] + 0.1054067460317485 * sp[18] + 0.03596230158730127 * sp[18] + 0.1264880952380961 * sp[17];
    A[171] = 0.1473214285714276 * sp[19] + 0.04935515873015902 * sp[18] + 0.106894841269842 * sp[18] + 0.05605158730158804 * sp[17];
    A[172] = -0.1071428571428563 * sp[19] + -0.0560515873015872 * sp[18] + 0.01934523809524032 * sp[18] + 0.02182539682539814 * sp[17];
    A[173] = 0.2217261904761909 * sp[19] + 0.1252480158730156 * sp[18] + 0.09945436507936549 * sp[18] + 0.05109126984126969 * sp[17];
    A[174] = -0.519106168728203 * sp[19] + -0.3016427737204508 * sp[18] + -0.8067190459965525 * sp[18] + -0.3507474113028567 * sp[17];
    A[175] = -0.1890134809847096 * sp[19] + -0.2749286996141045 * sp[18] + -0.06873217490352254 * sp[18] + -0.1890134809847019 * sp[17];
    A[176] = 5.55555555555557 * sp[19] + 0.5902777777777783 * sp[18] + 0.5902777777777783 * sp[18] + 0.9126984126984293 * sp[17];
    A[177] = -0.3507474113028569 * sp[19] + -0.3016427737204449 * sp[18] + 0.2034334985556576 * sp[18] + -0.01402989645209509 * sp[17];
    A[178] = 0.07732369676647471 * sp[19] + 0.1675346763273471 * sp[18] + 0.06443641397205549 * sp[18] + 0.07732369676647141 * sp[17];
    A[179] = -0.6200396825396935 * sp[19] + 3.395337301587296 * sp[18] + 0.3596230158730228 * sp[18] + -0.620039682539702 * sp[17];
    A[180] = 0.03507474113028578 * sp[19] + -0.01192541198429711 * sp[18] + 0.1283735525368425 * sp[18] + -0.1248660784238148 * sp[17];
    A[181] = -0.07014948226057145 * sp[19] + 0.00982092751647989 * sp[18] + -0.1360899955855056 * sp[18] + 0.07856742013183692 * sp[17];
    A[182] = -0.03507474113028564 * sp[19] + 0.02314932914598861 * sp[18] + 0.06243303921190657 * sp[18] + -0.04349267900155106 * sp[17];
    A[183] = 0.03507474113028563 * sp[19] + 0.04700015311458285 * sp[18] + -0.09329881140655687 * sp[18] + -0.206239477846075 * sp[17];
    A[184] = -0.07014948226057141 * sp[19] + -0.07997040977705135 * sp[18] + 0.06594051332493447 * sp[18] + 0.1346870059402923 * sp[17];
    A[185] = -0.03507474113028564 * sp[19] + -0.05822407027627427 * sp[18] + -0.09750778034219186 * sp[18] + -0.1641497884897316 * sp[17];
    A[186] = 0.04208968935634283 * sp[19] + 0.02665680325901717 * sp[18] + -0.152925871328041 * sp[18] + -0.07856742013183682 * sp[17];
    A[187] = 0.002805979290422863 * sp[18] + 0.2946278254943949 * sp[18] + 0.1487169023924086 * sp[17];
    A[188] = -0.04208968935634282 * sp[19] + -0.01543288609732568 * sp[18] + -0.1950155606843832 * sp[18] + -0.08979133729352924 * sp[17];
    A[189] = -0.1984126984127016 * sp[19] + 0.01984126984126998 * sp[18] + 4.305555555555532 * sp[18] + -0.1984126984127008 * sp[17];
    A[190] = 0.1701034543599528 * sp[19] + 0.1579532076199495 * sp[18] + 0.4495591293798421 * sp[18] + -0.413108389159858 * sp[17];
    A[191] = -0.3507474113028569 * sp[19] + 0.2034334985556576 * sp[18] + -0.3016427737204449 * sp[18] + -0.01402989645209509 * sp[17];
    A[192] = 0.3968253968254036 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 4.920634920634909 * sp[17];
    A[193] = -0.1458029608799463 * sp[18] + -0.7290148043997469 * sp[18] + -0.4374088826398519 * sp[17];
    A[194] = 0.7014948226057137 * sp[19] + 0.3507474113028569 * sp[18] + 0.3507474113028572 * sp[18] + 0.2805979290422581 * sp[17];
    A[195] = -0.1005208057964095 * sp[19] + 0.07088005536926224 * sp[18] + -0.06314768569261553 * sp[18] + -0.08505606644311364 * sp[17];
    A[196] = 0.04639421805988031 * sp[19] + -0.01288728279441029 * sp[18] + 0.04897167461876184 * sp[18] + 0.03092947870658618 * sp[17];
    A[197] = -0.02319710902993958 * sp[19] + 0.0322182069860282 * sp[18] + 0.001288728279441132 * sp[18] + -0.01804219591217503 * sp[17];
    A[198] = 0.1005208057964093 * sp[19] + 0.1714008611656714 * sp[18] + 0.03737312010379379 * sp[18] + 0.1933092419161693 * sp[17];
    A[199] = -0.04639421805988019 * sp[19] + -0.0592815008542904 * sp[18] + 0.002577456558881516 * sp[18] + -0.04123930494211515 * sp[17];
    A[200] = 0.02319710902993945 * sp[19] + 0.05541531601596756 * sp[18] + 0.02448583730938063 * sp[18] + 0.07474624020758409 * sp[17];
    A[201] = 0.1030982623552902 * sp[19] + 0.07732369676646841 * sp[18] + 0.01546473935329262 * sp[18] + -0.05670404429540916 * sp[17];
    A[202] = -0.2061965247105818 * sp[19] + -0.1030982623552908 * sp[18] + -0.1030982623552906 * sp[18] + 0.1082531754730541 * sp[17];
    A[203] = 0.1030982623552903 * sp[19] + 0.02577456558882181 * sp[18] + 0.08763352300199788 * sp[18] + -0.04639421805987987 * sp[17];
    A[204] = -0.2187044413199086 * sp[19] + 0.2551551815399186 * sp[18] + -0.03645074021998757 * sp[18] + -0.2187044413199259 * sp[17];
    A[205] = -0.4017857142857217 * sp[19] + 0.558035714285723 * sp[18] + 3.593749999999993 * sp[18] + -0.4017857142857142 * sp[17];
    A[206] = 0.07732369676647471 * sp[19] + 0.06443641397205549 * sp[18] + 0.1675346763273471 * sp[18] + 0.07732369676647141 * sp[17];
    A[207] = -0.7290148043997469 * sp[18] + -0.1458029608799463 * sp[18] + -0.4374088826398519 * sp[17];
    A[208] = 0.8035714285714425 * sp[19] + 0.4017857142857212 * sp[18] + 0.4017857142857212 * sp[18] + 5.357142857142863 * sp[17];
    A[209] = -0.05154913117763665 * sp[18] + -0.2577456558882165 * sp[18] + -0.1546473935329269 * sp[17];
    A[210] = 0.06200396825396945 * sp[19] + -0.02108134920634952 * sp[18] + 0.09598214285714186 * sp[18] + 0.05307539682539828 * sp[17];
    A[211] = -0.1240079365079387 * sp[19] + 0.01736111111111123 * sp[18] + -0.2405753968253963 * sp[18] + 0.04365079365079537 * sp[17];
    A[212] = -0.06200396825396921 * sp[19] + 0.04092261904761981 * sp[18] + 0.1460813492063478 * sp[18] + -0.06498015873016071 * sp[17];
    A[213] = 0.06200396825396917 * sp[19] + 0.08308531746031883 * sp[18] + -0.03397817460317274 * sp[18] + 0.0401785714285746 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.1413690476190499 * sp[18] + 0.1165674603174582 * sp[18] + 0.1428571428571432 * sp[17];
    A[215] = -0.06200396825396917 * sp[19] + -0.1029265873015891 * sp[18] + -0.2080853174603166 * sp[18] + -0.3139880952380976 * sp[17];
    A[216] = 0.07440476190476314 * sp[19] + 0.04712301587301673 * sp[18] + 0.01537698412698315 * sp[18] + -0.007936507936507933 * sp[17];
    A[217] = 0.004960317460317543 * sp[18] + -0.1458333333333371 * sp[18] + -0.07043650793651005 * sp[17];
    A[218] = -0.07440476190476315 * sp[19] + -0.02728174603174644 * sp[18] + -0.05902777777777945 * sp[18] + -0.003968253968254307 * sp[17];
    A[219] = -0.3507474113028559 * sp[19] + 0.0350747411302854 * sp[18] + 0.5401510134063873 * sp[18] + 0.3226876183986337 * sp[17];
    A[220] = 0.3007032652029488 * sp[19] + 0.2792244605455824 * sp[18] + 0.1761261981902897 * sp[18] + 0.3007032652029426 * sp[17];
    A[221] = -0.6200396825396935 * sp[19] + 0.3596230158730228 * sp[18] + 3.395337301587296 * sp[18] + -0.620039682539702 * sp[17];
    A[222] = 0.7014948226057137 * sp[19] + 0.3507474113028572 * sp[18] + 0.3507474113028569 * sp[18] + 0.2805979290422581 * sp[17];
    A[223] = -0.2577456558882165 * sp[18] + -0.05154913117763665 * sp[18] + -0.1546473935329269 * sp[17];
    A[224] = 1.240079365079386 * sp[19] + 0.6200396825396923 * sp[18] + 0.6200396825396923 * sp[18] + 5.615079365079414 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "5ef7c449a95d7b424e9547ea1c3d1f06f62528b17ae4ce1a269846967409026af4c96e4c25d91f5b45e7fa670566e64f97f09f8d53deac0d681e42447247ea67";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    static const std::vector<std::size_t> position({});
    return position[i];
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return nullptr;
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_2();
        break;
      }
    case 1:
      {
        return new forms_finite_element_2();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_2();
        break;
      }
    case 1:
      {
        return new forms_dofmap_2();
        break;
      }
    }
    
    return 0;
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return 0;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return 0;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return 0;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "108dafa0472311164e3d035eb30e30f4cf3ca036a1737d9e5ebc3b6566301b7e8745210ebbd68d48e8bf6b07ac5d7b23237e4d0bc8f94b17f4dc7d592b22029c";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    static const std::vector<std::size_t> position({});
    return position[i];
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return nullptr;
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_finite_element_2();
        break;
      }
    case 1:
      {
        return new forms_finite_element_2();
        break;
      }
    }
    
    return 0;
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
      {
        return new forms_dofmap_2();
        break;
      }
    case 1:
      {
        return new forms_dofmap_2();
        break;
      }
    }
    
    return 0;
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return 0;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return 0;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return 0;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return 0;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return 0;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return 0;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return 0;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return 0;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
